
=============================================================================
Version 1.2.9 BETA
=============================================================================


2005-03-15 21:12  niall

	* Appender/FileAppender.cs:

	Implemented nestable locking and delegated impersonation to the locking model.
	
2005-03-14 02:44  nicko

	* Layout/: ILayout.cs, LayoutSkeleton.cs:

	Removed obsolete Format method from ILayout and LayoutSkeleton. It was 
	already a breaking change, best to remove the old method before the next 
	release, i.e. so we don't have to break it again.
	
2005-03-14 02:08  nicko

	* Appender/EventLogAppender.cs:

	Mono now supports the EventLog API. The implementation is a NOP
	
2005-03-11 22:57  nicko

	* Appender/FileAppender.cs:

	Updated doc comments
	
2005-03-11 22:30  nicko

	* Appender/FileAppender.cs:

	Updated comments, fixed couple of typos
	
2005-03-11 18:38  niall

	* Appender/FileAppender.cs:

	Added documentation for the locking models in FileAppender.
	
	* Appender/FileAppender.cs:

	Implemented locking models so that FileAppender and it's subclasses can 
	change their file access semantics.
	
2005-03-07 01:34  nicko

	* Appender/FileAppender.cs:

	Added virtual SetQWForFiles(Stream) method to make it simpler for subclasses 
	to wrap the output file stream, for example to add support for encryption
	
2005-03-04 21:11  nicko

	* DateFormatter/AbsoluteTimeDateFormatter.cs:

	Added Thread.MemoryBarrier call on NET_1_1 after writing to local variable, 
	this is only required on SMP machines with a weak memory model 
	(e.g. Itanium)
	
2005-02-27 22:57  nicko

	* AssemblyVersionInfo.cpp, AssemblyVersionInfo.cs,
	AssemblyVersionInfo.js, AssemblyVersionInfo.vb:

	Updated version numbers to 1.2.9.0
	
2005-02-15 18:56  nicko

	* Util/TypeConverters/IPAddressConverter.cs:

	Only attempt to IPAddress.Parse if the string contains valid IP address 
	characters

2005-02-14 19:45  nicko

	* Appender/AppenderSkeleton.cs:

	Added anonymous catch handler

2005-02-14 10:41  nicko

	* NDC.cs:

	Fixed Stack reference on NETCF

	* Config/XmlConfigurator.cs:

	Added DefaultCredential authentication support to loading config from web 
	request

2005-02-14 03:45  nicko

	* LogicalThreadContext.cs, MDC.cs, ThreadContext.cs:

	Updated doc comments

	* NDC.cs, Util/ThreadContextStack.cs:

	Added support for all old methods in NDC - Depth, SetMaxDepth, CloneStack, 
	Inherit

2005-02-14 03:24  nicko

	* LogicalThreadContext.cs, ThreadContext.cs, log4net.csproj,
	  Util/ThreadContextList.cs, Util/ThreadContextLists.cs:

	Removed Context Lists. The Context Stacks give essentially the same 
	functionality

	* AssemblyInfo.cs:

	Renamed CORE build to CLI_1_0

	* Config/XmlConfiguratorAttribute.cs:

	Added support for locating the config file when the app is deployed from a 
	web server, i.e. via no-touch deployment

	* Config/XmlConfigurator.cs:

	Added support for loading the configuration data via a URI

	* Appender/FileAppender.cs, Appender/SmtpPickupDirAppender.cs,
	  Util/SystemInfo.cs:

	Moved ConvertToFullPath method to SystemInfo

	* Appender/ColoredConsoleAppender.cs, Appender/EventLogAppender.cs,
	  Appender/NetSendAppender.cs,
	  Appender/OutputDebugStringAppender.cs, Util/NativeError.cs,
	  Util/WindowsSecurityContext.cs:

	Renamed CORE build to CLI_1_0

2005-02-07 23:27  nicko

	* Util/SystemInfo.cs:

	Fixed TryParse on NETCF

	* Layout/XmlLayoutSchemaLog4j.cs:

	Updated link to log4j site

2005-02-07 22:41  nicko

	* DateFormatter/AbsoluteTimeDateFormatter.cs,
	  DateFormatter/DateTimeDateFormatter.cs,
	  DateFormatter/Iso8601DateFormatter.cs,
	  Layout/Pattern/DatePatternConverter.cs,
	  Util/PatternStringConverters/DatePatternConverter.cs:

	Updated date patterns in doc comments to use .NET DateTime.ToString 
	formatting patterns rather than Java syntax

	* Appender/EventLogAppender.cs, Appender/RollingFileAppender.cs,
	  Layout/Pattern/NamedPatternConverter.cs, Util/OptionConverter.cs,
	  Util/SystemInfo.cs,
	  Util/PatternStringConverters/RandomStringPatternConverter.cs:

	Added SystemInfo.TryParse methods for parsing strings to integers. These 
	methods give a performance boost when the string cannot be parsed.

2005-02-07 04:05  nicko

	* Util/: PropertiesDictionary.cs, ProtectCloseTextWriter.cs,
	  QuietTextWriter.cs, ReadOnlyPropertiesDictionary.cs,
	  ReaderWriterLock.cs, ReusableStringWriter.cs, SystemInfo.cs,
	  TextWriterAdapter.cs, ThreadContextList.cs,
	  ThreadContextLists.cs, ThreadContextProperties.cs,
	  ThreadContextStack.cs, ThreadContextStacks.cs, Transform.cs,
	  WindowsSecurityContext.cs:

	Tidied up doc comments

	* Util/TypeConverters/: BooleanConverter.cs, EncodingConverter.cs,
	  IPAddressConverter.cs, PatternLayoutConverter.cs,
	  PatternStringConverter.cs, TypeConverter.cs:

	Made type converter implementations internal

2005-02-04 03:06  nicko

	* log4net.csproj:

	Added IPAddressConverter

	* Util/TypeConverters/: ConverterRegistry.cs,
	  IPAddressConverter.cs:

	Added IPAddressConverter that converts string IP addresses or DNS Hostnames 
	into IPAddress objects

	* Util/OptionConverter.cs:

	Updated ConvertStringTo to check for a registered converter before looking 
	for static Parse method

	* Util/TypeConverters/ConversionNotSupportedException.cs:

	Added support for passing nested exception to Create

	* Appender/RollingFileAppender.cs:

	Fixed issue where ExistingInit could open the output file if the current 
	file is from previous date period. This could lead to double open. Fixed 
	CountDirection when value is 0. Previously value had to be > or < 0 but 
	not 0. Now must either be positive or negative, 0 is positive.

	* Appender/FileAppender.cs:

	Fixed incorrect internal log message

2005-02-01 20:20  nicko

	* Appender/ColoredConsoleAppender.cs:

	Fixed background color overspill when changing background colors and the 
	console buffer is scrolled - see comment in code

2005-01-31 22:56  nicko

	* Util/: AppenderAttachedImpl.cs, CompositeProperties.cs,
	  ContextPropertiesBase.cs, CountingQuietTextWriter.cs,
	  CyclicBuffer.cs, EmptyCollection.cs, EmptyDictionary.cs,
	  FormattingInfo.cs, GlobalContextProperties.cs, LevelMapping.cs,
	  LevelMappingEntry.cs, LogLog.cs,
	  LogicalThreadContextProperties.cs, NativeError.cs,
	  NullDictionaryEnumerator.cs, NullEnumerator.cs,
	  NullSecurityContext.cs, OnlyOnceErrorHandler.cs,
	  OptionConverter.cs, PatternConverter.cs, PatternParser.cs,
	  PatternString.cs:

	Tidied up doc comments

	* Appender/ColoredConsoleAppender.cs:

	Updated to support writing more than 30,000 chars. Changed to use Stream 
	that calls WriteFile rather than WriteConsoleW

2005-01-31 02:32  nicko

	* Layout/PatternLayout.cs, Util/PatternString.cs:

	Updated doc comments

2005-01-28 22:18  nicko

	* Appender/AdoNetAppender.cs:

	Added ReconnectOnError property to AdoNetAppender

2005-01-28 20:51  nicko

	* Util/AppenderAttachedImpl.cs:

	Cache the appenders list in an array for performance

	* Repository/Hierarchy/: Hierarchy.cs, Logger.cs:

	Added casting to improve performance when comparing Level object against 
	null. Only reference equals is required

	* ObjectRenderer/RendererMap.cs:

	Added cache map to RenderMap to hold the renderer for queried types

	* Core/LoggingEvent.cs:

	Updated to use RendererMap.FindAndRender method that returns a string where 
	appropriate

	* Appender/AppenderCollection.cs:

	Added ToArray() to AppenderCollection. Added missing ICollection.CopyTo to 
	ReadOnlyAppenderCollection.

2005-01-25 01:59  nicko

	* Config/XmlConfiguratorAttribute.cs:

	Fixed mismatched tag in doc comment

2005-01-24 03:39  nicko

	* Appender/TelnetAppender.cs:

	Added check to only send events if the handler currently has open 
	connections

2005-01-18 20:16  nicko

	* Appender/RollingFileAppender.cs,
	  Config/XmlConfiguratorAttribute.cs:

	Updated doc comment

2005-01-17 21:42  nicko

	* AssemblyVersionInfo.cpp:

	Fixed managed c++ syntax error

2005-01-17 20:18  nicko

	* AssemblyInfo.cs, AssemblyVersionInfo.cpp, AssemblyVersionInfo.cs,
	  AssemblyVersionInfo.js, AssemblyVersionInfo.vb, GlobalContext.cs,
	  ILog.cs, LogManager.cs, LogicalThreadContext.cs, MDC.cs, NDC.cs,
	  ThreadContext.cs, Appender/AdoNetAppender.cs,
	  Appender/AnsiColorTerminalAppender.cs,
	  Appender/AppenderCollection.cs, Appender/AppenderSkeleton.cs,
	  Appender/AspNetTraceAppender.cs,
	  Appender/BufferingAppenderSkeleton.cs,
	  Appender/BufferingForwardingAppender.cs,
	  Appender/ColoredConsoleAppender.cs, Appender/ConsoleAppender.cs,
	  Appender/DebugAppender.cs, Appender/EventLogAppender.cs,
	  Appender/FileAppender.cs, Appender/ForwardingAppender.cs,
	  Appender/IAppender.cs, Appender/LocalSyslogAppender.cs,
	  Appender/MemoryAppender.cs, Appender/NetSendAppender.cs,
	  Appender/OutputDebugStringAppender.cs,
	  Appender/RemoteSyslogAppender.cs, Appender/RemotingAppender.cs,
	  Appender/RollingFileAppender.cs, Appender/SmtpAppender.cs,
	  Appender/SmtpPickupDirAppender.cs, Appender/TelnetAppender.cs,
	  Appender/TextWriterAppender.cs, Appender/TraceAppender.cs,
	  Appender/UdpAppender.cs, Config/AliasDomainAttribute.cs,
	  Config/AliasRepositoryAttribute.cs, Config/BasicConfigurator.cs,
	  Config/ConfiguratorAttribute.cs, Config/DOMConfigurator.cs,
	  Config/DOMConfiguratorAttribute.cs, Config/DomainAttribute.cs,
	  Config/Log4NetConfigurationSectionHandler.cs,
	  Config/PluginAttribute.cs, Config/RepositoryAttribute.cs,
	  Config/SecurityContextProviderAttribute.cs,
	  Config/XmlConfigurator.cs, Config/XmlConfiguratorAttribute.cs,
	  Core/CompactRepositorySelector.cs,
	  Core/DefaultRepositorySelector.cs, Core/ErrorCode.cs,
	  Core/IAppenderAttachable.cs, Core/IErrorHandler.cs,
	  Core/IFixingRequired.cs, Core/ILogger.cs, Core/ILoggerWrapper.cs,
	  Core/IOptionHandler.cs, Core/IRepositorySelector.cs,
	  Core/ITriggeringEventEvaluator.cs, Core/Level.cs,
	  Core/LevelCollection.cs, Core/LevelEvaluator.cs,
	  Core/LevelMap.cs, Core/LocationInfo.cs, Core/LogException.cs,
	  Core/LogImpl.cs, Core/LoggerManager.cs,
	  Core/LoggerWrapperImpl.cs, Core/LoggingEvent.cs,
	  Core/SecurityContext.cs, Core/SecurityContextProvider.cs,
	  Core/WrapperMap.cs, DateFormatter/AbsoluteTimeDateFormatter.cs,
	  DateFormatter/DateTimeDateFormatter.cs,
	  DateFormatter/IDateFormatter.cs,
	  DateFormatter/Iso8601DateFormatter.cs,
	  DateFormatter/SimpleDateFormatter.cs, Filter/DenyAllFilter.cs,
	  Filter/FilterDecision.cs, Filter/FilterSkeleton.cs,
	  Filter/IFilter.cs, Filter/LevelMatchFilter.cs,
	  Filter/LevelRangeFilter.cs, Filter/LoggerMatchFilter.cs,
	  Filter/MdcFilter.cs, Filter/NdcFilter.cs,
	  Filter/PropertyFilter.cs, Filter/StringMatchFilter.cs,
	  Layout/ExceptionLayout.cs, Layout/ILayout.cs,
	  Layout/IRawLayout.cs, Layout/Layout2RawLayoutAdapter.cs,
	  Layout/LayoutSkeleton.cs, Layout/PatternLayout.cs,
	  Layout/RawLayoutConverter.cs, Layout/RawPropertyLayout.cs,
	  Layout/RawTimeStampLayout.cs, Layout/RawUtcTimeStampLayout.cs,
	  Layout/SimpleLayout.cs, Layout/XMLLayout.cs,
	  Layout/XMLLayoutBase.cs, Layout/XmlLayoutSchemaLog4j.cs,
	  Layout/Pattern/AppDomainPatternConverter.cs,
	  Layout/Pattern/DatePatternConverter.cs,
	  Layout/Pattern/ExceptionPatternConverter.cs,
	  Layout/Pattern/FileLocationPatternConverter.cs,
	  Layout/Pattern/FullLocationPatternConverter.cs,
	  Layout/Pattern/IdentityPatternConverter.cs,
	  Layout/Pattern/LevelPatternConverter.cs,
	  Layout/Pattern/LineLocationPatternConverter.cs,
	  Layout/Pattern/LoggerPatternConverter.cs,
	  Layout/Pattern/MessagePatternConverter.cs,
	  Layout/Pattern/MethodLocationPatternConverter.cs,
	  Layout/Pattern/NamedPatternConverter.cs,
	  Layout/Pattern/NdcPatternConverter.cs,
	  Layout/Pattern/PatternLayoutConverter.cs,
	  Layout/Pattern/PropertyPatternConverter.cs,
	  Layout/Pattern/RelativeTimePatternConverter.cs,
	  Layout/Pattern/ThreadPatternConverter.cs,
	  Layout/Pattern/TypeNamePatternConverter.cs,
	  Layout/Pattern/UserNamePatternConverter.cs,
	  Layout/Pattern/UtcDatePatternConverter.cs,
	  ObjectRenderer/DefaultRenderer.cs,
	  ObjectRenderer/IObjectRenderer.cs, ObjectRenderer/RendererMap.cs,
	  Plugin/IPlugin.cs, Plugin/IPluginFactory.cs,
	  Plugin/PluginCollection.cs, Plugin/PluginMap.cs,
	  Plugin/PluginSkeleton.cs, Plugin/RemoteLoggingServerPlugin.cs,
	  Repository/IBasicRepositoryConfigurator.cs,
	  Repository/ILoggerRepository.cs,
	  Repository/IXmlRepositoryConfigurator.cs,
	  Repository/LoggerRepositorySkeleton.cs,
	  Repository/Hierarchy/DefaultLoggerFactory.cs,
	  Repository/Hierarchy/Hierarchy.cs,
	  Repository/Hierarchy/ILoggerFactory.cs,
	  Repository/Hierarchy/Logger.cs,
	  Repository/Hierarchy/LoggerKey.cs,
	  Repository/Hierarchy/ProvisionNode.cs,
	  Repository/Hierarchy/RootLogger.cs,
	  Repository/Hierarchy/XmlHierarchyConfigurator.cs,
	  Util/AppenderAttachedImpl.cs, Util/CompositeProperties.cs,
	  Util/ContextPropertiesBase.cs, Util/CountingQuietTextWriter.cs,
	  Util/CyclicBuffer.cs, Util/EmptyCollection.cs,
	  Util/EmptyDictionary.cs, Util/FormattingInfo.cs,
	  Util/GlobalContextProperties.cs, Util/LevelMapping.cs,
	  Util/LevelMappingEntry.cs, Util/LogLog.cs,
	  Util/LogicalThreadContextProperties.cs, Util/NativeError.cs,
	  Util/NullDictionaryEnumerator.cs, Util/NullEnumerator.cs,
	  Util/NullSecurityContext.cs, Util/OnlyOnceErrorHandler.cs,
	  Util/OptionConverter.cs, Util/PatternConverter.cs,
	  Util/PatternParser.cs, Util/PatternString.cs,
	  Util/PropertiesDictionary.cs, Util/ProtectCloseTextWriter.cs,
	  Util/QuietTextWriter.cs, Util/ReadOnlyPropertiesDictionary.cs,
	  Util/ReaderWriterLock.cs, Util/ReusableStringWriter.cs,
	  Util/SystemInfo.cs, Util/TextWriterAdapter.cs,
	  Util/ThreadContextList.cs, Util/ThreadContextLists.cs,
	  Util/ThreadContextProperties.cs, Util/ThreadContextStack.cs,
	  Util/ThreadContextStacks.cs, Util/Transform.cs,
	  Util/WindowsSecurityContext.cs,
	  Util/PatternStringConverters/AppDomainPatternConverter.cs,
	  Util/PatternStringConverters/DatePatternConverter.cs,
	  Util/PatternStringConverters/EnvironmentPatternConverter.cs,
	  Util/PatternStringConverters/IdentityPatternConverter.cs,
	  Util/PatternStringConverters/LiteralPatternConverter.cs,
	  Util/PatternStringConverters/NewLinePatternConverter.cs,
	  Util/PatternStringConverters/ProcessIdPatternConverter.cs,
	  Util/PatternStringConverters/PropertyPatternConverter.cs,
	  Util/PatternStringConverters/RandomStringPatternConverter.cs,
	  Util/PatternStringConverters/UserNamePatternConverter.cs,
	  Util/PatternStringConverters/UtcDatePatternConverter.cs,
	  Util/TypeConverters/BooleanConverter.cs,
	  Util/TypeConverters/ConversionNotSupportedException.cs,
	  Util/TypeConverters/ConverterRegistry.cs,
	  Util/TypeConverters/EncodingConverter.cs,
	  Util/TypeConverters/IConvertFrom.cs,
	  Util/TypeConverters/IConvertTo.cs,
	  Util/TypeConverters/PatternLayoutConverter.cs,
	  Util/TypeConverters/PatternStringConverter.cs,
	  Util/TypeConverters/TypeConverter.cs,
	  Util/TypeConverters/TypeConverterAttribute.cs:

	Updated copyright to 2005

2005-01-17 17:45  nicko

	* Config/XmlConfiguratorAttribute.cs:

	Updated doc comments

2004-12-20 00:44  nicko

	* Util/TypeConverters/: BooleanConverter.cs,
	  ConversionNotSupportedException.cs, ConverterRegistry.cs,
	  EncodingConverter.cs, IConvertFrom.cs, IConvertTo.cs,
	  PatternLayoutConverter.cs, PatternStringConverter.cs,
	  TypeConverter.cs, TypeConverterAttribute.cs:

	Updated doc comments.

2004-12-20 00:03  nicko

	* log4net.csproj, Layout/PatternLayout.cs,
	  Layout/Pattern/LiteralPatternConverter.cs,
	  Layout/Pattern/NewLinePatternConverter.cs:

	Replaced literal and newline layout pattern converters with string pattern 
	converters

2004-12-19 23:57  nicko

	* log4net.csproj:

	Added UtcDatePatternConverter

	* Util/: PatternString.cs,
	  PatternStringConverters/AppDomainPatternConverter.cs,
	  PatternStringConverters/DatePatternConverter.cs,
	  PatternStringConverters/EnvironmentPatternConverter.cs,
	  PatternStringConverters/IdentityPatternConverter.cs,
	  PatternStringConverters/LiteralPatternConverter.cs,
	  PatternStringConverters/NewLinePatternConverter.cs,
	  PatternStringConverters/ProcessIdPatternConverter.cs,
	  PatternStringConverters/PropertyPatternConverter.cs,
	  PatternStringConverters/RandomStringPatternConverter.cs,
	  PatternStringConverters/UserNamePatternConverter.cs,
	  PatternStringConverters/UtcDatePatternConverter.cs:

	Updated doc comments. Added UtcDatePatternConverter

2004-12-19 19:49  nicko

	* Appender/AdoNetAppender.cs, Config/BasicConfigurator.cs,
	  Config/XmlConfigurator.cs, Core/LoggerManager.cs,
	  Layout/Pattern/NamedPatternConverter.cs,
	  Repository/Hierarchy/Hierarchy.cs,
	  Repository/Hierarchy/XmlHierarchyConfigurator.cs,
	  Util/PatternParser.cs,
	  Util/PatternStringConverters/IdentityPatternConverter.cs,
	  Util/PatternStringConverters/ProcessIdPatternConverter.cs,
	  Util/PatternStringConverters/UserNamePatternConverter.cs:

	Cleaned up internal log messages

2004-12-19 19:24  nicko

	* Util/TypeConverters/: PatternStringConverter.cs,
	  TypeConverter.cs:

	Updates suggested by FxCop.
	Minor naming changes to internal types.
	Perf improvements to type check + type cast code.

	* Appender/AdoNetAppender.cs,
	  Appender/AnsiColorTerminalAppender.cs,
	  Appender/AppenderCollection.cs,
	  Appender/ColoredConsoleAppender.cs, Appender/EventLogAppender.cs,
	  Appender/RemoteSyslogAppender.cs, Config/BasicConfigurator.cs,
	  Config/ConfiguratorAttribute.cs, Config/XmlConfigurator.cs,
	  Core/Level.cs, Core/LevelCollection.cs, Core/LogImpl.cs,
	  Core/LoggingEvent.cs, Core/WrapperMap.cs,
	  Layout/PatternLayout.cs, Layout/RawLayoutConverter.cs,
	  Layout/Pattern/LiteralPatternConverter.cs,
	  Layout/Pattern/PatternLayoutConverter.cs,
	  ObjectRenderer/DefaultRenderer.cs, ObjectRenderer/RendererMap.cs,
	  Plugin/PluginCollection.cs, Repository/Hierarchy/Hierarchy.cs,
	  Repository/Hierarchy/XmlHierarchyConfigurator.cs,
	  Util/PatternParser.cs, Util/ReadOnlyPropertiesDictionary.cs,
	  Util/WindowsSecurityContext.cs,
	  Util/PatternStringConverters/LiteralPatternConverter.cs,
	  Util/TypeConverters/BooleanConverter.cs,
	  Util/TypeConverters/ConverterRegistry.cs,
	  Util/TypeConverters/EncodingConverter.cs,
	  Util/TypeConverters/PatternLayoutConverter.cs:

	Updates suggested by FxCop.
	Minor naming changes to internal types.
	Perf improvements to type check + type cast code.

2004-12-13 02:12  nicko

	* Repository/Hierarchy/: DefaultLoggerFactory.cs, Hierarchy.cs,
	  ILoggerFactory.cs:

	Updated Hierarchy to use the ILoggerFactory to create the Root logger

	* Repository/Hierarchy/: DefaultLoggerFactory.cs, Hierarchy.cs,
	  ILoggerFactory.cs:

	Renamed ILoggerFactory method MakeNewLoggerInstance to CreateLogger

	* Core/DefaultRepositorySelector.cs:

	Fixed call to GetCustomAttributes for PluginAttribute

	* Appender/AppenderCollection.cs,
	  Core/DefaultRepositorySelector.cs, Core/LevelCollection.cs,
	  Core/LogImpl.cs, Plugin/IPlugin.cs, Plugin/IPluginFactory.cs,
	  Plugin/PluginCollection.cs, Plugin/PluginMap.cs,
	  Plugin/PluginSkeleton.cs, Plugin/RemoteLoggingServerPlugin.cs,
	  Repository/IBasicRepositoryConfigurator.cs,
	  Repository/ILoggerRepository.cs,
	  Repository/IXmlRepositoryConfigurator.cs,
	  Repository/LoggerRepositorySkeleton.cs,
	  Repository/Hierarchy/DefaultLoggerFactory.cs,
	  Repository/Hierarchy/Hierarchy.cs,
	  Repository/Hierarchy/ILoggerFactory.cs,
	  Repository/Hierarchy/Logger.cs,
	  Repository/Hierarchy/LoggerKey.cs,
	  Repository/Hierarchy/ProvisionNode.cs,
	  Repository/Hierarchy/RootLogger.cs,
	  Repository/Hierarchy/XmlHierarchyConfigurator.cs, ILog.cs:

	Updated doc comments

2004-12-08 20:08  nicko

	* Repository/Hierarchy/Hierarchy.cs:

	Updated GetAppenders() method to supported nested appenders

2004-12-06 02:26  nicko

	* GlobalContext.cs, ILog.cs, LogManager.cs, NDC.cs,
	  ObjectRenderer/DefaultRenderer.cs,
	  ObjectRenderer/IObjectRenderer.cs, ObjectRenderer/RendererMap.cs,
	  Plugin/PluginCollection.cs, Util/LogLog.cs,
	  Util/OptionConverter.cs, Util/ThreadContextStack.cs:

	Updated doc comments

	* log4net.csproj, Layout/RawUtcTimeStampLayout.cs:

	Added RawUtcTimeStampLayout

	* Core/ErrorCode.cs, Core/IAppenderAttachable.cs,
	  Core/IErrorHandler.cs, Core/IFixingRequired.cs, Core/ILogger.cs,
	  Core/ILoggerWrapper.cs, Core/IOptionHandler.cs,
	  Core/ITriggeringEventEvaluator.cs, Core/Level.cs,
	  Core/LevelCollection.cs, Core/LevelEvaluator.cs,
	  Core/LevelMap.cs, Core/LocationInfo.cs, Core/LogException.cs,
	  Core/LogImpl.cs, Core/LoggerManager.cs,
	  Core/LoggerWrapperImpl.cs, Core/LoggingEvent.cs,
	  Core/SecurityContext.cs, Core/SecurityContextProvider.cs,
	  Core/WrapperMap.cs, Appender/AnsiColorTerminalAppender.cs,
	  Appender/AppenderCollection.cs,
	  Appender/ColoredConsoleAppender.cs, Config/XmlConfigurator.cs,
	  DateFormatter/AbsoluteTimeDateFormatter.cs,
	  DateFormatter/DateTimeDateFormatter.cs,
	  DateFormatter/IDateFormatter.cs,
	  DateFormatter/Iso8601DateFormatter.cs,
	  DateFormatter/SimpleDateFormatter.cs, Filter/DenyAllFilter.cs,
	  Filter/FilterDecision.cs, Filter/FilterSkeleton.cs,
	  Filter/IFilter.cs, Filter/LevelMatchFilter.cs,
	  Filter/LevelRangeFilter.cs, Filter/LoggerMatchFilter.cs,
	  Filter/MdcFilter.cs, Filter/NdcFilter.cs,
	  Filter/PropertyFilter.cs, Filter/StringMatchFilter.cs,
	  Layout/ExceptionLayout.cs, Layout/ILayout.cs,
	  Layout/IRawLayout.cs, Layout/Layout2RawLayoutAdapter.cs,
	  Layout/LayoutSkeleton.cs, Layout/PatternLayout.cs,
	  Layout/RawLayoutConverter.cs, Layout/RawPropertyLayout.cs,
	  Layout/RawTimeStampLayout.cs, Layout/SimpleLayout.cs,
	  Layout/XMLLayout.cs, Layout/XMLLayoutBase.cs,
	  Layout/XmlLayoutSchemaLog4j.cs,
	  Layout/Pattern/AppDomainPatternConverter.cs,
	  Layout/Pattern/DatePatternConverter.cs,
	  Layout/Pattern/ExceptionPatternConverter.cs,
	  Layout/Pattern/FileLocationPatternConverter.cs,
	  Layout/Pattern/FullLocationPatternConverter.cs,
	  Layout/Pattern/IdentityPatternConverter.cs,
	  Layout/Pattern/LevelPatternConverter.cs,
	  Layout/Pattern/LineLocationPatternConverter.cs,
	  Layout/Pattern/LiteralPatternConverter.cs,
	  Layout/Pattern/LoggerPatternConverter.cs,
	  Layout/Pattern/MessagePatternConverter.cs,
	  Layout/Pattern/MethodLocationPatternConverter.cs,
	  Layout/Pattern/NamedPatternConverter.cs,
	  Layout/Pattern/NdcPatternConverter.cs,
	  Layout/Pattern/NewLinePatternConverter.cs,
	  Layout/Pattern/PropertyPatternConverter.cs,
	  Layout/Pattern/RelativeTimePatternConverter.cs,
	  Layout/Pattern/ThreadPatternConverter.cs,
	  Layout/Pattern/TypeNamePatternConverter.cs,
	  Layout/Pattern/UserNamePatternConverter.cs,
	  Layout/Pattern/UtcDatePatternConverter.cs:

	Updated doc comments

	* Core/: CompactRepositorySelector.cs,
	  DefaultRepositorySelector.cs, IRepositorySelector.cs:

	Added ExistsRepository method to IRepositorySelector. Updated doc comments

2004-11-29 21:20  nicko

	* Core/LoggingEvent.cs, Repository/Hierarchy/Logger.cs:

	Added EnsureRepository method to LoggingEvent used by 
	ForcedLog(LoggingEvent) to ensure that the event has a repository set

2004-11-29 16:56  nicko

	* DateFormatter/AbsoluteTimeDateFormatter.cs,
	  DateFormatter/DateTimeDateFormatter.cs,
	  DateFormatter/Iso8601DateFormatter.cs, Layout/PatternLayout.cs,
	  Layout/Pattern/DatePatternConverter.cs,
	  Layout/Pattern/UtcDatePatternConverter.cs:

	Added Universal date pattern: utcDate

2004-11-25 23:02  nicko

	* Appender/SmtpPickupDirAppender.cs:

	Added SecurityContext used to impersonate around file access

2004-11-24 15:53  nicko

	* NDC.cs, Util/ThreadContextStack.cs:

	Reinstated Clear() method on ThreadContextStack and NDC

	* LogicalThreadContext.cs, MDC.cs, ThreadContext.cs,
	  Core/LoggingEvent.cs:

	Updated doc comments

2004-11-23 01:37  nicko

	* Config/: AliasDomainAttribute.cs, AliasRepositoryAttribute.cs,
	  BasicConfigurator.cs, ConfiguratorAttribute.cs,
	  DOMConfigurator.cs, DomainAttribute.cs,
	  Log4NetConfigurationSectionHandler.cs, PluginAttribute.cs,
	  RepositoryAttribute.cs, XmlConfigurator.cs,
	  XmlConfiguratorAttribute.cs:

	Updated doc comments

2004-11-22 22:42  nicko

	* Appender/RollingFileAppender.cs:

	Removed redundant File property

	* Appender/FileAppender.cs:

	Added check to FileAppender.OpenFile to ensure that the file path is fully 
	qualified

	* Util/LogLog.cs:

	Added IsXXXEnabled properties

2004-11-22 16:13  nicko

	* Appender/AspNetTraceAppender.cs:

	Fixed broken code comment under .net 1.1

2004-11-22 02:09  nicko

	* GlobalContext.cs, ILog.cs, LogManager.cs,
	  LogicalThreadContext.cs, MDC.cs, NDC.cs, ThreadContext.cs,
	  Appender/AdoNetAppender.cs,
	  Appender/AnsiColorTerminalAppender.cs,
	  Appender/AspNetTraceAppender.cs,
	  Appender/BufferingAppenderSkeleton.cs,
	  Appender/BufferingForwardingAppender.cs,
	  Appender/ColoredConsoleAppender.cs, Appender/ConsoleAppender.cs,
	  Appender/DebugAppender.cs, Appender/EventLogAppender.cs,
	  Appender/FileAppender.cs, Appender/ForwardingAppender.cs,
	  Appender/LocalSyslogAppender.cs, Appender/MemoryAppender.cs,
	  Appender/NetSendAppender.cs,
	  Appender/OutputDebugStringAppender.cs,
	  Appender/RemoteSyslogAppender.cs, Appender/RemotingAppender.cs,
	  Appender/RollingFileAppender.cs, Appender/SmtpAppender.cs,
	  Appender/SmtpPickupDirAppender.cs, Appender/TelnetAppender.cs,
	  Appender/TextWriterAppender.cs, Appender/TraceAppender.cs,
	  Appender/UdpAppender.cs:

	Updated doc comments

2004-11-20 21:33  nicko

	* Appender/RollingFileAppender.cs:

	Fixed RollingFileAppender tests

2004-11-19 21:50  nicko

	* Appender/TelnetAppender.cs:

	Added TelnetAppender ported from log4j by Keith Long

	* Appender/UdpAppender.cs:

	Fixed doc comment

	* Appender/RollingFileAppender.cs:

	Minor tweak to string append code

2004-11-18 13:41  nicko

	* Util/LevelMapping.cs:

	Added additional null test for safety

2004-11-17 22:17  nicko

	* Appender/RollingFileAppender.cs:

	Added support for rolling the current file out of the way if not appending.
	Added new rolling style 'Once' which rolls the file only when the appender 
	is configured.

2004-11-17 21:50  nicko

	* ObjectRenderer/DefaultRenderer.cs:

	Removed explicit support for rendering Exceptions. Exception.ToString gives 
	better results.
	Added support for rendering collections and dictionaries.

2004-11-15 20:40  nicko

	* Util/WindowsSecurityContext.cs:

	Added support for reverting to the Process credentials

	* Util/PatternConverter.cs:

	Made the SPACES array private

2004-11-15 02:52  nicko

	* log4net.csproj:

	Added SecurityContext files to solution

	* Config/SecurityContextProviderAttribute.cs:

	Added SecurityContextProviderAttribute for specifying the 
	SecurityContextProvider type in an assembly attribute

	* Config/ConfiguratorAttribute.cs,
	  Config/XmlConfiguratorAttribute.cs,
	  Core/DefaultRepositorySelector.cs:

	Added support for priority ordered loading of ConfiguratorAttributes

2004-11-12 22:33  nicko

	* Appender/AdoNetAppender.cs, Appender/EventLogAppender.cs,
	  Appender/FileAppender.cs, Appender/NetSendAppender.cs,
	  Appender/RollingFileAppender.cs, Core/SecurityContext.cs,
	  Core/SecurityContextProvider.cs, Util/NullSecurityContext.cs,
	  Util/WindowsSecurityContext.cs:

	Added initial SecurityContext classes

	* Core/LoggingEvent.cs, Layout/PatternLayout.cs:

	Renamed LoggingEvent.EventProperties to LoggingEvent.Properties. This is in 
	line with the other properties layers and is also backwardly compatible as 
	that is what it used to be called. If the properties have been cached then 
	the combined properties are returned, otherwise just the event properties 
	are returned.

2004-10-31 22:35  nicko

	* ILog.cs, Core/LogImpl.cs:

	Americanised spelling in doc comment

	* AssemblyVersionInfo.cpp, AssemblyVersionInfo.cs,
	  AssemblyVersionInfo.js, AssemblyVersionInfo.vb:

	Added AssemblyInformationalVersionAttribute

	* ILog.cs, Core/Level.cs, Core/LevelMap.cs, Core/LogImpl.cs,
	  Layout/SimpleLayout.cs, Layout/XMLLayout.cs,
	  Layout/XmlLayoutSchemaLog4j.cs,
	  Layout/Pattern/LevelPatternConverter.cs,
	  Repository/ILoggerRepository.cs,
	  Repository/LoggerRepositorySkeleton.cs,
	  Repository/Hierarchy/Hierarchy.cs,
	  Repository/Hierarchy/LoggerKey.cs,
	  Repository/Hierarchy/XmlHierarchyConfigurator.cs:

	Update to allow Level configuration to be redefined in the repository 
	LevelMap. This is now the authority on levels and the Level.Debug etc. 
	values are just the default values.
	Levels now have a display name which can be configured to alias or localize 
	levels in the output.
	The LogImpl looks up the level values to use from the LevelMap and listens 
	for configuration changes.

2004-10-01 22:24  nicko

	* Core/LocationInfo.cs:

	Added more checks for null in LocationInfo constructor

	* Config/PluginAttribute.cs, Core/CompactRepositorySelector.cs,
	  Core/DefaultRepositorySelector.cs,
	  Repository/Hierarchy/XmlHierarchyConfigurator.cs,
	  Util/OptionConverter.cs, Util/PatternParser.cs,
	  Util/TypeConverters/ConverterRegistry.cs:

	Replaced all type.GetConstructor().Invoke() with EmptyTypes with 
	Activator.CreateInstance

	* Repository/: ILoggerRepository.cs, LoggerRepositorySkeleton.cs,
	  Hierarchy/Hierarchy.cs:

	Added GetAppenders method call to ILoggerRepository

	* Appender/RemoteSyslogAppender.cs, ObjectRenderer/RendererMap.cs,
	  Util/PatternStringConverters/RandomStringPatternConverter.cs:

	Added missing CultureInfo to method calls

2004-09-29 23:02  nicko

	* ILog.cs, Core/LogImpl.cs:

	Added DebugFormat, InfoFormat, WarnFormat, ErrorFormat and FatalFormat 
	methods to ILog interface. These methods use String.Format style format 
	strings.

2004-09-27 00:21  nicko

	* LogicalThreadContext.cs, ThreadContext.cs, log4net.csproj,
	  Core/LoggingEvent.cs, Util/ContextPropertiesBase.cs,
	  Util/GlobalContextProperties.cs,
	  Util/LogicalThreadContextProperties.cs,
	  Util/ThreadContextLists.cs, Util/ThreadContextProperties.cs,
	  Util/ThreadContextStacks.cs,
	  Util/PatternStringConverters/PropertyPatternConverter.cs:

	Added LogicalThreadContext based on ideas by Ian Kundil.
	The LogicalThreadContext stores properties in the 
	System.Runtime.Remoting.Messaging.CallContext which allows them to flow 
	across thread boundaries as a call is marshalled. This does not support 
	flowing across a Remoting boundary.

	Reduced the times when a PropertiesDictionary is created just to support 
	reading.

2004-09-26 23:41  nicko

	* Appender/RollingFileAppender.cs:

	Updated doc comments. I have not been able to confirm the stuff on win32 
	file locking and sharing modes

	* Appender/BufferingForwardingAppender.cs,
	  Appender/ForwardingAppender.cs, Core/IAppenderAttachable.cs,
	  Repository/Hierarchy/Logger.cs, Util/AppenderAttachedImpl.cs:

	Amended the IAppenderAttachable interface to make the behaviour regarding 
	closing the appenders more explicit. Updated the RemoveAppender methods to 
	return the appender removed.

2004-09-26 19:06  nicko

	* log4net.csproj, Appender/AnsiColorTerminalAppender.cs:

	Added AnsiColorTerminalAppender contributed by Patrick Wagstrom.
	This appender uses ANSI Color escape sequences to colorize log messages. 
	Different foreground and background colors as well as attributes like 
	Bright and Underline can be specified for different levels.

2004-09-19 20:50  nicko

	* log4net.csproj, Layout/PatternLayout.cs,
	  Layout/Pattern/ExceptionPatternConverter.cs,
	  Layout/Pattern/PatternLayoutConverter.cs:

	Added ExceptionPatternConverter. Updated PatternLayout to check converters 
	for IgnoresException.

	* Layout/LayoutSkeleton.cs:

	Updated doc comments

2004-09-19 18:52  nicko

	* Core/ILogger.cs, Core/LocationInfo.cs, Core/LogImpl.cs,
	  Core/LoggingEvent.cs, Repository/Hierarchy/Logger.cs:

	Replaced fullNameOfLoggerClass string with callerStackBoundaryDeclaringType. 
	This allows us to perform a more accurate and more performant lookup of the 
	caller location information for a logging event. It also fixes an issue with 
	looking up the location information when using an extension.

2004-09-18 17:34  nicko

	* Appender/: FileAppender.cs, RollingFileAppender.cs,
	  TextWriterAppender.cs:

	Added Doug de la Torre's updates to make the FileAppender and 
	RollingFileAppender more robust. The TextWriterAppender.PrepareWriter method 
	is called for each message logged if the Writer has not been set.
	FileAppender uses PrepareWriter to attempt to open the file for each message 
	rather than just once at configuration. Once the file has been opened a 
	write lock is held. RollingFileAppender moves files before deleting them as 
	this reduces the number of situations where a file cannot be rolled.

	* Appender/RemoteSyslogAppender.cs:

	Fixed englishisation in doc comments

2004-09-18 15:34  nicko

	* Appender/LocalSyslogAppender.cs:

	Not supported on NETCF and SSCLI

	* log4net.csproj:

	Added syslog appender files

2004-09-14 22:00  nicko

	* Appender/: LocalSyslogAppender.cs, RemoteSyslogAppender.cs:

	Added LocalSyslogAppender and RemoteSyslogAppender based on Rob Lyon's 
	contribution.
	LocalSyslogAppender uses libc calls to write to the local syslog service.
	RemoteSyslogAppender uses UDP port 514 to send messages to a remote syslogd.

2004-09-13 08:53  nicko

	* Util/PatternString.cs:

	Added support for adding new pattern converters during configuration

	* Layout/PatternLayout.cs:

	Added comments and null arg checks

2004-09-13 08:05  nicko

	* ObjectRenderer/DefaultRenderer.cs:

	Added check for null return from obj.ToString()

	* Repository/Hierarchy/Logger.cs:

	Perf fix to Logger. Added test before AcquireReaderLock

	* Util/OnlyOnceErrorHandler.cs:

	Updated OnlyOnceErrorHandler to continue logging if InternalDebug is enabled

	* Util/CountingQuietTextWriter.cs:

	Added check for null or zero length string

2004-09-11 21:47  nicko

	* log4net.csproj:

	Added new files

	* Util/LevelMapping.cs:

	Fixed for NETCF

2004-09-10 21:58  nicko

	* Appender/ColoredConsoleAppender.cs, Appender/EventLogAppender.cs,
	  Util/LevelMapping.cs, Util/LevelMappingEntry.cs:

	Added LevelMapping helper to simplify writing appender configurable level
	mappings, e.g. the Level to Color mapping of the ColoredConsoleAppender.
	Updated the ColoredConsoleAppender and EventLogAppender to use the 
	LevelMapping.

2004-09-10 20:40  nicko

	* Layout/: ExceptionLayout.cs, LayoutSkeleton.cs, PatternLayout.cs,
	  SimpleLayout.cs, XMLLayoutBase.cs:

	Made LayoutSkeleton.IgnoresException a settable property. The user can now 
	force a layout to ignore the exception in the event.

2004-09-10 19:54  nicko

	* Repository/Hierarchy/XmlHierarchyConfigurator.cs,
	  Util/OptionConverter.cs:

	Removed OptionConverter.ConvertSpecialChars. This was used to parse C
	style string escaped chars. XML has a different but well defined and
	understood char escaping scheme which is preferred for XML data. This
	means that backslashes will no longer need to be escaped.

2004-09-10 10:16  nicko

	* log4net.csproj:

	Added new files to project

	* NDC.cs, Config/XmlConfigurator.cs:

	Fixed NETCF build errors

2004-09-09 22:53  nicko

	* MDC.cs, NDC.cs, ThreadContext.cs, Appender/EventLogAppender.cs,
	  Appender/RemotingAppender.cs, Appender/SmtpAppender.cs,
	  Appender/SmtpPickupDirAppender.cs, Appender/UdpAppender.cs,
	  Core/IFixingRequired.cs, Core/LoggingEvent.cs,
	  Filter/MdcFilter.cs, Filter/NdcFilter.cs,
	  Filter/PropertyFilter.cs, Layout/PatternLayout.cs,
	  Layout/RawPropertyLayout.cs, Layout/XMLLayout.cs,
	  Layout/XmlLayoutSchemaLog4j.cs,
	  Layout/Pattern/GlobalPropertyPatternConverter.cs,
	  Layout/Pattern/MdcPatternConverter.cs,
	  Layout/Pattern/NdcPatternConverter.cs,
	  Layout/Pattern/PropertyPatternConverter.cs,
	  Util/CompositeProperties.cs, Util/PatternString.cs,
	  Util/ThreadContextList.cs, Util/ThreadContextLists.cs,
	  Util/ThreadContextProperties.cs, Util/ThreadContextStack.cs,
	  Util/ThreadContextStacks.cs,
	  Util/PatternStringConverters/PropertyPatternConverter.cs:

	Added ThreadContext.
	The ThreadContext.Properties is a replacement for the MDC. The 
	ThreadContext.Stacks is a replacement for the NDC.
	The ThreadContext.Stacks and ThreadContext.Lists are stored in the 
	ThreadContext.Properties.
	The MDC and NDC forward to the new implementation where possible.
	The contexts are composed into layers; GlobalContext.Properties are 
	overridden by ThreadContext.Properties and they are overridden by 
	LoggingEvent.EventProperties.
	Changed filters and layouts to lookup properties from the LoggingEvent.

2004-09-09 21:37  nicko

	* Config/XmlConfigurator.cs:

	Improved doc comments. Added more detail to missing config section error 
	message

	* GlobalContext.cs:

	Added the hostname to the GlobalContext.Properties

2004-09-09 20:03  nicko

	* ObjectRenderer/DefaultRenderer.cs:

	Fix for error when reading the Exception.Source property that may occur if 
	it is an unmanaged exception. Reported by Brent Matzelle.

	* ObjectRenderer/RendererMap.cs:

	Added simple FindAndRender() method that writes to a StringWriter and then 
	returns the string

	* Util/: GlobalContextProperties.cs, PatternConverter.cs:

	Minor code naming changes and doc comments

	* Repository/Hierarchy/XmlHierarchyConfigurator.cs:

	Added support for using a TypeConverter to convert from the explicitly 
	specified type to the actual required property type

2004-08-23 01:07  nicko

	* Util/SystemInfo.cs:

	Process.StartTime not supported on NETCF or SSCLI

2004-08-22 20:26  nicko

	* Core/LoggingEvent.cs:

	Fixed LoggingEvent.GetObjectData() to add missing GlobalProperties value

2004-08-19 23:30  nicko

	* Layout/: XmlLayoutSchemaLog4j.cs,
	  Pattern/RelativeTimePatternConverter.cs:

	Fixed DateTime handling, convert to UTC before any math operations 
	involving 2 DateTimes.

	* Core/LoggingEvent.cs:

	Changed to use SystemInfo.ProcessStartTime property. Updated doc comments

	* Util/PatternStringConverters/DatePatternConverter.cs,
	  Layout/Pattern/DatePatternConverter.cs:

	minor change to doc comment

	* Util/SystemInfo.cs:

	Added ProcessStartTime property

2004-08-19 22:31  nicko

	* Repository/Hierarchy/XmlHierarchyConfigurator.cs:

	Added explicit parameter subtype specification. This allows the subtype of
	a property to be specified in the config file allowing an appropriate
	converter to be found for the string value. This allows the following to
	be specified in the config file:

	<layout type="log4net.Layout.PatternLayout" value="%d [%t] %-5p %c [%x] - %m%n" />

	This leverages the pattern layout TypeConverter to convert the value into the
	required type.

2004-08-19 22:22  nicko

	* log4net.csproj:

	Added RandomStringPatternConverter.cs and PatternLayoutConverter.cs

	* Util/: PatternString.cs,
	  PatternStringConverters/RandomStringPatternConverter.cs:

	Added RandomStringPatternConverter

	* Util/TypeConverters/: ConverterRegistry.cs,
	  PatternLayoutConverter.cs:

	Added PatternLayoutConverter

	* Layout/PatternLayout.cs:

	Cleaned up PatternLayout(string) constructor. Added more docs about 
	ActivateOptions() method

2004-08-11 21:04  nicko

	* Appender/SmtpAppender.cs:

	Update to the SmtpAppender from Al Little.
	Added SMTP Basic (username & password) and NTLM (Windows Integrated) 
	authentication to the SmtpAppender.
	Added property to allow the SMTP server port to be set.
	These features are only available on .NET 1.1 runtime using CDO as the mail 
	client implementation.

2004-08-02 10:44  nicko

	* Layout/: XMLLayout.cs, XmlLayoutSchemaLog4j.cs:

	Added support for GlobalProperties

	* Util/: PropertiesDictionary.cs, ReadOnlyPropertiesDictionary.cs:

	Made the inner hashtable m_ht private

	* Appender/ColoredConsoleAppender.cs:

	Added overloaded AddMapping() method

	* GlobalContext.cs:

	Added code example

2004-07-31 15:41  nicko

	* log4net.csproj:

	Added new files to project

	* Util/GlobalContextProperties.cs:

	NETCF Compact Framework does not support volatile keyword

2004-07-30 21:48  nicko

	* Layout/XMLLayout.cs:

	Minor doc comment update

2004-07-30 18:42  nicko

	* GlobalContext.cs, Core/LoggingEvent.cs, Layout/PatternLayout.cs,
	  Layout/Pattern/GlobalPropertyPatternConverter.cs,
	  Util/GlobalContextProperties.cs:

	Added GlobalContext similar to MDC but not thread local.
	GlobalContext.Properties is a shared properties dictionary that can be 
	included in the
	output by using the %global pattern in the PatternLayout.

	* Repository/Hierarchy/XmlHierarchyConfigurator.cs:

	Fixed misspelling in error message

	* Util/: PropertiesDictionary.cs, ReadOnlyPropertiesDictionary.cs:

	Added ReadOnlyPropertiesDictionary that is a read only mapping from String 
	to Object.
	Changed the PropertiesDictionary to extend the ReadOnlyPropertiesDictionary.
	Added copy constructors to both to allows the dictionary to be initialised 
	from another
	ReadOnlyPropertiesDictionary.

2004-07-30 15:19  nicko

	* Layout/PatternLayout.cs:

	Added AddConverter(name,type) method to PatternLayout. This allows a custom
	converter to be bound to the instance of the PatternLayout. A ConverterInfo
	class is used to allow the converter to be specified in the Xml configuration.

	* Util/TypeConverters/: ConverterRegistry.cs, TypeConverter.cs:

	Added TypeConverter and converter that converts a string to a Type

	* Repository/Hierarchy/XmlHierarchyConfigurator.cs:

	Changed the way that the Add<name> method is looked up. The code now 
	supports methods that are overloaded and finds the first one with a single 
	argument, previously it would only find the first method and give an error 
	if it did not have a single argument.

2004-07-24 15:54  drieseng

	* Appender/ColoredConsoleAppender.cs:

	do not include this class in log4net Core as it contains win32 specific code

	* Appender/EventLogAppender.cs, Appender/NetSendAppender.cs,
	  Appender/OutputDebugStringAppender.cs, Util/NativeError.cs:

	do not include these classes in log4net Core as these are Windows-specific

2004-07-24 08:46  drieseng

	* Util/ReaderWriterLock.cs:

	System.Threading.ReaderWriterLock is now implemented in Mono 1.0

2004-06-27 18:53  nicko

	* Repository/Hierarchy/XmlHierarchyConfigurator.cs:

	Fixed NullReferenceException thrown when parsing an unknown or inherited level.
	The exception was thrown from an incorrectly placed internal log message.

2004-06-09 09:03  nicko

	* Core/CompactRepositorySelector.cs,
	  Core/DefaultRepositorySelector.cs,
	  Repository/LoggerRepositorySkeleton.cs,
	  Repository/Hierarchy/Hierarchy.cs:

	Changed event delivery method names from FireXXX to OnXXX as per .net 
	guidelines

2004-06-07 02:10  nicko

	* LogManager.cs:

	Updated to use WrapperMap.GetWrapper

	* Appender/: AdoNetAppender.cs, RollingFileAppender.cs:

	Made exception catching more specific

	* Core/LevelMap.cs, Core/CompactRepositorySelector.cs,
	  Core/DefaultRepositorySelector.cs, Appender/UdpAppender.cs,
	  NDC.cs:

	Updated to use SystemInfo.CreateArgumentOutOfRangeException

	* Core/LoggingEvent.cs:

	Added ExceptionObject property to get the exception object if it exists

	* Core/WrapperMap.cs:

	Replaced indexer property with GetWrapper method

	* Layout/XMLLayout.cs:

	Fixed doc comments

	* ObjectRenderer/RendererMap.cs:

	Cleaned up catch blocks

	* Appender/AppenderCollection.cs, Core/LevelCollection.cs,
	  Plugin/PluginCollection.cs:

	Updated to use SystemInfo.CreateArgumentOutOfRangeException

	* Plugin/RemoteLoggingServerPlugin.cs:

	Made the RemoteLoggingSinkImpl nested class private. Removed the 
	RemoteLoggingSinkImpl.LoggerRepository property

	* Repository/Hierarchy/Hierarchy.cs:

	Added protected methods to access the implementation of the 
	IBasicRepositoryConfigurator and IXmlRepositoryConfigurator interfaces.

	* Util/PatternStringConverters/EnvironmentPatternConverter.cs:

	Fixed incorrect internal log message

	* Util/: CyclicBuffer.cs, OptionConverter.cs:

	Updated to use SystemInfo.CreateArgumentOutOfRangeException

	* Util/SystemInfo.cs:

	Make catches more specific where possible. Added method 
	CreateArgumentOutOfRangeException

2004-06-02 17:28  nicko

	* Appender/BufferingAppenderSkeleton.cs:

	Updated to use new CyclicBuffer.Append method

	* Util/CyclicBuffer.cs:

	Simplified CyclicBuffer.Append method signature. Now just returns the 
	discarded event (if any) rather than having bools and out params

	* Util/: Transform.cs, OptionConverter.cs:

	Updated parameter names in line with guidelines.

	* Repository/Hierarchy/LoggerKey.cs:

	Removed unused internal property Value. Marked private fields as readonly 
	as LoggerKey is immutable.

	* Repository/LoggerRepositorySkeleton.cs:

	Updated parameter names in line with guidelines. Fixed race condition in 
	FireShutdownEvent

	* Core/WrapperMap.cs:

	Made the ILoggerRepository Shutdown event handler delegate method private. 
	Added a new overridable method RepositoryShutdown.

2004-06-02 16:37  nicko

	* Core/Level.cs:

	Marked private fields as readonly as the Level is immutable

	* Config/: ConfiguratorAttribute.cs, XmlConfiguratorAttribute.cs:

	Updated parameter names in line with guidelines

	* NDC.cs:

	Removed unused internal method Peek from NDC

2004-06-01 19:34  nicko

	* Appender/: ConsoleAppender.cs, DebugAppender.cs,
	  EventLogAppender.cs, FileAppender.cs, TextWriterAppender.cs,
	  TraceAppender.cs, ColoredConsoleAppender.cs:

	Marked all non default constructors as Obsolete.
	The correct usage model for appenders is to create an instance using the 
	default constructor, set the properties on the instance and then call 
	ActivateOptions(). The alternative constructors represent a set of 
	different and possible incorrect initialisation paths.

	* Appender/MemoryAppender.cs:

	Updated comment

	* Config/BasicConfigurator.cs:

	Changed default console appender construction to use the IOptionHandler 
	pattern more correctly.

	* Core/LevelCollection.cs, Appender/AppenderCollection.cs:

	Sealed inner classes

	* Layout/PatternLayout.cs:

	Updated doc comments

2004-06-01 18:58  nicko

	* Plugin/PluginMap.cs:

	Sealed PluginMap class and removed virtual from properties and methods

	* Plugin/PluginCollection.cs:

	Sealed inner classes

	* Repository/LoggerRepositorySkeleton.cs:

	Changed to set threshold field directly in the constructor rather than 
	using the virtual property

	* Util/PatternString.cs:

	Updated PatternString not to implement the IOptionHandler interface

	* Util/NativeError.cs:

	Sealed NativeError class

2004-05-30 19:02  nicko

	* log4net.csproj:

	Added CompactRepositorySelector.cs to the project

	* Appender/UdpAppender.cs:

	Updated doc comments. Fixed arguments to ArgumentOutOfRangeException

	* Appender/: BufferingAppenderSkeleton.cs, EventLogAppender.cs,
	  FileAppender.cs, NetSendAppender.cs, RemotingAppender.cs,
	  RollingFileAppender.cs:

	Updated doc comments

	* Appender/ColoredConsoleAppender.cs:

	Renamed inner class ColoredConsoleAppenderLevelColorMapping to LevelColors

	* Appender/AdoNetAppender.cs:

	Updated doc comments. Minor code cleanup

	* Appender/AppenderSkeleton.cs:

	Renamed LoggingEvent.GetExceptionStrRep to GetExceptionString. Updated doc 
	comments.

2004-05-30 12:38  nicko

	* LogManager.cs:

	Updated doc comments.
	Marked WrapLogger and WrapLoggers as private methods.

	* MDC.cs:

	Updated doc comments

	* NDC.cs:

	Fixed arguments to ArgumentOutOfRangeException. Updated doc comments

	* Config/BasicConfigurator.cs:

	Renamed PatternLayout.TtlnConversionPattern to DetailConversionPattern

	* Layout/PatternLayout.cs:

	Updated doc comments.
	Removed references to TTCCLayout.
	Renamed constant TtlnConversionPattern to DetailConversionPattern

	* Layout/: LayoutSkeleton.cs, SimpleLayout.cs:

	Updated doc comments

	* Layout/ExceptionLayout.cs:

	Renamed loggingEvent.GetExceptionStrRep to GetExceptionString

	* Layout/: XMLLayout.cs, XMLLayoutBase.cs, XmlLayoutSchemaLog4j.cs:

	Renamed loggingEvent.GetExceptionStrRep to GetExceptionString. Updated doc 
	comments

	* Layout/Pattern/: DatePatternConverter.cs,
	  NamedPatternConverter.cs, NewLinePatternConverter.cs:

	Updated doc comments

	* Core/LoggingEvent.cs:

	Renamed GetExceptionStrRep to GetExceptionString

	* Core/: CompactRepositorySelector.cs,
	  DefaultRepositorySelector.cs, LevelMap.cs:

	Fixed arguments to ArgumentOutOfRangeException

	* Filter/FilterSkeleton.cs, Filter/MdcFilter.cs,
	  Filter/NdcFilter.cs, Filter/StringMatchFilter.cs,
	  Core/IOptionHandler.cs:

	Updated doc comments

	* Appender/AppenderCollection.cs, Core/LevelCollection.cs,
	  Plugin/PluginCollection.cs:

	Fixed arguments to ArgumentOutOfRangeException.
	Excluded nested classes from documentation.

	* Repository/Hierarchy/XmlHierarchyConfigurator.cs:

	Renamed OptionConverter method SubstVars to SubstituteVariables

	* Util/CyclicBuffer.cs:

	Fixed arguments to ArgumentOutOfRangeException

	* Util/OptionConverter.cs:

	Removed unused methods:
	ConcatenateArrays, ToInt, FindAndSubst

	Renamed method SubstVars to SubstituteVariables

	* Util/: PatternString.cs,
	  PatternStringConverters/DatePatternConverter.cs,
	  PatternStringConverters/NewLinePatternConverter.cs:

	Updated doc comments

2004-05-28 22:42  nicko

	* AssemblyInfo.cs:

	Reinstated CLSCompliant attribute in Mono builds.
	Removed code from build.cmd that called %WINDIR%\monobasepath.bat if it 
	exists. This was a hack to get early versions of mono to build but is no 
	longer required.

	* Util/: NativeError.cs, SystemInfo.cs:

	Added NativeError.GetLastError method to get the native error for the last 
	windows error.

2004-05-21 23:15  nicko

	* AssemblyInfo.cs, LogManager.cs, Appender/AdoNetAppender.cs,
	  Appender/AspNetTraceAppender.cs,
	  Appender/ColoredConsoleAppender.cs, Appender/EventLogAppender.cs,
	  Appender/NetSendAppender.cs,
	  Appender/OutputDebugStringAppender.cs,
	  Appender/RemotingAppender.cs, Appender/SmtpAppender.cs,
	  Config/AliasDomainAttribute.cs,
	  Config/AliasRepositoryAttribute.cs,
	  Config/ConfiguratorAttribute.cs, Config/DOMConfigurator.cs,
	  Config/DOMConfiguratorAttribute.cs, Config/DomainAttribute.cs,
	  Config/Log4NetConfigurationSectionHandler.cs,
	  Config/PluginAttribute.cs, Config/RepositoryAttribute.cs,
	  Config/XmlConfiguratorAttribute.cs,
	  Core/DefaultRepositorySelector.cs, Core/LoggerManager.cs,
	  Plugin/RemoteLoggingServerPlugin.cs, Util/NativeError.cs,
	  Util/PatternStringConverters/EnvironmentPatternConverter.cs:

	Updated log4net.build to not specify file excludes for specific platforms.
	Updated code files to use C# preprocessor defines to conditionally exclude 
	the contents of some files from some of the builds. This improves the 
	visibility of the exclusions and reduces the maintenance of the nant build 
	file.

2004-05-20 20:40  nicko

	* Appender/CountingAppender.cs:

	Moved to nunit tests assembly

	* .cvsignore:

	Updated cvsignore files to use wildcards

2004-05-16 22:28  nicko

	* Core/LoggingEvent.cs:

	fixed documentation comments

	* DateFormatter/AbsoluteTimeDateFormatter.cs:

	Added locking to date formatter where the shared static buffer is written to.

	* Util/PropertiesDictionary.cs:

	Fixed bug where the dictionary entry key is not decoded correctly on 
	deserialization

2004-04-18 19:34  nicko

	* Util/PropertiesDictionary.cs:

	Fixed issue with SerializationInfo keys, must be valid XML Qnames otherwise 
	SOAP serialization fails

2004-03-12 19:12  nicko

	* Config/XmlConfigurator.cs:

	Added better error message if the .net configuration section is not found.

2004-02-27 13:03  nicko

	* Appender/RollingFileAppender.cs:

	Fixed ComputeCheckPeriod day rolling detection in pre GMT timezones.
	Fixed ComputeCheckPeriod month rolling detection.

2004-02-26 21:44  nicko

	* Util/SystemInfo.cs:

	Updated SystemInfo.GetTypeFromString to search all the loaded assemblies
	for an unqualified type name if it is not found in the relative assembly.

	Added tests for GetTypeFromString.

2004-02-26 21:02  nicko

	* LogManager.cs, Config/BasicConfigurator.cs,
	  Config/XmlConfigurator.cs, Core/LoggerManager.cs:

	Obsoleted GetLoggerRepository and added GetRepository

	* log4net.csproj:

	Moved CountingAppender to the test project

	* log4net.sln:

	Removed the ReleaseStrong configuration from the solution, it doesn't exist 
	anymore.

	* Appender/BufferingAppenderSkeleton.cs:

	Changed to not create the cyclic buffer if the buffer size is less than 2

2004-02-23 03:18  nicko

	* ILog.cs, NDC.cs, Appender/AdoNetAppender.cs,
	  Appender/AppenderCollection.cs, Appender/AppenderSkeleton.cs,
	  Appender/BufferingAppenderSkeleton.cs,
	  Appender/BufferingForwardingAppender.cs,
	  Appender/ColoredConsoleAppender.cs, Appender/ConsoleAppender.cs,
	  Appender/DebugAppender.cs, Appender/EventLogAppender.cs,
	  Appender/FileAppender.cs, Appender/ForwardingAppender.cs,
	  Appender/IAppender.cs, Appender/MemoryAppender.cs,
	  Appender/NetSendAppender.cs, Appender/RemotingAppender.cs,
	  Appender/RollingFileAppender.cs, Appender/SmtpAppender.cs,
	  Appender/TextWriterAppender.cs, Appender/TraceAppender.cs,
	  Appender/UdpAppender.cs, Config/AliasDomainAttribute.cs,
	  Config/AliasRepositoryAttribute.cs,
	  Config/ConfiguratorAttribute.cs, Config/DOMConfigurator.cs,
	  Config/DomainAttribute.cs, Config/RepositoryAttribute.cs,
	  Config/XmlConfigurator.cs, Config/XmlConfiguratorAttribute.cs,
	  Core/DefaultRepositorySelector.cs, Core/Level.cs,
	  Core/LevelCollection.cs, Core/LevelMap.cs, Core/LocationInfo.cs,
	  Core/LoggerManager.cs, Core/LoggingEvent.cs, Core/WrapperMap.cs,
	  DateFormatter/AbsoluteTimeDateFormatter.cs,
	  Filter/DenyAllFilter.cs, Filter/FilterSkeleton.cs,
	  Filter/IFilter.cs, Filter/LevelMatchFilter.cs,
	  Filter/LevelRangeFilter.cs, Filter/LoggerMatchFilter.cs,
	  Filter/MdcFilter.cs, Filter/NdcFilter.cs,
	  Filter/StringMatchFilter.cs, Layout/ExceptionLayout.cs,
	  Layout/IRawLayout.cs, Layout/Layout2RawLayoutAdapter.cs,
	  Layout/PatternLayout.cs, Layout/RawLayoutConverter.cs,
	  Layout/SimpleLayout.cs, Layout/XmlLayoutSchemaLog4j.cs,
	  Layout/Pattern/DatePatternConverter.cs,
	  Layout/Pattern/LiteralPatternConverter.cs,
	  ObjectRenderer/DefaultRenderer.cs, Plugin/PluginCollection.cs,
	  Plugin/PluginMap.cs, Repository/IBasicRepositoryConfigurator.cs,
	  Repository/ILoggerRepository.cs,
	  Repository/IXmlRepositoryConfigurator.cs,
	  Repository/LoggerRepositorySkeleton.cs,
	  Repository/Hierarchy/Hierarchy.cs,
	  Repository/Hierarchy/Logger.cs,
	  Repository/Hierarchy/XmlHierarchyConfigurator.cs,
	  Util/CyclicBuffer.cs, Util/EmptyCollection.cs,
	  Util/NativeError.cs, Util/OnlyOnceErrorHandler.cs,
	  Util/OptionConverter.cs, Util/PatternConverter.cs,
	  Util/PatternParser.cs, Util/PatternString.cs,
	  Util/PropertiesDictionary.cs, Util/ProtectCloseTextWriter.cs,
	  Util/QuietTextWriter.cs, Util/ReusableStringWriter.cs,
	  Util/Transform.cs,
	  Util/PatternStringConverters/DatePatternConverter.cs,
	  Util/PatternStringConverters/EnvironmentPatternConverter.cs,
	  Util/PatternStringConverters/LiteralPatternConverter.cs,
	  Util/TypeConverters/BooleanConverter.cs,
	  Util/TypeConverters/ConverterRegistry.cs,
	  Util/TypeConverters/IConvertFrom.cs,
	  Util/TypeConverters/IConvertTo.cs,
	  Util/TypeConverters/PatternStringConverter.cs,
	  Util/TypeConverters/TypeConverterAttribute.cs:

	Fixed spelling errors and minor formatting updates.

2004-02-16 16:30  nicko

	* AssemblyVersionInfo.cs, log4net.csproj, log4net.sln,
	  Appender/EventLogAppender.cs, Appender/RollingFileAppender.cs,
	  Repository/Hierarchy/Logger.cs:

	Created new project log4net.Tests.
	Moved existing NUnit tests from the log4net assembly to the log4net.Tests 
	assembly.

2004-02-16 02:10  nicko

	* AssemblyInfo.cs, AssemblyVersionInfo.cpp, AssemblyVersionInfo.cs,
	  AssemblyVersionInfo.js, AssemblyVersionInfo.vb, ILog.cs,
	  LogManager.cs, MDC.cs, NDC.cs, Appender/AdoNetAppender.cs,
	  Appender/AppenderCollection.cs, Appender/AppenderSkeleton.cs,
	  Appender/AspNetTraceAppender.cs,
	  Appender/BufferingAppenderSkeleton.cs,
	  Appender/BufferingForwardingAppender.cs,
	  Appender/ColoredConsoleAppender.cs, Appender/ConsoleAppender.cs,
	  Appender/CountingAppender.cs, Appender/DebugAppender.cs,
	  Appender/EventLogAppender.cs, Appender/FileAppender.cs,
	  Appender/ForwardingAppender.cs, Appender/IAppender.cs,
	  Appender/MemoryAppender.cs, Appender/NetSendAppender.cs,
	  Appender/OutputDebugStringAppender.cs,
	  Appender/RemotingAppender.cs, Appender/RollingFileAppender.cs,
	  Appender/SmtpAppender.cs, Appender/SmtpPickupDirAppender.cs,
	  Appender/TextWriterAppender.cs, Appender/TraceAppender.cs,
	  Appender/UdpAppender.cs, Config/AliasDomainAttribute.cs,
	  Config/AliasRepositoryAttribute.cs, Config/BasicConfigurator.cs,
	  Config/ConfiguratorAttribute.cs, Config/DOMConfigurator.cs,
	  Config/DOMConfiguratorAttribute.cs, Config/DomainAttribute.cs,
	  Config/Log4NetConfigurationSectionHandler.cs,
	  Config/PluginAttribute.cs, Config/RepositoryAttribute.cs,
	  Config/XmlConfigurator.cs, Config/XmlConfiguratorAttribute.cs,
	  Core/CompactRepositorySelector.cs,
	  Core/DefaultRepositorySelector.cs, Core/ErrorCode.cs,
	  Core/IAppenderAttachable.cs, Core/IErrorHandler.cs,
	  Core/ILogger.cs, Core/ILoggerWrapper.cs, Core/IOptionHandler.cs,
	  Core/IRepositorySelector.cs, Core/ITriggeringEventEvaluator.cs,
	  Core/Level.cs, Core/LevelCollection.cs, Core/LevelEvaluator.cs,
	  Core/LevelMap.cs, Core/LocationInfo.cs, Core/LogException.cs,
	  Core/LogImpl.cs, Core/LoggerManager.cs,
	  Core/LoggerWrapperImpl.cs, Core/LoggingEvent.cs,
	  Core/WrapperMap.cs, DateFormatter/AbsoluteTimeDateFormatter.cs,
	  DateFormatter/DateTimeDateFormatter.cs,
	  DateFormatter/IDateFormatter.cs,
	  DateFormatter/Iso8601DateFormatter.cs,
	  DateFormatter/SimpleDateFormatter.cs, Filter/DenyAllFilter.cs,
	  Filter/FilterDecision.cs, Filter/FilterSkeleton.cs,
	  Filter/IFilter.cs, Filter/LevelMatchFilter.cs,
	  Filter/LevelRangeFilter.cs, Filter/LoggerMatchFilter.cs,
	  Filter/MdcFilter.cs, Filter/NdcFilter.cs,
	  Filter/StringMatchFilter.cs, Layout/ExceptionLayout.cs,
	  Layout/ILayout.cs, Layout/IRawLayout.cs,
	  Layout/Layout2RawLayoutAdapter.cs, Layout/LayoutSkeleton.cs,
	  Layout/PatternLayout.cs, Layout/RawLayoutConverter.cs,
	  Layout/RawPropertyLayout.cs, Layout/RawTimeStampLayout.cs,
	  Layout/SimpleLayout.cs, Layout/XMLLayout.cs,
	  Layout/XMLLayoutBase.cs, Layout/XmlLayoutSchemaLog4j.cs,
	  Layout/Pattern/AppDomainPatternConverter.cs,
	  Layout/Pattern/DatePatternConverter.cs,
	  Layout/Pattern/FileLocationPatternConverter.cs,
	  Layout/Pattern/FullLocationPatternConverter.cs,
	  Layout/Pattern/IdentityPatternConverter.cs,
	  Layout/Pattern/LevelPatternConverter.cs,
	  Layout/Pattern/LineLocationPatternConverter.cs,
	  Layout/Pattern/LiteralPatternConverter.cs,
	  Layout/Pattern/LoggerPatternConverter.cs,
	  Layout/Pattern/MdcPatternConverter.cs,
	  Layout/Pattern/MessagePatternConverter.cs,
	  Layout/Pattern/MethodLocationPatternConverter.cs,
	  Layout/Pattern/NamedPatternConverter.cs,
	  Layout/Pattern/NdcPatternConverter.cs,
	  Layout/Pattern/NewLinePatternConverter.cs,
	  Layout/Pattern/PatternLayoutConverter.cs,
	  Layout/Pattern/PropertyPatternConverter.cs,
	  Layout/Pattern/RelativeTimePatternConverter.cs,
	  Layout/Pattern/ThreadPatternConverter.cs,
	  Layout/Pattern/TypeNamePatternConverter.cs,
	  Layout/Pattern/UserNamePatternConverter.cs,
	  ObjectRenderer/DefaultRenderer.cs,
	  ObjectRenderer/IObjectRenderer.cs, ObjectRenderer/RendererMap.cs,
	  Plugin/IPlugin.cs, Plugin/IPluginFactory.cs,
	  Plugin/PluginCollection.cs, Plugin/PluginMap.cs,
	  Plugin/PluginSkeleton.cs, Plugin/RemoteLoggingServerPlugin.cs,
	  Repository/IBasicRepositoryConfigurator.cs,
	  Repository/ILoggerRepository.cs,
	  Repository/IXmlRepositoryConfigurator.cs,
	  Repository/LoggerRepositorySkeleton.cs,
	  Repository/Hierarchy/DefaultLoggerFactory.cs,
	  Repository/Hierarchy/Hierarchy.cs,
	  Repository/Hierarchy/ILoggerFactory.cs,
	  Repository/Hierarchy/Logger.cs,
	  Repository/Hierarchy/LoggerKey.cs,
	  Repository/Hierarchy/ProvisionNode.cs,
	  Repository/Hierarchy/RootLogger.cs,
	  Repository/Hierarchy/XmlHierarchyConfigurator.cs,
	  Util/AppenderAttachedImpl.cs, Util/CountingQuietTextWriter.cs,
	  Util/CyclicBuffer.cs, Util/EmptyCollection.cs,
	  Util/EmptyDictionary.cs, Util/FormattingInfo.cs, Util/LogLog.cs,
	  Util/NativeError.cs, Util/NullDictionaryEnumerator.cs,
	  Util/NullEnumerator.cs, Util/OnlyOnceErrorHandler.cs,
	  Util/OptionConverter.cs, Util/PatternConverter.cs,
	  Util/PatternParser.cs, Util/PatternString.cs,
	  Util/PropertiesDictionary.cs, Util/ProtectCloseTextWriter.cs,
	  Util/QuietTextWriter.cs, Util/ReaderWriterLock.cs,
	  Util/ReusableStringWriter.cs, Util/SystemInfo.cs,
	  Util/TextWriterAdapter.cs, Util/Transform.cs,
	  Util/PatternStringConverters/AppDomainPatternConverter.cs,
	  Util/PatternStringConverters/DatePatternConverter.cs,
	  Util/PatternStringConverters/EnvironmentPatternConverter.cs,
	  Util/PatternStringConverters/IdentityPatternConverter.cs,
	  Util/PatternStringConverters/LiteralPatternConverter.cs,
	  Util/PatternStringConverters/NewLinePatternConverter.cs,
	  Util/PatternStringConverters/ProcessIdPatternConverter.cs,
	  Util/PatternStringConverters/UserNamePatternConverter.cs,
	  Util/TypeConverters/BooleanConverter.cs,
	  Util/TypeConverters/ConversionNotSupportedException.cs,
	  Util/TypeConverters/ConverterRegistry.cs,
	  Util/TypeConverters/EncodingConverter.cs,
	  Util/TypeConverters/IConvertFrom.cs,
	  Util/TypeConverters/IConvertTo.cs,
	  Util/TypeConverters/PatternStringConverter.cs,
	  Util/TypeConverters/TypeConverterAttribute.cs:

	Updated copyright

2004-02-12 19:32  nicko

	* Layout/PatternLayout.cs:

	Fixed doc comment. Was using old style %X{} syntax. Replaced with %mdc{}

2004-01-28 20:44  nicko

	* Core/: CompactRepositorySelector.cs,
	  DefaultRepositorySelector.cs, ErrorCode.cs,
	  IAppenderAttachable.cs, IErrorHandler.cs, ILogger.cs,
	  ILoggerWrapper.cs, IOptionHandler.cs, IRepositorySelector.cs,
	  ITriggeringEventEvaluator.cs, Level.cs, LevelCollection.cs,
	  LevelEvaluator.cs, LevelMap.cs, LocationInfo.cs, LogException.cs,
	  LogImpl.cs, LoggerManager.cs, LoggerWrapperImpl.cs,
	  LoggingEvent.cs, WrapperMap.cs:

	* .cvsignore, AssemblyInfo.cs, AssemblyVersionInfo.cpp,
	  AssemblyVersionInfo.cs, AssemblyVersionInfo.js,
	  AssemblyVersionInfo.vb, ILog.cs, LogManager.cs, MDC.cs, NDC.cs,
	  log4net.csproj, log4net.sln, Appender/AdoNetAppender.cs,
	  Appender/AppenderCollection.cs, Appender/AppenderSkeleton.cs,
	  Appender/AspNetTraceAppender.cs,
	  Appender/BufferingAppenderSkeleton.cs,
	  Appender/BufferingForwardingAppender.cs,
	  Appender/ColoredConsoleAppender.cs, Appender/ConsoleAppender.cs,
	  Appender/CountingAppender.cs, Appender/DebugAppender.cs,
	  Appender/EventLogAppender.cs, Appender/FileAppender.cs,
	  Appender/ForwardingAppender.cs, Appender/IAppender.cs,
	  Appender/MemoryAppender.cs, Appender/NetSendAppender.cs,
	  Appender/OutputDebugStringAppender.cs,
	  Appender/RemotingAppender.cs, Appender/RollingFileAppender.cs,
	  Appender/SmtpAppender.cs, Appender/SmtpPickupDirAppender.cs,
	  Appender/TextWriterAppender.cs, Appender/TraceAppender.cs,
	  Appender/UdpAppender.cs, Config/AliasDomainAttribute.cs,
	  Config/AliasRepositoryAttribute.cs, Config/BasicConfigurator.cs,
	  Config/ConfiguratorAttribute.cs, Config/DOMConfigurator.cs,
	  Config/DOMConfiguratorAttribute.cs, Config/DomainAttribute.cs,
	  Config/Log4NetConfigurationSectionHandler.cs,
	  Config/PluginAttribute.cs, Config/RepositoryAttribute.cs,
	  Config/XmlConfigurator.cs, Config/XmlConfiguratorAttribute.cs,
	  DateFormatter/AbsoluteTimeDateFormatter.cs,
	  DateFormatter/DateTimeDateFormatter.cs,
	  DateFormatter/IDateFormatter.cs,
	  DateFormatter/Iso8601DateFormatter.cs,
	  DateFormatter/SimpleDateFormatter.cs, Filter/DenyAllFilter.cs,
	  Filter/FilterDecision.cs, Filter/FilterSkeleton.cs,
	  Filter/IFilter.cs, Filter/LevelMatchFilter.cs,
	  Filter/LevelRangeFilter.cs, Filter/LoggerMatchFilter.cs,
	  Filter/MdcFilter.cs, Filter/NdcFilter.cs,
	  Filter/StringMatchFilter.cs, Layout/ExceptionLayout.cs,
	  Layout/ILayout.cs, Layout/IRawLayout.cs,
	  Layout/Layout2RawLayoutAdapter.cs, Layout/LayoutSkeleton.cs,
	  Layout/PatternLayout.cs, Layout/RawLayoutConverter.cs,
	  Layout/RawPropertyLayout.cs, Layout/RawTimeStampLayout.cs,
	  Layout/SimpleLayout.cs, Layout/XMLLayout.cs,
	  Layout/XMLLayoutBase.cs, Layout/XmlLayoutSchemaLog4j.cs,
	  Layout/Pattern/AppDomainPatternConverter.cs,
	  Layout/Pattern/DatePatternConverter.cs,
	  Layout/Pattern/FileLocationPatternConverter.cs,
	  Layout/Pattern/FullLocationPatternConverter.cs,
	  Layout/Pattern/IdentityPatternConverter.cs,
	  Layout/Pattern/LevelPatternConverter.cs,
	  Layout/Pattern/LineLocationPatternConverter.cs,
	  Layout/Pattern/LiteralPatternConverter.cs,
	  Layout/Pattern/LoggerPatternConverter.cs,
	  Layout/Pattern/MdcPatternConverter.cs,
	  Layout/Pattern/MessagePatternConverter.cs,
	  Layout/Pattern/MethodLocationPatternConverter.cs,
	  Layout/Pattern/NamedPatternConverter.cs,
	  Layout/Pattern/NdcPatternConverter.cs,
	  Layout/Pattern/NewLinePatternConverter.cs,
	  Layout/Pattern/PatternLayoutConverter.cs,
	  Layout/Pattern/PropertyPatternConverter.cs,
	  Layout/Pattern/RelativeTimePatternConverter.cs,
	  Layout/Pattern/ThreadPatternConverter.cs,
	  Layout/Pattern/TypeNamePatternConverter.cs,
	  Layout/Pattern/UserNamePatternConverter.cs,
	  ObjectRenderer/DefaultRenderer.cs,
	  ObjectRenderer/IObjectRenderer.cs, ObjectRenderer/RendererMap.cs,
	  Plugin/IPlugin.cs, Plugin/IPluginFactory.cs,
	  Plugin/PluginCollection.cs, Plugin/PluginMap.cs,
	  Plugin/PluginSkeleton.cs, Plugin/RemoteLoggingServerPlugin.cs,
	  Repository/IBasicRepositoryConfigurator.cs,
	  Repository/ILoggerRepository.cs,
	  Repository/IXmlRepositoryConfigurator.cs,
	  Repository/LoggerRepositorySkeleton.cs,
	  Repository/Hierarchy/DefaultLoggerFactory.cs,
	  Repository/Hierarchy/Hierarchy.cs,
	  Repository/Hierarchy/ILoggerFactory.cs,
	  Repository/Hierarchy/Logger.cs,
	  Repository/Hierarchy/LoggerKey.cs,
	  Repository/Hierarchy/ProvisionNode.cs,
	  Repository/Hierarchy/RootLogger.cs,
	  Repository/Hierarchy/XmlHierarchyConfigurator.cs,
	  Util/AppenderAttachedImpl.cs, Util/CountingQuietTextWriter.cs,
	  Util/CyclicBuffer.cs, Util/EmptyCollection.cs,
	  Util/EmptyDictionary.cs, Util/FormattingInfo.cs, Util/LogLog.cs,
	  Util/NativeError.cs, Util/NullDictionaryEnumerator.cs,
	  Util/NullEnumerator.cs, Util/OnlyOnceErrorHandler.cs,
	  Util/OptionConverter.cs, Util/PatternConverter.cs,
	  Util/PatternParser.cs, Util/PatternString.cs,
	  Util/PropertiesDictionary.cs, Util/ProtectCloseTextWriter.cs,
	  Util/QuietTextWriter.cs, Util/ReaderWriterLock.cs,
	  Util/ReusableStringWriter.cs, Util/SystemInfo.cs,
	  Util/TextWriterAdapter.cs, Util/Transform.cs,
	  Util/PatternStringConverters/AppDomainPatternConverter.cs,
	  Util/PatternStringConverters/DatePatternConverter.cs,
	  Util/PatternStringConverters/EnvironmentPatternConverter.cs,
	  Util/PatternStringConverters/IdentityPatternConverter.cs,
	  Util/PatternStringConverters/LiteralPatternConverter.cs,
	  Util/PatternStringConverters/NewLinePatternConverter.cs,
	  Util/PatternStringConverters/ProcessIdPatternConverter.cs,
	  Util/PatternStringConverters/UserNamePatternConverter.cs,
	  Util/TypeConverters/BooleanConverter.cs,
	  Util/TypeConverters/ConversionNotSupportedException.cs,
	  Util/TypeConverters/ConverterRegistry.cs,
	  Util/TypeConverters/EncodingConverter.cs,
	  Util/TypeConverters/IConvertFrom.cs,
	  Util/TypeConverters/IConvertTo.cs,
	  Util/TypeConverters/PatternStringConverter.cs,
	  Util/TypeConverters/TypeConverterAttribute.cs:

	Initial checkin

=============================================================================
log4net moved to Apache
=============================================================================

2004-01-26 05:12  ncadell

	* ILog.cs, LogManager.cs, log4net.csproj,
	Appender/AppenderSkeleton.cs, Appender/AspNetTraceAppender.cs,
	Appender/ColoredConsoleAppender.cs, Appender/ConsoleAppender.cs,
	Appender/EventLogAppender.cs, Appender/FileAppender.cs,
	Appender/MemoryAppender.cs, Appender/RollingFileAppender.cs,
	Appender/SmtpAppender.cs, Appender/TextWriterAppender.cs,
	Appender/UdpAppender.cs, Config/BasicConfigurator.cs,
	Core/CompactRepositorySelector.cs,
	Core/DefaultRepositorySelector.cs, Core/ErrorCode.cs,
	Core/ErrorCodes.cs, Core/IErrorHandler.cs, Core/Level.cs,
	Core/LevelEvaluator.cs, Core/LogImpl.cs, Core/LoggerManager.cs,
	Core/LoggingEvent.cs, DateFormatter/AbsoluteTimeDateFormatter.cs,
	Filter/DenyAllFilter.cs, Filter/FilterDecision.cs,
	Filter/FilterSkeleton.cs, Filter/IFilter.cs,
	Filter/LevelMatchFilter.cs, Filter/LevelRangeFilter.cs,
	Filter/LoggerMatchFilter.cs, Filter/MdcFilter.cs,
	Filter/NdcFilter.cs, Filter/StringMatchFilter.cs,
	Layout/PatternLayout.cs, Layout/Pattern/DatePatternConverter.cs,
	Repository/ILoggerRepository.cs,
	Repository/LoggerRepositorySkeleton.cs,
	Repository/Hierarchy/Hierarchy.cs, Repository/Hierarchy/Logger.cs,
	Util/CountingQuietTextWriter.cs, Util/OnlyOnceErrorHandler.cs,
	Util/PatternParser.cs, Util/PropertiesCollection.cs,
	Util/PropertiesDictionary.cs, Util/QuietTextWriter.cs,
	Util/TextWriterAdapter.cs,
	Util/PatternStringConverters/DatePatternConverter.cs:

	Updated code inline with FxCop recommendations.
	Lots of changes to member casing. Changed properties to methods when
	returning an array.
	
2004-01-26 03:00  ncadell

	* MDC.cs, log4net.csproj, Appender/AdoNetAppender.cs,
	Appender/AppenderSkeleton.cs,
	Appender/BufferingAppenderSkeleton.cs,
	Appender/BufferingForwardingAppender.cs,
	Appender/EventLogAppender.cs, Appender/FileAppender.cs,
	Appender/ForwardingAppender.cs, Appender/NetSendAppender.cs,
	Appender/RemotingAppender.cs, Appender/RollingFileAppender.cs,
	Appender/SmtpAppender.cs, Appender/SmtpPickupDirAppender.cs,
	Appender/TextWriterAppender.cs, Appender/UdpAppender.cs,
	Config/BasicConfigurator.cs, Config/DOMConfigurator.cs,
	Config/DOMConfiguratorAttribute.cs, Config/PluginAttribute.cs,
	Config/XmlConfigurator.cs, Config/XmlConfiguratorAttribute.cs,
	Core/DefaultRepositorySelector.cs, Core/LevelMap.cs,
	Core/LocationInfo.cs, Core/LoggerManager.cs, Core/LoggingEvent.cs,
	Filter/LevelMatchFilter.cs, Filter/LevelRangeFilter.cs,
	Filter/LoggerMatchFilter.cs, Filter/MdcFilter.cs,
	Filter/NdcFilter.cs, Filter/StringMatchFilter.cs,
	Layout/ExceptionLayout.cs, Layout/IRawLayout.cs,
	Layout/PatternLayout.cs, Layout/RawLayoutConverter.cs,
	Layout/RawPropertyLayout.cs, Layout/RawTimeStampLayout.cs,
	Layout/SimpleLayout.cs, Layout/XMLLayout.cs,
	Layout/XMLLayoutBase.cs, Layout/XmlLayoutSchemaLog4j.cs,
	Layout/Pattern/DatePatternConverter.cs,
	Layout/Pattern/LiteralPatternConverter.cs,
	Layout/Pattern/NamedPatternConverter.cs,
	Layout/Pattern/NewLinePatternConverter.cs,
	Layout/Pattern/PatternLayoutConverter.cs,
	ObjectRenderer/DefaultRenderer.cs, ObjectRenderer/RendererMap.cs,
	Plugin/PluginMap.cs, Plugin/RemoteLoggingServerPlugin.cs,
	Repository/ILoggerRepository.cs,
	Repository/LoggerRepositorySkeleton.cs,
	Repository/Hierarchy/Hierarchy.cs, Repository/Hierarchy/Logger.cs,
	Repository/Hierarchy/RootLogger.cs,
	Repository/Hierarchy/XmlHierarchyConfigurator.cs,
	Util/AppenderAttachedImpl.cs, Util/CountingQuietTextWriter.cs,
	Util/CyclicBuffer.cs, Util/EmptyCollection.cs,
	Util/EmptyDictionary.cs, Util/FormattingInfo.cs, Util/LogLog.cs,
	Util/NativeError.cs, Util/NullDictionaryEnumerator.cs,
	Util/NullEnumerator.cs, Util/OnlyOnceErrorHandler.cs,
	Util/OptionConverter.cs, Util/PatternConverter.cs,
	Util/PatternParser.cs, Util/PatternString.cs,
	Util/PropertiesCollection.cs, Util/ProtectCloseTextWriter.cs,
	Util/QuietTextWriter.cs, Util/ReaderWriterLock.cs,
	Util/ReusableStringWriter.cs, Util/SystemInfo.cs,
	Util/TextWriterAdapter.cs, Util/Transform.cs,
	Util/PatternStringConverters/AppDomainPatternConverter.cs,
	Util/PatternStringConverters/DatePatternConverter.cs,
	Util/PatternStringConverters/EnvironmentPatternConverter.cs,
	Util/PatternStringConverters/IdentityPatternConverter.cs,
	Util/PatternStringConverters/LiteralPatternConverter.cs,
	Util/PatternStringConverters/NewLinePatternConverter.cs,
	Util/PatternStringConverters/ProcessIdPatternConverter.cs,
	Util/PatternStringConverters/UserNamePatternConverter.cs,
	Util/TypeConverters/BooleanConverter.cs,
	Util/TypeConverters/ConversionNotSupportedException.cs,
	Util/TypeConverters/ConverterRegistry.cs,
	Util/TypeConverters/EncodingConverter.cs,
	Util/TypeConverters/IConvertFrom.cs,
	Util/TypeConverters/IConvertTo.cs,
	Util/TypeConverters/PatternStringConverter.cs,
	Util/TypeConverters/TypeConverterAttribute.cs,
	helpers/AppenderAttachedImpl.cs,
	helpers/CountingQuietTextWriter.cs, helpers/CyclicBuffer.cs,
	helpers/EmptyCollection.cs, helpers/EmptyDictionary.cs,
	helpers/FormattingInfo.cs, helpers/LogLog.cs,
	helpers/NativeError.cs, helpers/NullDictionaryEnumerator.cs,
	helpers/NullEnumerator.cs, helpers/OnlyOnceErrorHandler.cs,
	helpers/OptionConverter.cs, helpers/PatternConverter.cs,
	helpers/PatternParser.cs, helpers/PatternString.cs,
	helpers/PropertiesCollection.cs, helpers/ProtectCloseTextWriter.cs,
	helpers/QuietTextWriter.cs, helpers/ReaderWriterLock.cs,
	helpers/ReusableStringWriter.cs, helpers/SystemInfo.cs,
	helpers/TextWriterAdapter.cs, helpers/Transform.cs,
	helpers/PatternStringConverters/AppDomainPatternConverter.cs,
	helpers/PatternStringConverters/DatePatternConverter.cs,
	helpers/PatternStringConverters/EnvironmentPatternConverter.cs,
	helpers/PatternStringConverters/IdentityPatternConverter.cs,
	helpers/PatternStringConverters/LiteralPatternConverter.cs,
	helpers/PatternStringConverters/NewLinePatternConverter.cs,
	helpers/PatternStringConverters/ProcessIdPatternConverter.cs,
	helpers/PatternStringConverters/UserNamePatternConverter.cs,
	helpers/TypeConverters/BooleanConverter.cs,
	helpers/TypeConverters/ConversionNotSupportedException.cs,
	helpers/TypeConverters/ConverterRegistry.cs,
	helpers/TypeConverters/EncodingConverter.cs,
	helpers/TypeConverters/IConvertFrom.cs,
	helpers/TypeConverters/IConvertTo.cs,
	helpers/TypeConverters/PatternStringConverter.cs,
	helpers/TypeConverters/TypeConverterAttribute.cs:

	Renamed log4net.helpers namespace to log4net.Util
	
2004-01-26 02:51  ncadell

	* ILog.cs, LogManager.cs, log4net.csproj,
	Appender/AdoNetAppender.cs, Appender/AppenderSkeleton.cs,
	Appender/AspNetTraceAppender.cs,
	Appender/BufferingAppenderSkeleton.cs,
	Appender/BufferingForwardingAppender.cs,
	Appender/ColoredConsoleAppender.cs, Appender/ConsoleAppender.cs,
	Appender/CountingAppender.cs, Appender/DebugAppender.cs,
	Appender/EventLogAppender.cs, Appender/FileAppender.cs,
	Appender/ForwardingAppender.cs, Appender/IAppender.cs,
	Appender/MemoryAppender.cs, Appender/NetSendAppender.cs,
	Appender/OutputDebugStringAppender.cs,
	Appender/RemotingAppender.cs, Appender/RollingFileAppender.cs,
	Appender/SmtpAppender.cs, Appender/SmtpPickupDirAppender.cs,
	Appender/TextWriterAppender.cs, Appender/TraceAppender.cs,
	Appender/UdpAppender.cs, Config/BasicConfigurator.cs,
	Config/PluginAttribute.cs, Core/CompactRepositorySelector.cs,
	Core/DefaultRepositorySelector.cs, Core/ErrorCodes.cs,
	Core/IAppenderAttachable.cs, Core/IErrorHandler.cs,
	Core/ILogger.cs, Core/ILoggerWrapper.cs, Core/IOptionHandler.cs,
	Core/IRepositorySelector.cs, Core/ITriggeringEventEvaluator.cs,
	Core/Level.cs, Core/LevelCollection.cs, Core/LevelEvaluator.cs,
	Core/LevelMap.cs, Core/LocationInfo.cs, Core/LogException.cs,
	Core/LogImpl.cs, Core/LoggerManager.cs, Core/LoggerWrapperImpl.cs,
	Core/LoggingEvent.cs, Core/WrapperMap.cs, Filter/DenyAllFilter.cs,
	Filter/FilterSkeleton.cs, Filter/IFilter.cs,
	Filter/LevelMatchFilter.cs, Filter/LevelRangeFilter.cs,
	Filter/LoggerMatchFilter.cs, Filter/MdcFilter.cs,
	Filter/NdcFilter.cs, Filter/StringMatchFilter.cs,
	Layout/ExceptionLayout.cs, Layout/ILayout.cs, Layout/IRawLayout.cs,
	Layout/Layout2RawLayoutAdapter.cs, Layout/LayoutSkeleton.cs,
	Layout/PatternLayout.cs, Layout/RawLayoutConverter.cs,
	Layout/RawPropertyLayout.cs, Layout/RawTimeStampLayout.cs,
	Layout/SimpleLayout.cs, Layout/XMLLayout.cs,
	Layout/XMLLayoutBase.cs, Layout/XmlLayoutSchemaLog4j.cs,
	Layout/Pattern/AppDomainPatternConverter.cs,
	Layout/Pattern/DatePatternConverter.cs,
	Layout/Pattern/FileLocationPatternConverter.cs,
	Layout/Pattern/FullLocationPatternConverter.cs,
	Layout/Pattern/IdentityPatternConverter.cs,
	Layout/Pattern/LevelPatternConverter.cs,
	Layout/Pattern/LineLocationPatternConverter.cs,
	Layout/Pattern/LiteralPatternConverter.cs,
	Layout/Pattern/LoggerPatternConverter.cs,
	Layout/Pattern/MdcPatternConverter.cs,
	Layout/Pattern/MessagePatternConverter.cs,
	Layout/Pattern/MethodLocationPatternConverter.cs,
	Layout/Pattern/NamedPatternConverter.cs,
	Layout/Pattern/NdcPatternConverter.cs,
	Layout/Pattern/NewLinePatternConverter.cs,
	Layout/Pattern/PatternLayoutConverter.cs,
	Layout/Pattern/PropertyPatternConverter.cs,
	Layout/Pattern/RelativeTimePatternConverter.cs,
	Layout/Pattern/ThreadPatternConverter.cs,
	Layout/Pattern/TypeNamePatternConverter.cs,
	Layout/Pattern/UserNamePatternConverter.cs,
	Plugin/RemoteLoggingServerPlugin.cs,
	Repository/ILoggerRepository.cs,
	Repository/LoggerRepositorySkeleton.cs,
	Repository/Hierarchy/DefaultLoggerFactory.cs,
	Repository/Hierarchy/Hierarchy.cs, Repository/Hierarchy/Logger.cs,
	Repository/Hierarchy/RootLogger.cs,
	Repository/Hierarchy/XmlHierarchyConfigurator.cs,
	helpers/AppenderAttachedImpl.cs,
	helpers/CountingQuietTextWriter.cs, helpers/CyclicBuffer.cs,
	helpers/OnlyOnceErrorHandler.cs, helpers/OptionConverter.cs,
	helpers/PatternConverter.cs, helpers/PatternParser.cs,
	helpers/PatternString.cs, helpers/ProtectCloseTextWriter.cs,
	helpers/QuietTextWriter.cs,
	helpers/PatternStringConverters/DatePatternConverter.cs,
	helpers/PatternStringConverters/EnvironmentPatternConverter.cs,
	helpers/PatternStringConverters/NewLinePatternConverter.cs,
	spi/CompactRepositorySelector.cs, spi/DefaultRepositorySelector.cs,
	spi/ErrorCodes.cs, spi/IAppenderAttachable.cs,
	spi/IErrorHandler.cs, spi/ILogger.cs, spi/ILoggerWrapper.cs,
	spi/IOptionHandler.cs, spi/IRepositorySelector.cs,
	spi/ITriggeringEventEvaluator.cs, spi/Level.cs,
	spi/LevelCollection.cs, spi/LevelEvaluator.cs, spi/LevelMap.cs,
	spi/LocationInfo.cs, spi/LogException.cs, spi/LogImpl.cs,
	spi/LoggerManager.cs, spi/LoggerWrapperImpl.cs,
	spi/LoggingEvent.cs, spi/WrapperMap.cs:

	Renamed log4net.spi namespace to log4net.Core
	
2004-01-26 02:42  ncadell

	* Appender/ASPNetTraceAppender.cs, Appender/AspNetTraceAppender.cs,
	Appender/SMTPAppender.cs, Appender/SmtpAppender.cs,
	DateFormatter/ISO8601DateFormatter.cs,
	DateFormatter/Iso8601DateFormatter.cs, Filter/MDCFilter.cs,
	Filter/MdcFilter.cs, Filter/NdcFilter.cs, Filter/NDCFilter.cs:

	Fixed pascal casing
	
	* Appender/ADONetAppender.cs:

	Fixed pascal case
	
	* Appender/AdoNetAppender.cs:

	Fixed pascal casing
	
	* log4net.csproj, Appender/ASPNetTraceAppender.cs,
	Appender/SMTPAppender.cs, DateFormatter/ISO8601DateFormatter.cs,
	Filter/MDCFilter.cs, Filter/NDCFilter.cs, Layout/PatternLayout.cs,
	Layout/Pattern/DatePatternConverter.cs,
	helpers/PatternStringConverters/DatePatternConverter.cs:

	Fixed pascal casing of classes
	
2004-01-26 02:14  ncadell

	* Layout/ExceptionLayout.cs:

	Fixed doc
	
	* Appender/: ADONetAppender.cs, BufferingAppenderSkeleton.cs:

	Fixed pascal casing of AdoNetAppender
	
	* Appender/ADONetAppender.cs:

	Fixed pascal casing of ADONetAppender
	
	* log4net.csproj, Config/DOMConfigurator.cs,
	Config/DOMConfiguratorAttribute.cs, Config/XmlConfigurator.cs,
	Config/XmlConfiguratorAttribute.cs,
	Repository/IDOMRepositoryConfigurator.cs,
	Repository/IXmlRepositoryConfigurator.cs,
	Repository/Hierarchy/DOMHierarchyConfigurator.cs,
	Repository/Hierarchy/Hierarchy.cs,
	Repository/Hierarchy/XmlHierarchyConfigurator.cs:

	Obsoleted DOMConfigurator, replaced with XmlConfigurator.
	Replaced DOMConfiguratorAttribute with XmlConfiguratorAttribute.
	Replaced DOMHierarchyConfigurator with XmlHierarchyConfigurator.
	
2004-01-26 01:46  ncadell

	* LogManager.cs, log4net.csproj, Config/AliasDomainAttribute.cs,
	Config/AliasRepositoryAttribute.cs, Config/DomainAttribute.cs,
	Config/RepositoryAttribute.cs, spi/DefaultRepositorySelector.cs,
	spi/LoggerManager.cs:

	Obsoleted use of term "Domain" or "logging domain".
	Added RepositoryAttribute and AliasRepositoryAttribute attributes.
	Obsoleted DomainAttribute and AliasDomainAttribute.
	Obsoleted CreateDomain methods in LogManager and LoggerManager
	replaced with CreateRepository methods.
	
2004-01-26 00:36  ncadell

	* Appender/RemotingAppender.cs:

	Changed to send events using a pool thread rather than the caller's
	thread. This fixes a side effect caused by the remoting framework
	that could cause loss of data in the CallContext.
	
	* Appender/FileAppender.cs:

	Changed to check if directory exists before creating it.
	
	* Appender/: UdpAppender.cs, SmtpPickupDirAppender.cs,
	SMTPAppender.cs:

	Changed hostname property to log4net:HostName
	
	* Appender/TraceAppender.cs:

	Updated documentation
	Changed to pass the logger name as the Trace category.
	
	* Appender/DebugAppender.cs:

	Updated documentation.
	Changed to pass the logger name as the debug category.
	
	* AssemblyInfo.cs:

	Added AllowPartiallyTrustedCallers attribute to the assembly. This
	allows partially trusted callers to call a strongly named log4net assembly.
	
2004-01-17 19:40  ncadell

	* log4net.csproj, Filter/LoggerMatchFilter.cs:

	Added LoggerMatchFilter. This filter does a StartsWith match against
	the event's logger name.
	
	* Appender/ColoredConsoleAppender.cs:

	Console colors are restored between appends so that any additional
	Console.Write uses the default colors.
	Added doc comments.
	
	* Appender/: ADONetAppender.cs, AppenderSkeleton.cs,
	BufferingAppenderSkeleton.cs, BufferingForwardingAppender.cs,
	DebugAppender.cs, ForwardingAppender.cs, TextWriterAppender.cs,
	TraceAppender.cs, UdpAppender.cs:

	Changed IsAsSevereAsThreshold and OnClose from public to virtual
	protected. These should not be exposed in the appender's public interface.
	This change breaks appenders that override the OnClose method.
	
2004-01-13 03:13  ncadell

	* ILog.cs, LogManager.cs, MDC.cs, NDC.cs,
	Appender/ADONetAppender.cs, Appender/ASPNetTraceAppender.cs,
	Appender/AppenderCollection.cs, Appender/AppenderSkeleton.cs,
	Appender/BufferingAppenderSkeleton.cs,
	Appender/BufferingForwardingAppender.cs,
	Appender/ColoredConsoleAppender.cs, Appender/ConsoleAppender.cs,
	Appender/CountingAppender.cs, Appender/DebugAppender.cs,
	Appender/EventLogAppender.cs, Appender/FileAppender.cs,
	Appender/ForwardingAppender.cs, Appender/IAppender.cs,
	Appender/MemoryAppender.cs, Appender/NetSendAppender.cs,
	Appender/OutputDebugStringAppender.cs,
	Appender/RemotingAppender.cs, Appender/RollingFileAppender.cs,
	Appender/SMTPAppender.cs, Appender/SmtpPickupDirAppender.cs,
	Appender/TextWriterAppender.cs, Appender/TraceAppender.cs,
	Appender/UdpAppender.cs, Config/AliasDomainAttribute.cs,
	Config/BasicConfigurator.cs, Config/ConfiguratorAttribute.cs,
	Config/DOMConfigurator.cs, Config/DOMConfiguratorAttribute.cs,
	Config/DomainAttribute.cs,
	Config/Log4NetConfigurationSectionHandler.cs,
	Config/PluginAttribute.cs,
	DateFormatter/AbsoluteTimeDateFormatter.cs,
	DateFormatter/DateTimeDateFormatter.cs,
	DateFormatter/IDateFormatter.cs,
	DateFormatter/ISO8601DateFormatter.cs,
	DateFormatter/SimpleDateFormatter.cs, Filter/DenyAllFilter.cs,
	Filter/FilterSkeleton.cs, Filter/IFilter.cs,
	Filter/LevelMatchFilter.cs, Filter/LevelRangeFilter.cs,
	Filter/MDCFilter.cs, Filter/NDCFilter.cs,
	Filter/StringMatchFilter.cs, Layout/ExceptionLayout.cs,
	Layout/ILayout.cs, Layout/IRawLayout.cs,
	Layout/Layout2RawLayoutAdapter.cs, Layout/LayoutSkeleton.cs,
	Layout/PatternLayout.cs, Layout/RawLayoutConverter.cs,
	Layout/RawPropertyLayout.cs, Layout/RawTimeStampLayout.cs,
	Layout/SimpleLayout.cs, Layout/XMLLayout.cs,
	Layout/XMLLayoutBase.cs, Layout/XmlLayoutSchemaLog4j.cs,
	Layout/Pattern/AppDomainPatternConverter.cs,
	Layout/Pattern/DatePatternConverter.cs,
	Layout/Pattern/FileLocationPatternConverter.cs,
	Layout/Pattern/FullLocationPatternConverter.cs,
	Layout/Pattern/IdentityPatternConverter.cs,
	Layout/Pattern/LevelPatternConverter.cs,
	Layout/Pattern/LineLocationPatternConverter.cs,
	Layout/Pattern/LiteralPatternConverter.cs,
	Layout/Pattern/LoggerPatternConverter.cs,
	Layout/Pattern/MdcPatternConverter.cs,
	Layout/Pattern/MessagePatternConverter.cs,
	Layout/Pattern/MethodLocationPatternConverter.cs,
	Layout/Pattern/NamedPatternConverter.cs,
	Layout/Pattern/NdcPatternConverter.cs,
	Layout/Pattern/NewLinePatternConverter.cs,
	Layout/Pattern/PatternLayoutConverter.cs,
	Layout/Pattern/PropertyPatternConverter.cs,
	Layout/Pattern/RelativeTimePatternConverter.cs,
	Layout/Pattern/ThreadPatternConverter.cs,
	Layout/Pattern/TypeNamePatternConverter.cs,
	Layout/Pattern/UserNamePatternConverter.cs,
	ObjectRenderer/DefaultRenderer.cs,
	ObjectRenderer/IObjectRenderer.cs, ObjectRenderer/RendererMap.cs,
	Plugin/IPlugin.cs, Plugin/IPluginFactory.cs,
	Plugin/PluginCollection.cs, Plugin/PluginMap.cs,
	Plugin/PluginSkeleton.cs, Plugin/RemoteLoggingServerPlugin.cs,
	Repository/IBasicRepositoryConfigurator.cs,
	Repository/IDOMRepositoryConfigurator.cs,
	Repository/ILoggerRepository.cs,
	Repository/LoggerRepositorySkeleton.cs,
	Repository/Hierarchy/DOMHierarchyConfigurator.cs,
	Repository/Hierarchy/DefaultLoggerFactory.cs,
	Repository/Hierarchy/Hierarchy.cs,
	Repository/Hierarchy/ILoggerFactory.cs,
	Repository/Hierarchy/Logger.cs, Repository/Hierarchy/LoggerKey.cs,
	Repository/Hierarchy/ProvisionNode.cs,
	Repository/Hierarchy/RootLogger.cs,
	helpers/AppenderAttachedImpl.cs,
	helpers/CountingQuietTextWriter.cs, helpers/CyclicBuffer.cs,
	helpers/EmptyCollection.cs, helpers/EmptyDictionary.cs,
	helpers/FormattingInfo.cs, helpers/LogLog.cs,
	helpers/NativeError.cs, helpers/NullDictionaryEnumerator.cs,
	helpers/NullEnumerator.cs, helpers/OnlyOnceErrorHandler.cs,
	helpers/OptionConverter.cs, helpers/PatternConverter.cs,
	helpers/PatternParser.cs, helpers/PatternString.cs,
	helpers/PropertiesCollection.cs, helpers/ProtectCloseTextWriter.cs,
	helpers/QuietTextWriter.cs, helpers/ReaderWriterLock.cs,
	helpers/ReusableStringWriter.cs, helpers/SystemInfo.cs,
	helpers/TextWriterAdapter.cs, helpers/Transform.cs,
	helpers/PatternStringConverters/AppDomainPatternConverter.cs,
	helpers/PatternStringConverters/DatePatternConverter.cs,
	helpers/PatternStringConverters/EnvironmentPatternConverter.cs,
	helpers/PatternStringConverters/IdentityPatternConverter.cs,
	helpers/PatternStringConverters/LiteralPatternConverter.cs,
	helpers/PatternStringConverters/NewLinePatternConverter.cs,
	helpers/PatternStringConverters/UserNamePatternConverter.cs,
	helpers/TypeConverters/BooleanConverter.cs,
	helpers/TypeConverters/ConversionNotSupportedException.cs,
	helpers/TypeConverters/ConverterRegistry.cs,
	helpers/TypeConverters/EncodingConverter.cs,
	helpers/TypeConverters/IConvertFrom.cs,
	helpers/TypeConverters/IConvertTo.cs,
	helpers/TypeConverters/PatternStringConverter.cs,
	helpers/TypeConverters/TypeConverterAttribute.cs,
	spi/CompactRepositorySelector.cs, spi/DefaultRepositorySelector.cs,
	spi/ErrorCodes.cs, spi/IAppenderAttachable.cs,
	spi/IErrorHandler.cs, spi/ILogger.cs, spi/ILoggerWrapper.cs,
	spi/IOptionHandler.cs, spi/IRepositorySelector.cs,
	spi/ITriggeringEventEvaluator.cs, spi/Level.cs,
	spi/LevelCollection.cs, spi/LevelEvaluator.cs, spi/LevelMap.cs,
	spi/LocationInfo.cs, spi/LogException.cs, spi/LogImpl.cs,
	spi/LoggerManager.cs, spi/LoggerWrapperImpl.cs,
	spi/LoggingEvent.cs, spi/WrapperMap.cs:

	Added <author> tags
	
	* log4net.csproj,
	helpers/PatternStringConverters/ProcessIdPatternConverter.cs:

	Added ProcessIdPatternConverter
	
2003-10-16 14:30  ncadell

	* ObjectRenderer/RendererMap.cs:

	Changed RendererMap to display full stack trace when an internal error
	occurs during a render operation.
	
2003-10-02 23:52  ncadell

	* log4net.csproj:

	Added PatternString
	
	* helpers/: PatternStringConverters/AppDomainPatternConverter.cs,
	PatternStringConverters/DatePatternConverter.cs,
	PatternStringConverters/EnvironmentPatternConverter.cs,
	PatternStringConverters/IdentityPatternConverter.cs,
	PatternStringConverters/LiteralPatternConverter.cs,
	PatternStringConverters/NewLinePatternConverter.cs,
	PatternStringConverters/UserNamePatternConverter.cs,
	PatternString.cs, TypeConverters/PatternStringConverter.cs:

	Adding PatternString
	
2003-08-17 19:30  ncadell

	* helpers/PatternParser.cs:

	FxCop. Specified number format info and culture info.
	
	* helpers/TextWriterAdapter.cs:

	Added Writer property
	
	* helpers/ProtectCloseTextWriter.cs:

	Changed to use Writer property rather than m_writer field directly
	
	* helpers/PatternConverter.cs:

	Made m_option private, use the Option property to get or set the value.
	
	* helpers/OptionConverter.cs:

	Added support for IConvertTo type converters
	
	* Layout/Pattern/: DatePatternConverter.cs,
	LiteralPatternConverter.cs, MdcPatternConverter.cs,
	NamedPatternConverter.cs, NewLinePatternConverter.cs,
	PropertyPatternConverter.cs:

	Changed to use Option property rather than m_option field.
	
	* Layout/PatternLayout.cs:

	Fixed PatternLayoutShim protection level
	
	* Appender/SMTPAppender.cs:

	FxCop. Specified culture info to StringWriter
	
	* Appender/TraceAppender.cs:

	Fixed spelling mistake
	
	* spi/LoggingEvent.cs:

	FxCop. Changed to specify the culture info to StringWriters
	
	* helpers/TypeConverters/: ConverterRegistry.cs, IConvertTo.cs,
	TypeConverterAttribute.cs:

	Updated type converters to support IConvertTo as well as IConvertFrom
	
	* Appender/DebugAppender.cs:

	Added debug appender
	
2003-08-03 23:29  ncadell

	* log4net.csproj:

	Added pattern converters.
	
	* Layout/PatternLayout.cs:

	Updated to write to a TextWriter.
	Changed to use new PatternParser, generates converter registry.
	Updated documentation to include long pattern names.
	
	* helpers/: PatternConverter.cs, PatternParser.cs:

	Changed PatternParser to parse long patterns. Patterns are stored in
	a registry that is external to the parser.
	Changed the PatternConverter to convert any state object not only a
	LoggingEvent object.
	
	* Layout/Pattern/: AppDomainPatternConverter.cs,
	DatePatternConverter.cs, FileLocationPatternConverter.cs,
	FullLocationPatternConverter.cs, IdentityPatternConverter.cs,
	LevelPatternConverter.cs, LineLocationPatternConverter.cs,
	LiteralPatternConverter.cs, LoggerPatternConverter.cs,
	MdcPatternConverter.cs, MessagePatternConverter.cs,
	MethodLocationPatternConverter.cs, NamedPatternConverter.cs,
	NdcPatternConverter.cs, NewLinePatternConverter.cs,
	PatternLayoutConverter.cs, PropertyPatternConverter.cs,
	RelativeTimePatternConverter.cs, ThreadPatternConverter.cs,
	TypeNamePatternConverter.cs, UserNamePatternConverter.cs:

	Added pattern converter classes.
	
	* Appender/ADONetAppender.cs:

	Added documentation for using the Oracle provider.
	
	* ObjectRenderer/: DefaultRenderer.cs, IObjectRenderer.cs,
	RendererMap.cs:

	Changed IObjectRenderer to render to a TextWriter rather than returning
	a new string object.
	
	* Layout/SimpleLayout.cs:

	Updated to write the logging event message to a writer
	
	* spi/LoggingEvent.cs:

	Added constructor that takes the repository and fullNameOfLoggerClass.
	Added Repository property to get the ILoggerRepository that this event
	was generated in.
	Updated to use IObjectRenderer taking a TextWriter.
	
	* DateFormatter/: AbsoluteTimeDateFormatter.cs, IDateFormatter.cs,
	SimpleDateFormatter.cs:

	Changed IDateFormatter to write to a TextWriter rather than returning
	a new string.
	
	* helpers/FormattingInfo.cs:

	Added new constructor that takes formatting info settings.
	Changed default min and max values to be Int32.MinValue and MaxValue.
	
	* spi/LocationInfo.cs:

	Added check for fullNameOfCallingClass being null or empty. In that case
	the location information is not generated.
	
	* helpers/PropertiesCollection.cs:

	Added support for the IDictionary interface to the PropertiesCollection.
	
	* Layout/RawPropertyLayout.cs:

	Added RawPropertyLayout. Returns the object value of a property.
	
2003-07-31 18:33  drieseng

	* helpers/PropertiesCollection.cs, spi/LoggingEvent.cs:

	SecurityPermissionAttribute class is now available in Mono (cvs)
	
	* Config/DOMConfigurator.cs:

	XmlValidatingReader is now partially implemented in Mono
	
2003-07-31 05:54  drieseng

	* Plugin/RemoteLoggingServerPlugin.cs:

	undo temporary work around for mono bug #45520 : use the fully qualified 
	type name to refer to log4net.Appender.RemotingAppender.IRemoteLoggingSink, 
	instead of using alias.
	
	This issue has now been fixed in Mono (cvs) and will be available in 
	Mono 0.26
	
2003-07-20 19:56  ncadell

	* Appender/ADONetAppender.cs, Appender/AppenderSkeleton.cs,
	Appender/SMTPAppender.cs, Appender/SmtpPickupDirAppender.cs,
	Appender/TextWriterAppender.cs, Layout/ExceptionLayout.cs,
	Layout/ILayout.cs, Layout/Layout2RawLayoutAdapter.cs,
	Layout/LayoutSkeleton.cs, Layout/PatternLayout.cs,
	Layout/SimpleLayout.cs, Layout/XMLLayoutBase.cs:

	Changed ILayout. Added Format(TextWriter, LoggingEvent) method. Marked as
	obsolete the Format(LoggingEvent) method. Having the layouts write into
	a caller supplied TextWriter will reduce the number of buffers and copies
	required in some cases (e.g. FileAppender).
	
	Updated all layouts to write to a TextWriter. Updated Appenders to pass
	TextWriter when rendering the event.
	
	* helpers/CountingQuietTextWriter.cs:

	Changed to use the Encoding property on this instance rather than the
	Writer.Encoding property. Encoding is correctly forwarded to the
	underlying writer.
	
	* helpers/QuietTextWriter.cs:

	Changed to use TextWriterAdapter base class. Now the QuietTextWriter
	is a TextWriter.
	
	* log4net.csproj:

	Added new classes
	
	* helpers/ReusableStringWriter.cs:

	Added ReusableStringWriter. This class extends StringWriter and adds
	a Reset method that allows the writer to reuse its internal buffers.
	This allows the StringWriter to be reused rather than recreated.
	
	* helpers/ProtectCloseTextWriter.cs:

	Added ProtectCloseTextWriter. This class is a TextWriterAdapter that 
	ignores	the Close method, i.e it forwards all messages to another 
	TextWriter except the Close message.
	
	* helpers/TextWriterAdapter.cs:

	Added TextWriterAdapter. This class is a TextWriter that forwards all
	messages to a separate TextWriter instance.
	
2003-07-19 18:07  ncadell

	* log4net.csproj, Repository/Hierarchy/Logger.cs,
	helpers/ReaderWriterLock.cs:

	Added ReaderWriterLock class that implements a multiple reader single
	writer lock abstraction for multiple platforms.
	Logger uses this lock to protect its appender list, this should increase
	multithreaded throughput.
	
2003-07-17 12:07  ncadell

	* Layout/PatternLayout.cs, spi/LocationInfo.cs,
	spi/LoggingEvent.cs:

	Added documentation on when the caller location information is available
	
2003-07-15 17:59  drieseng

	* spi/DefaultRepositorySelector.cs:

	xml doc updates
	
	* spi/LocationInfo.cs:

	- xml doc updates
	- code restructure
	
	* spi/Level.cs:

	implement IComparable (was already implemented but was not in the class
	signature)
	xml doc updates
	code restructure
	
2003-07-14 18:52  ncadell

	* AssemblyVersionInfo.cpp, AssemblyVersionInfo.cs,
	AssemblyVersionInfo.js, AssemblyVersionInfo.vb:

	Updated version number to 1.2.0.30714
	
2003-07-14 09:14  ncadell

	* log4net.csproj:

	Added file Layout\XmlLayoutSchemaLog4j.cs
	

=============================================================================
Version 1.2.0 BETA 8
=============================================================================


2003-07-14 10:14  ncadell

	* log4net.csproj:

	Added file Layout\XmlLayoutSchemaLog4j.cs
	
	* Layout/XmlLayoutSchemaLog4j.cs:

	Added XmlLayoutSchemaLog4j class. This layout generates XML events that
	comply with the log4j dtd.
	
	* Layout/XMLLayout.cs:

	Renamed class XMLLayout to XmlLayout.
	Added 3 additional attributes to the event element:
	domain, identity, and username.
	
	* Layout/XMLLayoutBase.cs:

	Renamed class XMLLayoutBase to XmlLayoutBase
	
	* Appender/UdpAppender.cs:

	Removed requirement to set LocalPort property. This is now optional.
	Simplified example receivers, made non multicast.
	Added Encoding property to allow the packet encoding of the string
	event data to be specified.
	Set the logging event Property HostNameProperty to the current machine's
	host name (unless already set) in line with other remotable appenders.
	
	* spi/LoggingEvent.cs:

	Changed the implementation of the Domain property to lookup the
	value using the SystemInfo.ApplicationFriendlyName property.
	This is cached per app domain so should make this a 1 time hit only.
	Added Domain to the list of Partial fixes because of this speedup.
	Added well known keys into the logging event Properties collection:
	HostNameProperty, IdentityProperty, and UserNameProperty.
	
	* Appender/: RemotingAppender.cs, SMTPAppender.cs,
	SmtpPickupDirAppender.cs:

	Changed to use SystemInfo.HostName property rather than calculating
	the hostname.
	
	* helpers/SystemInfo.cs:

	Added HostName and ApplicationFriendlyName properties
	
2003-07-08 02:18  ncadell

	* Appender/BufferingAppenderSkeleton.cs,
	Appender/MemoryAppender.cs, spi/LoggingEvent.cs:

	Added new property (Fix) for specifying the fields in the event that
	should be fixed. This uses an enum that allows fine grained control
	over which fields are fixed.
	
	* Appender/SMTPAppender.cs:

	Obsoleted the LocationInfo property which is no longer used. The
	buffering base class provides all the necessary functionality.
	
	* Appender/SmtpPickupDirAppender.cs:

	Removed LocationInfo property it is not used. The buffering base class
	provides the necessary functionality.
	
2003-07-07 20:47  drieseng

	* Plugin/RemoteLoggingServerPlugin.cs:

	temporary work around for mono bug #45520 : use the fully qualified 
	type name to refer to 
	log4net.Appender.RemotingAppender.IRemoteLoggingSink, instead of 
	using alias.
	
2003-07-07 20:41  ncadell

	* Config/PluginAttribute.cs,
	Repository/Hierarchy/DOMHierarchyConfigurator.cs,
	helpers/OptionConverter.cs, helpers/PatternConverter.cs,
	helpers/SystemInfo.cs, helpers/TypeConverters/ConverterRegistry.cs:

	FxCop 1.21. Renamed parameters.
	Updated SystemInfo.GetTypeFromString to take an ignoreCase flag.
	Updated callers to pass false (i.e. to ignore case)
	
	* spi/: ILogger.cs, Level.cs, LevelMap.cs, LocationInfo.cs,
	LoggerManager.cs:

	FxCop 1.21. Sealed helper classes. Renamed parameters.
	
	* helpers/PropertiesCollection.cs, spi/LoggingEvent.cs:

	FxCop 1.21. Added serialization security demand to GetObjectData.
	
	* helpers/: EmptyCollection.cs, EmptyDictionary.cs, LogLog.cs,
	NullDictionaryEnumerator.cs, NullEnumerator.cs, PatternParser.cs,
	QuietTextWriter.cs, Transform.cs:

	FxCop 1.21. Sealed helper classes. Renamed parameters.
	
	* ObjectRenderer/DefaultRenderer.cs, ObjectRenderer/RendererMap.cs,
	Repository/Hierarchy/Logger.cs:

	FxCop 1.21. Renamed parameters.
	
	* Layout/XMLLayoutBase.cs:

	FxCop 1.21. Culture specified.
	
	* DateFormatter/: AbsoluteTimeDateFormatter.cs,
	DateTimeDateFormatter.cs, IDateFormatter.cs,
	ISO8601DateFormatter.cs, SimpleDateFormatter.cs:

	FxCop 1.21. Renamed parameters.
	
	* LogManager.cs, MDC.cs, NDC.cs, Appender/ADONetAppender.cs,
	Config/BasicConfigurator.cs, Config/DOMConfigurator.cs:

	FxCop 1.21. Sealed helper classes. Renamed parameters.
	
2003-07-07 01:05  ncadell

	* Appender/ConsoleAppender.cs:

	Added better comment on how the events are delivered to the console.
	
	* Appender/: ColoredConsoleAppender.cs, SmtpPickupDirAppender.cs:

	Added doc for the new appenders ColoredConsoleAppender and 
	SmtpPickupDirAppender
	
2003-07-03 16:32  ncadell

	* log4net.csproj, Appender/ColoredConsoleAppender.cs,
	Appender/ColouredConsoleAppender.cs:

	Americanized spelling of ColouredConsoleAppender
	
2003-07-02 22:52  ncadell

	* log4net.csproj:

	Added ColouredConsoleAppender.cs and SmtpPickupDirAppender.cs
	
2003-07-02 21:34  ncadell

	* Appender/ColouredConsoleAppender.cs:

	Added new appender: ColouredConsoleAppender
	
	* Appender/SmtpPickupDirAppender.cs:

	Added new appender: SmtpPickupDirAppender
	
	* helpers/SystemInfo.cs:

	Added Guid generating support class for Compact Framework
	
	* Appender/EventLogAppender.cs:

	There is a limit of 32K characters in an EventLog message. Added a 
	check that only logs the first 32000 characters from the rendered 
	message.
	
2003-07-02 19:56  ncadell

	* Layout/PatternLayout.cs, helpers/PatternParser.cs,
	spi/LoggingEvent.cs:

	Added support for capturing the current thread principal name and the
	app domain friendly name for each logging event.
	
	* Layout/XMLLayout.cs:

	Fixed method comment
	
2003-07-02 18:15  ncadell

	* spi/LoggingEvent.cs:

	Fixed spelly in comment
	
2003-06-26 21:02  drieseng

	* log4net.csproj:

	removed releasestrong build configuration, made release configuration 
	strong
	
2003-06-26 07:35  drieseng

	* AssemblyInfo.cs:

	fall back to using "log4net" as title when it's an unknown framework.
	
	* AssemblyInfo.cs:

	the assembly title now includes the framework name and version that's 
	targeted by the assembly
	
2003-06-25 05:59  drieseng

	* .cvsignore, log4net.csproj:

	updated assembly naming scheme in project file
	
2003-05-20 19:48  drieseng

	* Layout/: XMLLayout.cs, XMLLayoutBase.cs:

	- code restructure
	- made constructors on XMLLayoutBase protected
	- changed case of protected constants in XMLLayoutBase
	- xml doc updates
	
	* Appender/ASPNetTraceAppender.cs:

	replaced spaces by tabs
	
2003-05-12 01:11  ncadell

	* Layout/XMLLayout.cs, Layout/XMLLayoutBase.cs, log4net.csproj:

	Added XMLLayoutBase abstract class as a basis for xml layouts.
	Rewritten XMLLayout to use an XmlWriter to generate the XML.
	
2003-05-11 20:14  ncadell

	* helpers/Transform.cs:

	Replaced Transform string based methods to XmlWriter based escape
	method WriteEscapedXmlString
	
	* spi/LoggingEvent.cs:

	Added MappedContext property that returns the MDC dictionary held
	by the event.
	
2003-05-10 15:51  ncadell

	* spi/LoggingEvent.cs:

	Added MessageObject property to get access to the raw message object
	that was used to construct the LoggingEvent
	
2003-05-07 14:08  ncadell

	* AssemblyVersionInfo.cpp, AssemblyVersionInfo.cs,
	AssemblyVersionInfo.js, AssemblyVersionInfo.vb:

	Updated version number to 1.2.0.30507
	
2003-05-06 16:38  ncadell

	* Appender/RollingFileAppender.cs, Repository/Hierarchy/Logger.cs:

	Updated tests to mark the repository as configured.
	

=============================================================================
Version 1.2.0 BETA 7
=============================================================================


2003-05-06 16:38  ncadell

	* Appender/RollingFileAppender.cs, Repository/Hierarchy/Logger.cs:

	Updated tests to mark the repository as configured.
	
2003-05-05 16:11  ncadell

	* Appender/ADONetAppender.cs:

	Resolved some issues with the ADONetAppender where it could forget
	that it should be using a prepared command object. Improved exception
	handling and clean up code.
	
	* Repository/Hierarchy/Logger.cs:

	Changed no appender warnings to debug level. These messages will not
	be displayed on the application's console by default.
	
2003-04-28 21:04  ncadell

	* Config/DOMConfigurator.cs:

	Added Configure methods that take a Stream to read the configuration
	from. Updated the method that reads from a file to use the stream
	reading method.
	
2003-04-24 23:28  ncadell

	* Repository/Hierarchy/DOMHierarchyConfigurator.cs:

	Fixed incorrect test in ParseRenderer method.
	
2003-04-23 01:42  ncadell

	* Appender/AppenderSkeleton.cs:

	Make Close() method wait for the appender's lock before calling 
	OnClose. Added recursion guard to the DoAppend() method.
	Updated comment doc for RequiresLayout.
	
	* Repository/Hierarchy/Hierarchy.cs:

	Disabled the Hierarchy until it is configured.
	
	* Config/DOMConfigurator.cs:

	When the config file does not contain a <log4net> element a Debug 
	message is written rather than an Error message.
	
2003-04-21 15:29  ncadell

	* helpers/OptionConverter.cs:

	Updated OptionConverter.ToFileSize to trim space between the number 
	and the units.
	
	* Appender/: NetSendAppender.cs, UdpAppender.cs:

	Fixed typo
	
2003-04-21 12:19  ncadell

	* spi/DefaultRepositorySelector.cs:

	Added Debug message to CreateRepository when the domain already exists.
	
2003-04-19 23:09  ncadell

	* spi/LoggerManager.cs:

	Changed LoggerManager static constructor to call a method to register
	the AppDomain events. This is because the events use a LinkDemand that
	is evaluated during the JIT phase therefore the SecurityException 
	cannot be caught within the method itself but can be caught in the 
	caller.
	
	* Repository/Hierarchy/Logger.cs:

	Added SecurityException check around AppDomain properties.
	
	* Config/DOMConfigurator.cs:

	Added Exception check around the creation of the 
	ConfigureAndWatchHandler because a SecurityException can be thrown from 
	the constructor.
	
2003-04-16 21:42  ncadell

	* AssemblyVersionInfo.cpp:

	Added AssemblyVersionInfo file for managed C++
	
2003-04-16 07:57  drieseng

	* Appender/AppenderSkeleton.cs:

	fixed minor xml doc typo
	
2003-04-15 08:03  drieseng

	* spi/DefaultRepositorySelector.cs:

	fixed some comments
	
2003-04-14 07:31  drieseng

	* AssemblyVersionInfo.js:

	added AssemblyVersionInfo file for JScript.NET examples.
	
2003-04-08 07:00  drieseng

	* spi/LoggerManager.cs:

	added conditional compilation directive for SSCLI, as this runtime does
	not support the Environment.OSVersion property.
	
	* spi/LoggerManager.cs:

	changed version info that's printed when debug is enabled :
	
	- removed Microsoft
	- add info about operating system on which log4net is running
	
2003-04-08 00:15  ncadell

	* log4net.sln:

	Removed example C# projects. These now have their own solution file.
	
2003-04-07 18:45  drieseng

	* helpers/OptionConverter.cs:

	Added support for specifying case-sensitivity and added support for 
	parsing flag-type enum values to the .NET CF version of ParseEnum.
	
2003-04-04 07:07  drieseng

	* AssemblyVersionInfo.vb:

	AssemblyVersionInfo for vb examples
	
2003-04-01 20:14  ncadell

	* Config/DOMConfigurator.cs:

	Updated not to throw an exception (which was not caught) when the
	config file could not be opened either because the file could not
	be read (lock violation) or because the file was not valid XML.
	
2003-03-30 18:31  drieseng

	* log4net.sln:

	Update : add directory levels for framework version and code language.
	
2003-03-28 17:42  ncadell

	* spi/DefaultRepositorySelector.cs:

	Added a method for creating a repository for an assembly without
	reading the assembly attributes from the target assembly. This can
	be used in situations where the assembly is being loaded into the
	process in a managed way, and should not have control over its
	logging configuration.
	
2003-03-28 15:53  ncadell

	* Repository/: ILoggerRepository.cs, LoggerRepositorySkeleton.cs,
	Hierarchy/Hierarchy.cs:

	Added repository specific properties to the ILoggerRepository and
	classes that implement the interface.
	
2003-03-28 15:33  ncadell

	* Appender/MemoryAppender.cs:

	Removed abstract class modifier from MemoryAppender
	
2003-03-25 11:49  ncadell

	* Layout/XMLLayout.cs:

	IgnoresException was returning true. The layout does render the 
	exception data correctly and has been changed to return false. This 
	fixes an issue where invalid XML was generated when an exception was 
	logged.
	
2003-03-25 00:56  ncadell

	* Config/DOMConfigurator.cs:

	Added code to catch exceptions while reading the .config file.
	Errors are displayed, and common errors diagnosed.
	
	* helpers/LogLog.cs:

	Minor update to error message when the .config file cannot be parsed.
	
2003-03-23 13:28  drieseng

	* helpers/: EmptyDictionary.cs, NullDictionaryEnumerator.cs,
	NullEnumerator.cs:

	Minor update: xml docs
	
2003-03-23 12:35  ncadell

	* helpers/OnlyOnceErrorHandler.cs:

	Updated OnlyOnceErrorHandler to only attempt to log the first message
	if an error occurs logging the message then it will not be attempted
	again.
	
2003-03-23 09:51  drieseng

	* helpers/OnlyOnceErrorHandler.cs, helpers/PatternConverter.cs,
	helpers/PatternParser.cs, helpers/PropertiesCollection.cs,
	helpers/Transform.cs, spi/IAppenderAttachable.cs,
	spi/LoggingEvent.cs:

	Minor update: xml docs
	
	* helpers/OptionConverter.cs:

	Minor update: xml docs + code style updates
	
	* helpers/: LogLog.cs, EmptyCollection.cs:

	Minor update: xml docs
	
	* helpers/NativeError.cs:

	Minor update : fixed typo
	
	* helpers/: AppenderAttachedImpl.cs, CyclicBuffer.cs,
	EmptyCollection.cs, EmptyDictionary.cs, FormattingInfo.cs,
	NativeError.cs:

	Minor update : xml doc + code style updates
	
2003-03-22 18:27  drieseng

	* Config/: DOMConfigurator.cs, AliasDomainAttribute.cs,
	BasicConfigurator.cs, ConfiguratorAttribute.cs,
	DOMConfiguratorAttribute.cs, Log4NetConfigurationSectionHandler.cs,
	PluginAttribute.cs:

	Minor update : xml doc + code style updates
	
2003-03-21 19:47  drieseng

	* Config/DOMConfigurator.cs:

	Minor update : updated xml docs + (very) minor code style updates
	
2003-03-17 00:47  ncadell

	* Repository/Hierarchy/Logger.cs:

	Fixed NUnit tests
	
	* spi/WrapperMap.cs:

	Added support for wrapping a null logger. A null wrapper is returned.
	
2003-03-16 08:28  drieseng

	* log4net.ndoc:

	sdk docs are now built using the nant build system
	
2003-03-16 02:18  ncadell

	* AssemblyVersionInfo.cs:

	Updated version number to 1.2.0.30316
	

=============================================================================
Version 1.2.0 BETA 6
=============================================================================


2003-03-15 20:23  ncadell

	* MDC.cs:

	Added Clear() method to remove the mappings for the current thread.
	
2003-03-15 14:39  ncadell

	* Config/BasicConfigurator.cs:

	Compact Framework supports the revised ConsoleAppender so the
	conditional compilation in the BasicConfigurator has been removed.
	
2003-03-15 08:43  drieseng

	* ILog.cs:
	* Layout/PatternLayout.cs:
	* Appender/: ASPNetTraceAppender.cs, AppenderSkeleton.cs,
	BufferingForwardingAppender.cs, ConsoleAppender.cs,
	EventLogAppender.cs, NetSendAppender.cs,
	OutputDebugStringAppender.cs, SMTPAppender.cs,
	TextWriterAppender.cs, TraceAppender.cs, UdpAppender.cs:

	Minor update : xml doc restructure + corrected code example and
	reference to JVM
	
2003-03-12 11:10  ncadell

	* helpers/LogLog.cs:

	Fixed to catch exception if the config file is malformed
	
	* Layout/PatternLayout.cs:

	Fixed doc to used correct milliseconds date pattern
	
2003-03-08 16:26  drieseng

	* Repository/Hierarchy/: DefaultLoggerFactory.cs,
	ILoggerFactory.cs, Logger.cs, ProvisionNode.cs, RootLogger.cs:

	minor update : xml docs
	
	* NDC.cs:

	minor update : xml docs
	
	* ILog.cs, LogManager.cs, MDC.cs, NDC.cs:

	minor update : xml docs
	
2003-03-08 13:55  drieseng

	* Config/: DOMConfiguratorAttribute.cs, PluginAttribute.cs:

	minor update : xml docs + removed conditional compilation directive 
	for NETCF, because the class is being excluded from build
	
	* Config/ConfiguratorAttribute.cs:

	minor update : xml docs
	
	* Config/: AliasDomainAttribute.cs, DomainAttribute.cs:

	minor update : xml docs + removed conditional compilation directive 
	for NETCF, because the class is being excluded from build
	
	* spi/LogException.cs, Config/BasicConfigurator.cs:

	minor update : xml docs
	
	* helpers/TypeConverters/ConversionNotSupportedException.cs:

	minor update : xml docs
	
2003-03-08 12:14  ncadell

	* AssemblyInfo.cs:

	Added AssemblyDefaultAlias attribute with value 'log4net'.
	Removed use of AssemblyKeyName attribute as it is not required.
	
2003-03-08 10:48  drieseng

	* AssemblyInfo.cs:

	Minor update : added support for building strong-named SSCLI assembly.
	
2003-03-07 17:09  drieseng

	* .cvsignore:

	added log4net.sln.old and log4net*.xml to ignore list
	
2003-03-07 14:52  drieseng

	* Appender/: ADONetAppender.cs, ASPNetTraceAppender.cs,
	EventLogAppender.cs, SMTPAppender.cs:

	Minor update : conditional compilation directive for SSCLI no longer
	needed, file is being excluded in the buildfile now.
	
2003-03-07 09:43  drieseng

	* Appender/EventLogAppender.cs:

	Minor update : conditional compilation directive for MONO no longer
	needed, file is being excluded in the buildfile now.
	
2003-03-07 07:57  drieseng

	* Plugin/RemoteLoggingServerPlugin.cs:

	Moved from Mono 0.21 to Mono 0.22 : RemotingServices.Shutdown is now
	available on Mono, so conditional compilation directive was removed.
	
	* helpers/SystemInfo.cs:

	Moved from Mono 0.21 to Mono 0.22 : GlobalAssemblyCache property is 
	now available on Mono, so conditional compilation directive was removed.
	
	* Config/DOMConfigurator.cs:

	Minor update : combined conditionals for MONO and NETCF
	
	* Appender/FileAppender.cs:

	Moved from Mono 0.21 to Mono 0.22 : CreateDirectory issue is fixed in
	Mono 0.22, so the conditional compilation directive has been removed.
	
2003-03-07 06:26  drieseng

	* AssemblyInfo.cs, Appender/ADONetAppender.cs,
	Appender/ASPNetTraceAppender.cs, Appender/EventLogAppender.cs,
	Appender/RemotingAppender.cs, Appender/SMTPAppender.cs,
	Config/DOMConfigurator.cs, Config/DOMConfiguratorAttribute.cs,
	spi/LoggingEvent.cs:

	Minor update : rename ROTOR conditional compilation directive to 
	SSCLI (Shared Source CLI)
	
2003-03-06 01:33  ncadell

	* Appender/AppenderCollection.cs,
	Appender/BufferingForwardingAppender.cs,
	Appender/ForwardingAppender.cs, Repository/Hierarchy/Logger.cs,
	helpers/AppenderAttachedImpl.cs, spi/IAppenderAttachable.cs:

	Renamed GetAppAppenders() in IAppenderAttachable to Appenders property
	This property supports get only and returns an AppenderCollection.
	
2003-03-05 19:41  drieseng

	* spi/LoggingEvent.cs:

	Minor update : a region directive inside a conditional compilation
	block causes error on .NET 1.0 framework
	
2003-03-05 02:30  ncadell

	* log4net.sln:

	Renamed domain example project files.
	
	* .cvsignore:

	Updated project file names
	
	* .cvsignore:

	Added ignore for bin directory that occasionally appears
	
	* log4net.csproj, log4net-vs2002.csproj, log4net-vs2002.sln,
	log4net.sln:

	renamed project file and solution back to log4net.csproj & .sln
	
2003-03-04 18:09  drieseng

	* log4net-vs2002.sln:

	minor update : updated location of project files for EventIDLogAp
	p and TraceLogApp samples.
	
2003-03-04 08:48  drieseng

	* log4net-vs2002.sln:

	minor update : updated location of project files for extensions.
	
2003-03-03 20:52  drieseng

	* log4net-vs2002.sln:

	minor update : updated location of TestApp project files
	
2003-03-03 19:45  drieseng

	* log4net-vs2002.sln:

	minor update : updated location of RemotingClient and RemoteServer
	project files
	
	* log4net-vs2002.csproj:

	minor update : name of xml doc files
	
	* log4net-vs2002.sln:

	minor update : new location of NotLogging project file
	
	* log4net-vs2002.csproj:

	minor update : changed name of generate xml doc + use nunit that's
	part of nant
	
2003-03-03 09:35  ncadell

	* .cvsignore, log4net-vs2002.csproj, log4net-vs2002.sln,
	log4net.csproj, log4net.sln:

	Renamed log4net.csproj and log4net.sln to log4net-vs2002.csproj
	and log4net-vs2002.sln. The project files are specific to one
	version of Visual Studio .NET.
	
	* log4net.sln:

	Updated location and name of example/net/domain projects
	
	* log4net.csproj:

	Updated build output to be named log4net-net-1.0.dll
	
2003-03-03 01:03  ncadell

	* Appender/: ADONetAppender.cs, ASPNetTraceAppender.cs,
	EventLogAppender.cs, SMTPAppender.cs:

	Added conditional compilation for rotor
	
2003-03-02 19:49  drieseng

	* Appender/EventLogAppender.cs:

	Minor update : add conditional compilation directive for Mono
	
2003-03-02 18:25  ncadell

	* AssemblyInfo.cs, Appender/RemotingAppender.cs,
	Config/DOMConfigurator.cs, Config/DOMConfiguratorAttribute.cs,
	spi/LoggingEvent.cs:

	Added conditional compilation to support ROTOR 1.0 platform
	
2003-03-02 17:42  ncadell

	* Appender/AppenderCollection.cs, Plugin/PluginCollection.cs,
	Plugin/PluginMap.cs, spi/LevelCollection.cs, log4net.csproj,
	helpers/AppenderAttachedImpl.cs, helpers/AppenderList.cs,
	helpers/LevelList.cs, helpers/PluginList.cs, spi/LevelMap.cs:

	Moved and renamed strongly typed collection classes.
	
2003-03-02 17:04  drieseng

	* helpers/: AppenderList.cs, LevelList.cs, PluginList.cs:

	Minor update: removed extra tabs in xml docs
	
2003-03-02 14:12  ncadell

	* log4net.csproj, helpers/AppenderAttachedImpl.cs,
	helpers/AppenderList.cs, helpers/LevelList.cs,
	helpers/PluginList.cs, Plugin/PluginMap.cs,
	Repository/LoggerRepositorySkeleton.cs, spi/LevelMap.cs:

	Added strongly typed IList classes for IAppender, IPlugin and Level
	
2003-03-02 09:57  drieseng

	* Repository/Hierarchy/LoggerKey.cs:

	Minor update: xml doc update
	
2003-03-02 09:27  drieseng

	* Repository/Hierarchy/: RootLogger.cs, Logger.cs:

	Minor update: xml doc update
	
	* spi/LoggerManager.cs:

	Minor update : fixed fxcop issues + xml doc updates
	
	* spi/: DefaultRepositorySelector.cs, IRepositorySelector.cs:

	Minor update : fixed fxcop issues
	
	* Repository/Hierarchy/RootLogger.cs:

	Minor update : GetEffectiveLevel method replaced by EffectiveLevel 
	property + xml doc updates
	
	* Repository/Hierarchy/Logger.cs:

	Minor update : fixed fxcop issues + xml doc updates + GetEffectiveLevel 
	method replaced by EffectiveLevel property
	
	* LogManager.cs:

	Minor update : fixed fxcop issues + xml doc updates
	
	* helpers/SystemInfo.cs:

	Minor update : fixed fxcop issues
	
2003-03-02 08:08  drieseng

	* helpers/SystemInfo.cs, Config/DOMConfigurator.cs,
	Config/DOMConfiguratorAttribute.cs,
	DateFormatter/AbsoluteTimeDateFormatter.cs,
	DateFormatter/DateTimeDateFormatter.cs,
	DateFormatter/IDateFormatter.cs,
	DateFormatter/ISO8601DateFormatter.cs,
	DateFormatter/SimpleDateFormatter.cs, spi/LoggingEvent.cs,
	Appender/FileAppender.cs:

	Minor update : fixed fxcop issues
	
	* helpers/SystemInfo.cs:

	Minor update : fixed fxcop issues
	
2003-03-02 06:57  drieseng

	* DateFormatter/AbsoluteTimeDateFormatter.cs,
	DateFormatter/IDateFormatter.cs,
	DateFormatter/SimpleDateFormatter.cs,
	ObjectRenderer/RendererMap.cs, Plugin/RemoteLoggingServerPlugin.cs,
	Repository/LoggerRepositorySkeleton.cs:

	Minor update : fixed fxcop issues
	
	* Appender/UdpAppender.cs, Appender/FileAppender.cs,
	helpers/CountingQuietTextWriter.cs, helpers/QuietTextWriter.cs:

	Minor update : changed case of error codes.
	
	* Appender/RollingFileAppender.cs:

	Minor update : fixed FxCop issues
	
	* spi/IErrorHandler.cs:

	Minor update : Moved ErrorCodes enum to a separate source file and 
	xml doc update.
	
	* spi/ErrorCodes.cs:

	Minor update : Moved ErrorCodes enum to a separate source file and
	changed case of members.
	
2003-03-01 20:06  drieseng

	* Plugin/IPluginFactory.cs:

	Minor update: removed unused using directive
	
	* Appender/AppenderSkeleton.cs, Appender/RollingFileAppender.cs,
	Plugin/IPluginFactory.cs:

	Minor update: xml doc update
	
2003-03-01 19:31  drieseng

	* Appender/FileAppender.cs:

	Minor update: support for Mono 0.21 - first check if the directory 
	for the file doesn't already exist, before actually trying to create
	the directory.  Should be removed when next version of Mono is 
	available.
	
2003-03-01 19:27  ncadell

	* Appender/: ADONetAppender.cs, ASPNetTraceAppender.cs,
	BufferingForwardingAppender.cs, ConsoleAppender.cs,
	CountingAppender.cs, EventLogAppender.cs, ForwardingAppender.cs,
	NetSendAppender.cs, OutputDebugStringAppender.cs,
	RemotingAppender.cs, SMTPAppender.cs, TextWriterAppender.cs,
	TraceAppender.cs, UdpAppender.cs:

	Updated to use RequiresLayout property only if the appender requires
	a layout to be specified.
	
	* Appender/: AppenderSkeleton.cs, IAppender.cs:

	Removed Layout, ErrorHandler and RequiresLayout from the IAppender
	interface.
	
2003-03-01 18:48  ncadell

	* Appender/: AppenderSkeleton.cs, IAppender.cs:

	Removed Filter property from IAppender. Added AddFilter(IFilter) 
	method to the AppenderSkeleton class.
	
	* Repository/Hierarchy/DOMHierarchyConfigurator.cs:

	Simplified parsing of elements. Enhanced generic param parsing to
	support params specified in the element name. i.e. a param like:
	<param name="param-name" /> can now be written as <param-name />.
	Made the lookup of param setter properties case insensitive.
	
2003-03-01 17:52  ncadell

	* log4net.csproj, Config/PluginAttribute.cs,
	Plugin/IPluginFactory.cs, spi/DefaultRepositorySelector.cs:

	Moved IPluginFactory interface to the log4net.Plugin namespace
	
	* Appender/RollingFileAppender.cs:

	Moved IDateTime interface inside the RollingFileAppender class.
	
2003-03-01 17:39  drieseng

	* Plugin/RemoteLoggingServerPlugin.cs:

	Minor update: xml doc update + support for Mono 0.21 - 
	RemotingServices.Disconnect is not available
	
	* Config/DOMConfigurator.cs:

	Minor update: support for Mono 0.21 - use XmlTextReader instead of
	XmlValidatingReader
	
	* helpers/SystemInfo.cs:

	Minor update: support for Mono 0.21
	
	* Plugin/: IPlugin.cs, PluginMap.cs, PluginSkeleton.cs:

	Minor update: xml doc updates
	
2003-03-01 17:04  ncadell

	* Appender/RemotingAppender.cs,
	Plugin/RemoteLoggingServerPlugin.cs:

	Moved IRemoteLoggingSink interface within the RemotingAppender class.
	This moves the interface out of the log4net.Appenders namespace.
	
2003-03-01 16:24  drieseng

	* Config/Log4NetConfigurationSectionHandler.cs:

	Minor update: xml doc updates
	
2003-03-01 14:53  ncadell

	* Repository/Hierarchy/Hierarchy.cs,
	Repository/Hierarchy/Logger.cs, helpers/LogLog.cs,
	spi/LoggingEvent.cs:

	Removed all Obsolete methods
	
2003-02-28 06:27  drieseng

	* spi/LoggingEvent.cs:

	minor update: fixes for .NETCF
	
	* spi/DefaultRepositorySelector.cs:

	cosmetic : removed extra linefeed
	
	* spi/LoggingEvent.cs:

	Minor update: xml doc updates + remove protected access to instance 
	fields
	
2003-02-28 00:14  ncadell

	* spi/WrapperMap.cs:

	Renamed ShutdownEventHandler() delegate method to OnShutdown() because
	FxCop didn't like that it ended with EventHandler.
	
	* Appender/ADONetAppender.cs:

	Renamed GetConnectionType() to ResolveConnectionType() because FxCop
	didn't like that there was a property called ConnectionType as well.
	
	* helpers/TypeConverters/ConversionNotSupportedException.cs:

	Made serializable
	
2003-02-26 20:29  drieseng

	* Appender/RemotingAppender.cs:

	minor update: added region
	
	* spi/: LoggerWrapperImpl.cs, LogImpl.cs:

	Warning: removed protected access to logger and fully qualified 
	classname instance fields + update docs
	
	* spi/WrapperMap.cs:

	Minor update: removed protected access to instance fields; updated 
	xml docs
	
2003-02-26 19:01  drieseng

	* helpers/: LogLog.cs, OnlyOnceErrorHandler.cs:

	Minor update: added extra linefeed for fixing problem with Mono
	
	* Appender/FileAppender.cs, Appender/UdpAppender.cs,
	Config/AliasDomainAttribute.cs, Config/DOMConfiguratorAttribute.cs,
	Config/Log4NetConfigurationSectionHandler.cs,
	Config/PluginAttribute.cs:

	Minor update: added extra linefeed for fixing problem with Mono
	
2003-02-25 20:20  drieseng

	* helpers/: PatternParser.cs, CountingQuietTextWriter.cs,
	QuietTextWriter.cs:

	Minor update: fixed fxcop issue + xml doc update + source 
	restructuring
	
2003-02-25 20:01  drieseng

	* Plugin/PluginSkeleton.cs:

	Minor update: fixed fxcop issue + xml doc update + source
	restructuring
	
	* Repository/Hierarchy/: Logger.cs, Hierarchy.cs:

	Minor update: fixed fxcop issue + xml doc update + source
	restructuring
	
	* Repository/Hierarchy/RootLogger.cs:

	Minor update: fixed fxcop issue
	
	* spi/ILogger.cs:

	Minor update: fixed fxcop issue + xml doc update
	
2003-02-25 19:10  drieseng

	* spi/DefaultRepositorySelector.cs:

	Minor update: fixed fxcop issue + xml doc update + source
	restructure
	
	* helpers/OptionConverter.cs:

	Minor update: fixed fxcop issue
	
2003-02-24 17:04  drieseng

	* helpers/TypeConverters/ConverterRegistry.cs:

	minor update : xml docs + code structure
	
2003-02-24 00:54  ncadell

	* log4net.sln:

	Moved release/examples to examples/net and release/extensions to
	extension. Updated VS.NET build file.
	
2003-02-24 00:17  ncadell

	* ChangeLog:

	Moved ChangeLog, notes and about to the root
	
2003-02-23 20:36  drieseng

	* Appender/: FileAppender.cs, RollingFileAppender.cs,
	FileAppender.cs:

	Minor update : xml doc update + removed protected access to instance 
	fields.
	
2003-02-23 18:45  drieseng

	* helpers/OptionConverter.cs,
	Repository/Hierarchy/DOMHierarchyConfigurator.cs:

	Minor update : xml doc update + fix for fxcop issues.
	
	* Config/PluginAttribute.cs:

	Minor update : xml doc update + fix for fxcop issue.
	
	* Appender/UdpAppender.cs:

	Minor update : use NumberFormatInfo.InvariantInfo instead of 
	CultureInfo.CurrentCulture to convert port number to string.
	
	* Appender/ConsoleAppender.cs:

	Minor update : added using directive.
	
2003-02-23 10:24  drieseng

	* Repository/Hierarchy/DOMHierarchyConfigurator.cs:

	Minor update : fixes for FxCop issues (pass FormatProvider), xml doc 
	updates + code restructuring
	
2003-02-22 19:53  drieseng

	* Appender/EventLogAppender.cs:

	Minor update: fix FxCop issue
	
	* Repository/Hierarchy/DOMHierarchyConfigurator.cs:

	Minor update: fix few FxCop issues
	
2003-02-22 19:29  drieseng

	* Appender/RemotingAppender.cs:

	Minor update: removed protected access to instance fields + xml doc
	updates
	
	* Appender/: OutputDebugStringAppender.cs, ASPNetTraceAppender.cs:

	Minor update: source structure update
	
2003-02-22 19:03  drieseng

	* Appender/MemoryAppender.cs:

	Minor update: removed protected access to instance field
	
	* Appender/EventLogAppender.cs:
	* Appender/MemoryAppender.cs:
	* Appender/ForwardingAppender.cs:

	Minor update: removed protected access to instance field + xml doc 
	updates
	
	* Appender/BufferingForwardingAppender.cs:

	Minor update: regions update
	
2003-02-22 18:31  drieseng

	* Appender/BufferingAppenderSkeleton.cs:
	* Appender/CountingAppender.cs:

	Minor update: removed protected access to instance field + xml doc 
	updates
	
	* Appender/AppenderSkeleton.cs:

	Minor update: removed protected access to instance field because 
	public access was already available using properties + xml doc updates
	
2003-02-22 17:57  drieseng

	* Appender/BufferingForwardingAppender.cs:

	Minor update: updated xml docs and removed protected access to 
	instance field.
	
	* Appender/OutputDebugStringAppender.cs:

	Minor fix: the dllimport for the .NETCF version should have been from 
	CoreDll.dll not from nk.dll. The appender now no longer returns 
	errors, but I still have no clue on how to monitor the output of this 
	appender on Pocket PC or Windows CE devices.
	
2003-02-22 15:20  drieseng

	* Plugin/IPlugin.cs, Plugin/PluginMap.cs, Plugin/PluginSkeleton.cs,
	Plugin/RemoteLoggingServerPlugin.cs,
	Repository/IBasicRepositoryConfigurator.cs,
	Repository/IDOMRepositoryConfigurator.cs,
	Repository/ILoggerRepository.cs,
	Repository/LoggerRepositorySkeleton.cs,
	Repository/Hierarchy/DOMHierarchyConfigurator.cs,
	Repository/Hierarchy/DefaultLoggerFactory.cs,
	Repository/Hierarchy/Hierarchy.cs,
	Repository/Hierarchy/ILoggerFactory.cs,
	Repository/Hierarchy/Logger.cs, Repository/Hierarchy/LoggerKey.cs,
	Repository/Hierarchy/ProvisionNode.cs,
	Repository/Hierarchy/RootLogger.cs,
	spi/DefaultRepositorySelector.cs, spi/IAppenderAttachable.cs,
	spi/IErrorHandler.cs, spi/ILogger.cs, spi/ILoggerWrapper.cs,
	spi/IOptionHandler.cs, spi/IRepositorySelector.cs,
	spi/ITriggeringEventEvaluator.cs, spi/Level.cs,
	spi/LevelEvaluator.cs, spi/LevelMap.cs, spi/LocationInfo.cs,
	spi/LogException.cs, spi/LogImpl.cs, spi/LoggerWrapperImpl.cs,
	spi/LoggingEvent.cs, spi/WrapperMap.cs:

	Minor update: copyright update
	
	* AssemblyInfo.cs, AssemblyVersionInfo.cs, ILog.cs, LogManager.cs,
	MDC.cs, NDC.cs, Config/AliasDomainAttribute.cs,
	Config/BasicConfigurator.cs, Config/ConfiguratorAttribute.cs,
	Config/DOMConfiguratorAttribute.cs, Config/DomainAttribute.cs,
	Config/Log4NetConfigurationSectionHandler.cs,
	Config/PluginAttribute.cs,
	DateFormatter/AbsoluteTimeDateFormatter.cs,
	DateFormatter/DateTimeDateFormatter.cs,
	DateFormatter/IDateFormatter.cs,
	DateFormatter/ISO8601DateFormatter.cs,
	DateFormatter/SimpleDateFormatter.cs, Filter/DenyAllFilter.cs,
	Filter/FilterSkeleton.cs, Filter/IFilter.cs,
	Filter/LevelMatchFilter.cs, Filter/LevelRangeFilter.cs,
	Filter/MDCFilter.cs, Filter/NDCFilter.cs,
	Filter/StringMatchFilter.cs, helpers/AppenderAttachedImpl.cs,
	helpers/CountingQuietTextWriter.cs, helpers/CyclicBuffer.cs,
	helpers/EmptyCollection.cs, helpers/EmptyDictionary.cs,
	helpers/FormattingInfo.cs, helpers/NullDictionaryEnumerator.cs,
	helpers/NullEnumerator.cs, helpers/OptionConverter.cs,
	helpers/PatternConverter.cs, helpers/PatternParser.cs,
	helpers/PropertiesCollection.cs, helpers/QuietTextWriter.cs,
	helpers/Transform.cs, helpers/TypeConverters/BooleanConverter.cs,
	helpers/TypeConverters/ConversionNotSupportedException.cs,
	helpers/TypeConverters/ConverterRegistry.cs,
	helpers/TypeConverters/EncodingConverter.cs,
	helpers/TypeConverters/IConvertFrom.cs,
	helpers/TypeConverters/TypeConverterAttribute.cs,
	Layout/ExceptionLayout.cs, Layout/ILayout.cs, Layout/IRawLayout.cs,
	Layout/Layout2RawLayoutAdapter.cs, Layout/LayoutSkeleton.cs,
	Layout/PatternLayout.cs, Layout/RawLayoutConverter.cs,
	Layout/RawTimeStampLayout.cs, Layout/SimpleLayout.cs,
	Layout/XMLLayout.cs, ObjectRenderer/DefaultRenderer.cs,
	ObjectRenderer/IObjectRenderer.cs, ObjectRenderer/RendererMap.cs:

	Minor update: copyright update
	
	* Config/DOMConfigurator.cs, helpers/LogLog.cs,
	helpers/OnlyOnceErrorHandler.cs, helpers/SystemInfo.cs,
	spi/LoggerManager.cs:

	Minor update. updated xml doc to prevent warning when compiling for 
	.NETCF.
	
2003-02-22 13:50  drieseng

	* Appender/RollingFileAppender.cs:

	Minor update. updated xml doc to prevent warning when compiling for 
	.NETCF.
	
	* Appender/ADONetAppender.cs:

	Minor update. removed protected access to instance variables, added 
	protected property for accessing database connection, updated xml 
	docs, optimized using directives.
	
	* Appender/TraceAppender.cs:

	Minor update. removed unnecessary using directives, updated xml docs, 
	removed protected access to m_immediateflush field because public 
	access is available.
	
	* Appender/: ASPNetTraceAppender.cs, BufferingAppenderSkeleton.cs,
	BufferingForwardingAppender.cs, ConsoleAppender.cs,
	CountingAppender.cs, EventLogAppender.cs, ForwardingAppender.cs,
	IAppender.cs, MemoryAppender.cs, NetSendAppender.cs,
	OutputDebugStringAppender.cs, RemotingAppender.cs,
	RollingFileAppender.cs, SMTPAppender.cs, TextWriterAppender.cs:

	Minor update. removed unnecessary using directives
	
2003-02-22 12:52  drieseng

	* Appender/: ASPNetTraceAppender.cs,
	BufferingForwardingAppender.cs, ConsoleAppender.cs,
	CountingAppender.cs, EventLogAppender.cs, ForwardingAppender.cs,
	NetSendAppender.cs, OutputDebugStringAppender.cs,
	RemotingAppender.cs, SMTPAppender.cs, TextWriterAppender.cs,
	TraceAppender.cs, UdpAppender.cs:

	Minor update. Xml doc updates.
	
	* Appender/TextWriterAppender.cs:

	Minor change - Replaced spaces with tabs.
	
	* Appender/IAppender.cs:

	Minor change - Updated copyright and minor documentation updates
	
	* Appender/ConsoleAppender.cs:

	Minor change - Replaced spaces with tabs
	
	* Appender/: ADONetAppender.cs, ASPNetTraceAppender.cs,
	BufferingAppenderSkeleton.cs, BufferingForwardingAppender.cs,
	CountingAppender.cs, EventLogAppender.cs, ForwardingAppender.cs,
	MemoryAppender.cs, OutputDebugStringAppender.cs,
	RemotingAppender.cs, RollingFileAppender.cs, SMTPAppender.cs,
	TraceAppender.cs:

	Minor change - Updated the copyright to include only Apache reference
	to Apache Software License version 1.1
	
2003-02-22 07:10  drieseng

	* Appender/TextWriterAppender.cs:

	Minor update
	Updated the license
	removed unnecessary using directives
	Documentation fix for .NETCF version + improved docs
	m_immediateFlush is now private instead of protected, public access to
	this variable was already available using the ImmediateFlush property
	reorganized source code
	
	* Appender/ConsoleAppender.cs:

	Documentation update for fixing warning in .NETCF version + improved
	docs
	Updated the license
	Removed override of ActiveOptions (nothing was done anyway)
	Changed organization of source
	
2003-02-21 16:44  drieseng

	* Appender/BufferingAppenderSkeleton.cs:

	Changed the example in the xml docs to refer to the ADONetAppender 
	instead of the SMTPAppender.  The SMTPAppender is currently not 
	available for the .NET Compact Framework version of log4net, so 
	referring to it in the xml docs would cause warnings on compilation
	(for the .NETCF version).
	
2003-02-19 09:49  ncadell

	* helpers/NativeError.cs:

	Fix from Gert to support calling FormatMessage on Win32
	
	* spi/Level.cs:

	Removed redundant field
	
2003-02-16 21:39  ncadell

	* Repository/Hierarchy/Logger.cs:

	Fixed to compile on the Compact Framework
	
2003-02-16 00:59  ncadell

	* Appender/OutputDebugStringAppender.cs:

	Updated to import correct native library for the compact framework
	
2003-02-16 00:38  ncadell

	* log4net.sln:

	Added log4net.Ext.EventID and EventIDLogApp projects
	
2003-02-16 00:22  ncadell

	* log4net.csproj:

	Added PropertiesCollection
	
	* spi/ILogger.cs:

	Updated docs
	
	* Appender/RollingFileAppender.cs:

	Updated due to Logger method change
	
	* Repository/Hierarchy/Logger.cs, spi/ILogger.cs, spi/LogImpl.cs:

	Simplified ILogger interface.
	Fixed issue with LocationInfo requiring the class name of the wrapper
	to be passed to the LoggingEvent.
	
	* Appender/EventLogAppender.cs:

	Updated EventLogAppender to read the EventID property as an int
	first before trying to parse it as a string.
	
	* helpers/PatternParser.cs:

	Updated to support new PropertiesCollection type for per event 
	properties
	
	* spi/LoggingEvent.cs:

	Updated to use PropertiesCollection for the per event Properties
	
	* helpers/PropertiesCollection.cs:

	Added PropertiesCollection. Simple mapping between a string key and
	an object value. Efficient serialization scheme.
	
2003-02-15 19:47  ncadell

	* Appender/ADONetAppender.cs:

	Updated to compile on the Compact Framework.
	
2003-02-14 01:43  ncadell

	* Appender/UdpAppender.cs:

	Added UdpAppender from Gert Driesen
	
2003-02-14 00:43  ncadell

	* helpers/SystemInfo.cs, Config/DOMConfiguratorAttribute.cs:

	Fixed DomConfiguratorAttribute to use the full assembly name
	including the extension when appending an additional extension
	to locate the config file.
	
2003-02-12 01:19  ncadell

	* Config/DomainAttribute.cs, spi/DefaultRepositorySelector.cs:

	Updated default behavior of DefaultRepositorySelector. Assemblies are
	now be default placed into the default domain. To specify another
	domain the DomainAttribute must be used. This is the opposite behavior
	to what was previously available.
	
2003-02-10 01:59  ncadell

	* Appender/ConsoleAppender.cs:

	Updated ConsoleAppender to write to the Console.Write or
	Console.Error.Write directly rather than caching the output
	streams. This means that the log will be written to wherever
	the stream points to at the time of the log message.
	
	* spi/DefaultRepositorySelector.cs:

	Fixed to request correct attribute types when loading PluginAttributes
	
2003-02-10 01:38  ncadell

	* NDC.cs, log4net.csproj, Appender/AppenderSkeleton.cs,
	Appender/FileAppender.cs, Appender/TraceAppender.cs,
	Config/AliasDomainAttribute.cs, Config/BasicConfigurator.cs,
	Config/DOMConfigurator.cs, Config/DOMConfiguratorAttribute.cs,
	Config/DomainAttribute.cs, Config/PluginAttribute.cs,
	Layout/IRawLayout.cs, Layout/RawLayoutConverter.cs,
	Layout/SimpleLayout.cs, Layout/XMLLayout.cs,
	ObjectRenderer/DefaultRenderer.cs, Plugin/PluginMap.cs,
	Repository/Hierarchy/DOMHierarchyConfigurator.cs,
	Repository/Hierarchy/Hierarchy.cs, Repository/Hierarchy/Logger.cs,
	Repository/Hierarchy/LoggerKey.cs, helpers/CyclicBuffer.cs,
	helpers/EmptyCollection.cs, helpers/EmptyDictionary.cs,
	helpers/EncodingConverter.cs, helpers/LogLog.cs,
	helpers/OptionConverter.cs, helpers/PatternParser.cs,
	helpers/SystemInfo.cs, spi/CompactRepositorySelector.cs,
	spi/DefaultRepositorySelector.cs, spi/Level.cs, spi/LevelMap.cs,
	spi/LocationInfo.cs, spi/LogException.cs, spi/LoggerManager.cs,
	spi/LoggingEvent.cs:

	Updated to use new type converter system.
	Added support for .NET Compact Framework
	
	* helpers/TypeConverters/: BooleanConverter.cs,
	ConversionNotSupportedException.cs, ConverterRegistry.cs,
	EncodingConverter.cs, IConvertFrom.cs, TypeConverterAttribute.cs:

	Added new type converter system
	
2003-02-10 00:20  ncadell

	* Appender/NetSendAppender.cs:

	Updated to use NativeError class for processing errors.
	Updates to code and docs from Gert Driesen.
	
	* helpers/NativeError.cs:

	Added NativeError class for processing errors from the underlying OS
	
2003-02-04 23:45  ncadell

	* Appender/NetSendAppender.cs, log4net.csproj:

	Added NetSendAppender. This appender delivers the log event using
	the windows messenger service.
	
2003-02-04 12:21  ncadell

	* spi/LoggerManager.cs:

	Moved code to the SystemInfo class
	
	* spi/DefaultRepositorySelector.cs:

	Dumps the assembly location to debug when a new assembly is detected.
	
	* Repository/Hierarchy/Logger.cs:

	Added more debug to dump info about the repository and the appdomain
	when no appenders are found for a logger.
	
	* Config/DOMConfigurator.cs:

	Added more debug info when loading a configuration. The repository 
	name is displayed. If the config is loaded from the .config file the 
	path to the config file is also displayed.
	
	* log4net.csproj, helpers/SystemInfo.cs:

	Added SystemInfo class with static methods for retrieving system 
	specific information typically used for debugging log4net.
	
	* Config/DOMConfiguratorAttribute.cs:

	Fixed doc comment warning
	
2003-02-02 16:59  ncadell

	* ChangeLog:

	Updated change log
	
2003-02-02 16:23  ncadell

	* helpers/OnlyOnceErrorHandler.cs:

	Put prefix string in square brackets [ and ]
	
2003-01-31 11:16  ncadell

	* log4net.sln:

	Removed old example projects CustomLog & TraceLogAssembly
	
	* AssemblyVersionInfo.cs:

	Updated version info.
	
	* LogManager.cs:

	Changed LogManager to use the LoggerManager.
	It now has the wrapper methods for generating ILog objects
	
	* ILog.cs:

	Updated ILog to extend ILoggerWrapper
	
	* Repository/Hierarchy/Logger.cs:

	Updated Logger to implement ILogger rather than ILog. Stripped the 
	ILog methods from the class.
	
	* Repository/Hierarchy/Hierarchy.cs:

	Updated to use ILogger rather than ILog
	
	* Repository/LoggerRepositorySkeleton.cs:

	Changed to use ILogger interface rather than ILog interface.
	Added more level definitions to the LevelMap
	
	* Repository/ILoggerRepository.cs:

	Updated to return ILogger objects rather than ILog
	
	* spi/LoggerManager.cs:

	Added LoggerManager class. This class has static methods to manage the
	domains and loggers at the ILoggerRepository and ILogger levels.
	
	* spi/WrapperMap.cs:

	Added WrapperMap class that maps between ILogger and ILoggerWrapper
	objects.
	
	* spi/LogImpl.cs:

	Implementation of ILog that extends ILoggerWrapper
	
	* spi/LoggerWrapperImpl.cs:

	Base implementation of ILoggerWrapper interface.
	
	* spi/ILoggerWrapper.cs:

	Added ILoggerWrapper interface. This is the base interface implemented
	by logger extensions or wrappers.
	
	* spi/ILogger.cs:

	Added ILogger interface the basic interface for a Logger
	
2003-01-30 17:50  ncadell

	* Category.cs:

	Removed old source file Category.cs
	
	* spi/DefaultRepositorySelector.cs:

	Added support for loading plugin attributes from the target assembly.
	
	* Config/DOMConfigurator.cs:

	Added error reporting when unable to open file or read xml arguments.
	
	* Config/BasicConfigurator.cs:

	Added documentation on how to use the IOptionHandler interface.
	
	* Config/PluginAttribute.cs:

	Added PluginAttribute.cs. This attribute specifies a type name for a
	plugin to be created and attached to the domain's hierarchy.
	
	* helpers/CyclicBuffer.cs:

	Updated Append() method to pass out the event that is discarded from 
	the buffer (if any).
	
	* Layout/ExceptionLayout.cs:

	Added ExceptionLayout.cs a stand alone layout that renders the 
	exception string.
	
	* Layout/SimpleLayout.cs:

	Fixed comment
	
	* Appender/BufferingForwardingAppender.cs:

	Added BufferingForwardingAppender.cs appender that buffers events and
	uses an evaluator to select the events to deliver to the nested 
	appenders.
	
	* Appender/ASPNetTraceAppender.cs:

	Adding ASPNetTraceAppender.cs appender that writes to the ASP.NET
	HttpContext.Trace
	
	* Appender/RollingFileAppender.cs:

	Added logging of exceptions.
	Made the RollFile and DeleteFile methods robust to file io exceptions.
	
	* Appender/BufferingAppenderSkeleton.cs:

	Fixed bug where the evaluator was not asked to check events when the
	buffer size was 1 or 0.
	
	Added LossyEvaluator which is used to examine events that are 
	discarded from the buffer and optionally send them to the appender.
	
	* Appender/AppenderSkeleton.cs, Appender/IAppender.cs:

	Added comment about using the IOptionHandler interface
	
2003-01-26 18:02  ncadell

	* Appender/OutputDebugStringAppender.cs:

	Simplified code slightly. Removed unused constructor.
	
2003-01-23 01:18  ncadell

	* DateFormatter/DateTimeDateFormatter.cs:

	Month was offset +1. Changed to call GetAbbreviatedMonthName().
	
2003-01-13 19:12  ncadell

	* Appender/ADONetAppender.cs:

	Added reference to http://www.connectionstrings.com/
	
2003-01-13 02:09  ncadell

	* Appender/ADONetAppender.cs:

	Added support for prepared statements and stored procedures.
	
2003-01-12 23:19  ncadell

	* Repository/Hierarchy/DOMHierarchyConfigurator.cs:

	Added support for using TypeConverters when creating objects
	
2003-01-12 23:17  ncadell

	* Layout/RawTimeStampLayout.cs:

	Added an IRawLayout that gets the TimeStamp of the logging event.
	
	* Layout/: IRawLayout.cs, Layout2RawLayoutAdapter.cs,
	RawLayoutConverter.cs:

	Added IRawLayout interface, this formats a logging event as an object
	rather than a string like the ILayout interface. The
	Layout2RawLayoutAdapter class allows an ILayout to be wrapped in a
	IRawLayout object. The RawLayoutConverter is a TypeConverter that
	supports automatically wrapping a ILayout with an adapter to make it
	into a IRawLayout interface.
	
	* helpers/OptionConverter.cs:

	Added CanConvertTypeTo() and ConvertTypeTo() methods. These methods
	look for TypeConverters to do any possible conversion from the
	source type to the target type.
	
	* Appender/EventLogAppender.cs:

	Added support for event ids. Each logging event has a Properties
	collection. If the event has an EventID property set then this
	will be used to set the EventID for the event log entry.
	
	* Appender/RollingFileAppender.cs:

	Changed test to use log.Log(level,msg) rather than log.Debug(msg)
	
2003-01-06 00:48  ncadell

	* Repository/Hierarchy/DOMHierarchyConfigurator.cs:

	Removed support for specifying constructor arguments to arbitrary 
	objects	in the config file. Objects created in the config file must
	have a default (public no argument) constructor.
	
	Removed the <object> element. Now the object type is specified 
	directly on the <param> element.
	
	For example:
	
	<param name="Evaluator">
	  <object type="log4net.spi.LevelEvaluator,log4net">
	    <constructor>
	      <param type="log4net.spi.Level,log4net" value="DEBUG"/>
	    </constructor>
	  </object>
	</param>
	
	becomes:
	
	<param name="Evaluator" type="log4net.spi.LevelEvaluator">
	  <param name="Threshold" value="DEBUG"/>
	</param>
	
	Added support for setting collection properties. A method with the
	signature Add<property name>(<property type>) must exist on the target
	object. This method will then be called for each <param> specifying
	the property name. The properties will be set in document order.
	
	* helpers/OptionConverter.cs:

	Added shortcut to ConvertStringTo() method if the required type is
	a string. Then no conversion is required.
	
2003-01-05 23:26  ncadell

	* spi/Level.cs:

	Added new levels
	
	* Plugin/RemoteLoggingServerPlugin.cs:

	Added default constructor. Added SinkURI property. Added exception
	handler around the remoting marshal call.
	
	* Repository/Hierarchy/DOMHierarchyConfigurator.cs:

	Changed use of class to type in variable names
	
2002-12-31 15:21  ncadell

	* Appender/ForwardingAppender.cs, Appender/MulticastAppender.cs,
	log4net.csproj:

	Renamed MulticastAppender to ForwardingAppender
	
2002-12-21 20:45  ncadell

	* Repository/Hierarchy/DOMHierarchyConfigurator.cs:

	Renamed ParesFilters() to ParseFilter() as it only parses a single
	filter.
	
	* log4net.csproj:

	Added MulticastAppender
	
	* Appender/MulticastAppender.cs:

	Added multicast appender
	

=============================================================================
Version 1.2.0 BETA 5
=============================================================================


2002-12-21 18:34  ncadell

	* AssemblyVersionInfo.cs:

	Updated version number to 1.2.0.21221
	
	* Repository/LoggerRepositorySkeleton.cs:

	Added check to Threshold setter to prevent the Threshold being set to
	null. If it is set to null then it will be set to Level.ALL.
	
	* Repository/Hierarchy/DOMHierarchyConfigurator.cs:

	Repository Threshold is not set to a null value if the level cannot 
	be decoded.
	
	* spi/LevelMap.cs:

	Updated LevelMap to use a case insensitive Hashtable to hold the 
	mapping between the level name and the Level object.
	
2002-12-19 22:46  ncadell

	* Config/DOMConfigurator.cs:

	Added check for null config XML element in ConfigureFromXML.
	

=============================================================================
Version 1.2.0 BETA 4
=============================================================================


2002-12-13 22:15  ncadell

	* Config/DOMConfigurator.cs:

	Updated the ConfigureFromXML() method to copy the configuration data
	from the XML element param into a new XML document. This isolates
	the config data from the rest of the original XML document. XPath 
	selects occur over the entire document regardless of which node they 
	are called from.
	
2002-12-13 00:47  ncadell

	* Appender/RemotingAppender.cs, Appender/SMTPAppender.cs,
	Layout/PatternLayout.cs, helpers/PatternParser.cs,
	spi/LoggingEvent.cs:

	Added Properties collection to the LoggingEvent type. This is a map of
	strings keyed on strings. The map is set on a per event basis unlike
	the MDC which is given (in current form) to each event. The properties
	map can be accessed using the PatternLayout with the %P{name} syntax.
	
	The RemotingAppender and the SMTPAppender both add the 'hostname'
	property to the Properties map.
	
2002-12-11 01:09  ncadell

	* Repository/Hierarchy/DOMHierarchyConfigurator.cs:

	Added config update mode attribute on the <log4net> element.
	This controls whether or not the hierarchy is reset before
	the configuration is loaded, i.e. is the configuration merged
	or overwritten. The default is merge, i.e. no reset.
	
2002-12-11 00:39  ncadell

	* Repository/LoggerRepositorySkeleton.cs:

	Setup the built-in levels in the constructor as well as in
	the ResetConfiguration handler.
	
	* Config/DOMConfigurator.cs:

	Removed ResetConfiguration() call when the config file could
	not be found. The current configuration continues unchanged
	when the file is not present.
	
	Changed the ConfigureAndWatchHandler to compress multiple
	notification events for a single file into one event. Previously
	up to 3 events were delivered, causing the configuration to
	be reloaded 3 times.
	
2002-12-10 22:25  ncadell

	* log4net.csproj, Plugin/IPlugin.cs, Plugin/PluginMap.cs,
	Plugin/PluginSkeleton.cs, Plugin/RemoteLoggingServerPlugin.cs,
	Repository/ILoggerRepository.cs,
	Repository/LoggerRepositorySkeleton.cs:

	Added IPlugin interface and supporting classes.
	Added RemoteLoggingServerPlugin
	
2002-12-07 01:52  ncadell

	* Repository/Hierarchy/DOMHierarchyConfigurator.cs:

	Removed support for parsing logger factories. They were not supported
	but the configurator still had code for parsing the elements.
	
2002-12-05 10:25  ncadell

	* spi/LoggingEvent.cs:

	Removed the SecurityPermissionAttribute from the GetObjectData method.
	This security check is not required because only public fields are
	serialized.
	
2002-12-05 01:00  ncadell

	* LogManager.cs, spi/DefaultRepositorySelector.cs,
	spi/LocationInfo.cs, spi/LoggingEvent.cs:

	Added code to cope with SecurityExceptions. If the code is running
	with reduced permissions then security violations can occur. The
	code now does a best attempt to log the information that is available.
	
	* helpers/OptionConverter.cs:

	Changed to use numeric formatting info when parsing numbers
	
	* Repository/Hierarchy/DOMHierarchyConfigurator.cs:

	Tweaked debug messages
	
	* helpers/PatternParser.cs:

	Changed FormatInfo to use correct numeric formatter
	
	* Appender/RollingFileAppender.cs, Layout/SimpleLayout.cs,
	Layout/XMLLayout.cs, ObjectRenderer/DefaultRenderer.cs:

	Changed AppendFormat() calls to multiple Append() calls. This should
	improve performance because the string does not need to be parsed.
	
2002-12-04 00:22  ncadell

	* spi/DefaultRepositorySelector.cs:

	Modified AliasRepository to allow calls that setup a duplicate alias.
	If the domain is already aliased to the repository then no action is
	taken.
	
2002-12-03 23:31  ncadell

	* spi/DefaultRepositorySelector.cs:

	Added additional check to AliasRepository. An exception is thrown if
	the domain being aliased has already been mapped to a repository.
	
	* LogManager.cs:

	Added check for SecurityException when getting the location of the
	log4net assembly (dumped to debug during start-up). When the caller
	does not have FileIOPermission the call to Assembly.Location will
	fail. This is now ignored.
	
2002-12-03 11:45  ncadell

	* Appender/BufferingAppenderSkeleton.cs:

	Added performance improvement when the buffer size is 0 or 1 the buffer
	is not used at all. The event is immediately dispatched.
	
	* Appender/ADONetAppender.cs:

	Added example of how to connect to Access DB using OLE DB rather than
	just using ODBC.
	
2002-12-01 23:32  ncadell

	* log4net.csproj, Config/AliasDomainAttribute.cs,
	Repository/ILoggerRepository.cs,
	Repository/LoggerRepositorySkeleton.cs,
	Repository/Hierarchy/DOMHierarchyConfigurator.cs,
	Repository/Hierarchy/Hierarchy.cs,
	spi/DefaultRepositorySelector.cs:

	Added domain aliasing using the new AliasDomainAttribute. This allows
	a main assembly to take control of shared assemblies logging domains.
	
2002-11-30 18:37  ncadell

	* ChangeLog:

	Updated ChangeLog
	
2002-11-27 16:21  ncadell

	* AssemblyVersionInfo.cs:

	Updated version number to 1.2.0.21127
	
2002-11-27 09:53  ncadell

	* LogManager.cs, Appender/AppenderSkeleton.cs,
	Appender/RemotingAppender.cs, Appender/RollingFileAppender.cs,
	Appender/TextWriterAppender.cs, Layout/SimpleLayout.cs,
	Layout/XMLLayout.cs, ObjectRenderer/DefaultRenderer.cs,
	Repository/ILoggerRepository.cs,
	Repository/LoggerRepositorySkeleton.cs,
	Repository/Hierarchy/Hierarchy.cs, helpers/LogLog.cs,
	helpers/OptionConverter.cs, helpers/PatternParser.cs,
	spi/IRepositorySelector.cs, spi/LocationInfo.cs,
	spi/LoggingEvent.cs:

	Minor updates due to FxCop reports
	
2002-11-26 00:30  ncadell

	* spi/: DefaultRepositorySelector.cs, IRepositorySelector.cs:

	Added LoggerRepositoryCreationEvent
	
	* Repository/Hierarchy/Hierarchy.cs:

	Added HierarchyConfigurationChangedEvent.
	Made obsolete methods with no implementation cause compilation errors.
	Renamed LoggerCreated event to LoggerCreatedEvent.
	
	* Repository/: ILoggerRepository.cs, LoggerRepositorySkeleton.cs:

	Added LoggerRepositoryShutdownEvent and
	LoggerRepositoryConfigurationResetEvent
	
	* helpers/OptionConverter.cs:

	Optimized reflection invoke method calls
	
2002-11-24 18:46  ncadell

	* log4net.csproj:

	Removed Priority.cs
	Added LevelMap.cs
	
	* Priority.cs:

	Removed obsolete file
	
	* spi/LevelMap.cs:

	Added LevelMap object. Maintains a mapping between level names and
	level objects.
	
	* Appender/RollingFileAppender.cs:

	Made private fields protected.
	Added check to RollFile to ensure that the source file
	exists. A warning is emitted if the file is missing.
	
	* Appender/OutputDebugStringAppender.cs:

	Made private method protected
	
	* Appender/: ADONetAppender.cs, ConsoleAppender.cs,
	EventLogAppender.cs:

	Made private methods virtual and protected
	
	* Filter/: LevelMatchFilter.cs, LevelRangeFilter.cs:

	Updated to use Level type properties rather than strings
	
	* Repository/ILoggerRepository.cs:

	Added LevelMap property.
	
	* Repository/LoggerRepositorySkeleton.cs:

	Added LevelMap property. Populated the level map in the
	ResetConfiguration() method.
	
	* Repository/Hierarchy/DOMHierarchyConfigurator.cs:

	Made configurator stateful. Stores the hierarchy as a member.
	Added code to lookup the levels by name using the LevelMap.
	
	* Repository/Hierarchy/Hierarchy.cs:

	Updated DOMHierarchyConfigurator.Configure() method arguments.
	
	* spi/LoggingEvent.cs:

	Level pool methods have been removed.
	
	* spi/Level.cs:

	Removed level pooling code.
	Made constructor public.
	Removed Parse() static methods.
	Removed type converter.
	Levels can now only be looked up from within the
	hierarchy that owns them.
	
	* helpers/OptionConverter.cs:

	Removed ToLevel() method. Levels can only be looked up from within the
	context of the hierarchy that owns them.
	
2002-11-10 23:39  ncadell

	* Appender/RollingFileAppender.cs:

	Fixed RollingFileAppender. When the StaticLogFileName property was set 
	to false (the default) the FileOpen function appended the current date
	regardless of the RollingStyle specified. When the rolling style is
	Size the date should not have been appended.
	
2002-11-07 01:06  ncadell

	* ObjectRenderer/RendererMap.cs:

	An exception thrown during object rendering is now caught in the
	findAndRender() method. A LogLog.Error() is generated with the
	exception. The object is rendered as a string indicating that
	it could not be rendered.
	
2002-11-07 00:47  ncadell

	* Appender/: BufferingAppenderSkeleton.cs, MemoryAppender.cs:

	Added OnlyFixPartialEventData property that causes the appender
	to call loggingEvent.FixVolatileData(bool) passing true. This
	gives a significant performance boost, but does not fix the
	location info and the user name settings.
	
	* spi/LoggingEvent.cs:

	Removed FixVolatileData call from the serialization GetObjectData
	method. FixVolatileData must be called during the IAppender.DoAppend
	method. Calling it during the GetObjectData method will be too late.
	
	Changed CacheMappedContext() to use the MDC.CopyMap() method.
	
	Added FixVolatileData(bool) method that optionally does not fix the
	location info and the user name. These two settings are very slow
	to generate and rarely actually needed. Therefore the user can
	specify that they need not be fixed.
	
	* log4net.ndoc:

	Upgraded to ndoc 1.1
	
	* log4net.csproj:

	Added EmptyDictionary and NullDictionaryEnumerator classes
	
	* Repository/Hierarchy/DOMHierarchyConfigurator.cs:

	Moved incorrect log warning message
	
	* MDC.cs:

	Added CopyMap() method that returns a copy of the MDC map for the
	current thread. This method is more efficient than calling the
	GetMap() method and then cloning the Hashtable returned.
	
	* helpers/: EmptyDictionary.cs, NullDictionaryEnumerator.cs:

	Added implementation of IDictionary that is always empty.
	This is a read only dictionary collection that contains no
	values. All interface methods are correctly implemented.
	
	* helpers/EmptyCollection.cs:

	Marked as serializable
	
2002-11-04 00:55  ncadell

	* Config/DOMConfigurator.cs:

	Updated xml config file loading to allow entity ref expansion.
	A validating xml reader is used to expand entity refs. It is not
	used to validate the xml document being loaded.
	This will allow an administrator to configure a config file
	to use external entities, i.e. to load the config from multiple
	files.
	
2002-11-04 00:32  ncadell

	* Config/DomainAttribute.cs, spi/DefaultRepositorySelector.cs:

	Removed UseExecutableDomain property from the DomainAttribute
	
2002-11-04 00:27  ncadell

	* Repository/Hierarchy/DOMHierarchyConfigurator.cs:

	Added support for expanding environment variables in <param> values.
	This only applies to strings read from the value attribute of
	a <param> element in the config file. The environment variables
	must be specified as '${FOO}' where 'FOO' is the name of the variable
	to expand.
	For example:
	<param name="File" value="${TMP}\\log-file.txt" />
	will use the value of the TMP environment variable as part of the
	path used to store the log file.
	
	Note that the ${...} syntax is used instead of the typical
	Environment variable syntax %...% because that syntax is used by the
	PatternLayout.
	
2002-10-28 13:21  ncadell

	* Config/DOMConfigurator.cs:

	Added extra error handling code for the XML document Load(file) call.
	
2002-10-17 12:32  ncadell

	* Appender/TextWriterAppender.cs:

	Fixed recursive call and stack overflow in ErrorHandler setter.
	
2002-10-14 01:27  ncadell

	* LogManager.cs, Priority.cs, log4net.csproj,
	Appender/AppenderSkeleton.cs, Appender/ConsoleAppender.cs,
	Appender/CountingAppender.cs, Appender/EventLogAppender.cs,
	Appender/FileAppender.cs, Appender/RollingFileAppender.cs,
	Appender/SMTPAppender.cs, Appender/TextWriterAppender.cs,
	DateFormatter/AbsoluteTimeDateFormatter.cs,
	DateFormatter/DateTimeDateFormatter.cs,
	Repository/Hierarchy/DOMHierarchyConfigurator.cs,
	Repository/Hierarchy/Hierarchy.cs, Repository/Hierarchy/Logger.cs,
	helpers/AppenderAttachedImpl.cs, helpers/CyclicBuffer.cs,
	helpers/FormattingInfo.cs, helpers/OptionConverter.cs,
	helpers/PatternParser.cs, helpers/Transform.cs, spi/Level.cs,
	spi/LogException.cs:

	Patch from Aspi Havewala to update to NUnit 2.0
	
2002-10-12 00:17  ncadell

	* AssemblyInfo.cs, Category.cs, ILog.cs, LogManager.cs, MDC.cs,
	NDC.cs, Priority.cs, Appender/ADONetAppender.cs,
	Appender/AppenderSkeleton.cs,
	Appender/BufferingAppenderSkeleton.cs, Appender/ConsoleAppender.cs,
	Appender/CountingAppender.cs, Appender/EventLogAppender.cs,
	Appender/FileAppender.cs, Appender/IAppender.cs,
	Appender/OutputDebugStringAppender.cs,
	Appender/RemotingAppender.cs, Appender/RollingFileAppender.cs,
	Appender/SMTPAppender.cs, Appender/TextWriterAppender.cs,
	Appender/TraceAppender.cs, Config/BasicConfigurator.cs,
	Config/ConfiguratorAttribute.cs, Config/DOMConfigurator.cs,
	Config/DOMConfiguratorAttribute.cs, Config/DomainAttribute.cs,
	DateFormatter/AbsoluteTimeDateFormatter.cs,
	DateFormatter/IDateFormatter.cs,
	DateFormatter/ISO8601DateFormatter.cs, Filter/FilterSkeleton.cs,
	Filter/IFilter.cs, Filter/LevelMatchFilter.cs,
	Filter/LevelRangeFilter.cs, Filter/MDCFilter.cs,
	Filter/NDCFilter.cs, Filter/StringMatchFilter.cs,
	Layout/ILayout.cs, Layout/LayoutSkeleton.cs,
	Layout/PatternLayout.cs, Layout/SimpleLayout.cs,
	Layout/XMLLayout.cs, ObjectRenderer/DefaultRenderer.cs,
	ObjectRenderer/IObjectRenderer.cs, ObjectRenderer/RendererMap.cs,
	Repository/ILoggerRepository.cs,
	Repository/LoggerRepositorySkeleton.cs,
	Repository/Hierarchy/DOMHierarchyConfigurator.cs,
	Repository/Hierarchy/Hierarchy.cs, Repository/Hierarchy/Logger.cs,
	helpers/AppenderAttachedImpl.cs,
	helpers/CountingQuietTextWriter.cs, helpers/EmptyCollection.cs,
	helpers/LogLog.cs, helpers/NullEnumerator.cs,
	helpers/OptionConverter.cs, helpers/PatternConverter.cs,
	helpers/PatternParser.cs, helpers/QuietTextWriter.cs,
	helpers/Transform.cs, spi/DefaultRepositorySelector.cs,
	spi/IErrorHandler.cs, spi/IOptionHandler.cs,
	spi/ITriggeringEventEvaluator.cs, spi/Level.cs,
	spi/LevelEvaluator.cs, spi/LocationInfo.cs, spi/LogException.cs,
	spi/LoggingEvent.cs:

	Fixed spelling errors
	
2002-10-11 22:38  ncadell

	* Config/DomainAttribute.cs:

	Fixed warning message text
	
	* Repository/Hierarchy/DOMHierarchyConfigurator.cs:

	Fixed DOMHierarchyConfigurator to not disable internal debugging if
	it has been enabled globally.
	
	* helpers/LogLog.cs:

	Made internal debug and quiet mode into read/write properties
	
2002-09-27 01:07  ncadell

	* Appender/AppenderSkeleton.cs:

	Added try/catch in DoAppend()
	
	* Appender/FileAppender.cs:

	Fixed error message when OpenFile() fails
	
	* Repository/Hierarchy/DOMHierarchyConfigurator.cs:

	Added check for missing nested appender
	
	* helpers/AppenderAttachedImpl.cs:

	Added try/catch blocks inside loops that call methods on all
	the appenders. This allows us to continue to the next appender
	even if the call fails for an appender.
	
2002-09-27 00:58  ncadell

	* helpers/OptionConverter.cs:

	Added argument checking to ToBoolean() method.
	
	* spi/DefaultRepositorySelector.cs:

	Added comment about expected compile time warning
	
2002-09-26 08:56  ncadell

	* spi/LoggingEvent.cs:

	Added CacheMappedContext() method used by FixVolatileData(). The MDC
	was not being fixed correctly. Now the MDC is copied into a new
	Hashtable when CacheMappedContext() is called.
	
2002-09-26 00:55  ncadell

	* spi/DefaultRepositorySelector.cs:

	Added more internal logging and error checking.
	
	* LogManager.cs:

	Moved RepositorySelector creation to the static constructor
	
2002-09-25 22:36  ncadell

	* Appender/ADONetAppender.cs,
	Repository/Hierarchy/DOMHierarchyConfigurator.cs,
	helpers/OptionConverter.cs:

	Cleaned up use of Type.GetType() to cause it to throw exceptions
	when it cannot load the required type.
	
2002-09-25 22:25  ncadell

	* Appender/FileAppender.cs:

	Added Encoding property used to pass to the StreamWriter constructor.
	
	* Appender/RollingFileAppender.cs:

	Updated CountingQuietTextWriter constructor not to take an
	Encoding parameter.
	
	* Appender/TraceAppender.cs:

	Updated comments
	
	* helpers/CountingQuietTextWriter.cs:

	Removed Encoding constructor argument. Now uses the Encoding property
	of the TextWriter to get the required encoding.
	
	* helpers/OptionConverter.cs:

	Added a TypeConverter registry. Added EncodingConverter to the
	type converter registry. Updated ConvertStringTo() to use the
	type converter registry to lookup the type converter.
	
	* log4net.csproj:

	Added EncodingConverter.cs
	
	* helpers/EncodingConverter.cs:

	Added EncodingConverter. This is a TypeConverter that supports
	converting a string to an Encoding.
	
2002-09-21 15:59  ncadell

	* AssemblyInfo.cs, log4net.csproj, log4net.sln:

	Added 'ReleaseStrong' configuration. This builds a strong named
	version of the dlls
	
2002-09-15 23:40  ncadell

	* AssemblyInfo.cs, AssemblyVersionInfo.cs, log4net.csproj:

	Added separate AssemblyVersionInfo.cs to each project holding the
	project version. Fixed the version at 1.2.0.20915
	
	* ChangeLog:

	checkin for 1.2.0 beta 3 release
	
	
=============================================================================
Version 1.2.0 BETA 3
=============================================================================


2002-09-08 19:02  ncadell

	* spi/LevelEvaluator.cs:

	Added default constructor that sets the threshold to Level.OFF
	
	* spi/Level.cs:

	Made Level.OFF public rather than internal

2002-09-08 17:36  ncadell

	* Appender/FileAppender.cs:

	Updated to use Path.Combine()
	
	* Config/DOMConfiguratorAttribute.cs:

	Updated to use Path.Combine() to build up the file paths.
	Added check for empty file name or file extension.
	
2002-09-05 13:00  ncadell

	* Appender/AppenderSkeleton.cs:

	Removed if(m_closed) check from AppenderSkeleton.DoAppend(). This check
	is also done in the PreAppendCheck() method which is sufficient. 
	However the DoAppend() method is not virtual and the PreAppendCheck() 
	method is.
	
2002-09-02 01:06  ncadell

	* log4net.sln:

	Added log4net.Ext.Trace project
	
2002-09-01 19:45  ncadell

	* log4net.csproj, Appender/MemoryAppender.cs:

	Added MemoryAppender. This appender stores all the events that are
	appended in an in-memory array.
	
2002-09-01 19:33  ncadell

	* Category.cs, LogManager.cs, log4net.csproj,
	Appender/RollingFileAppender.cs, Config/BasicConfigurator.cs,
	Config/DOMConfigurator.cs, Config/DOMConfiguratorAttribute.cs,
	Filter/FilterSkeleton.cs, Filter/IFilter.cs,
	Repository/DefaultLoggerFactory.cs, Repository/Hierarchy.cs,
	Repository/IBasicRepositoryConfigurator.cs,
	Repository/IDOMRepositoryConfigurator.cs,
	Repository/ILoggerFactory.cs, Repository/ILoggerRepository.cs,
	Repository/Logger.cs, Repository/LoggerKey.cs,
	Repository/LoggerRepositorySkeleton.cs,
	Repository/ProvisionNode.cs, Repository/RootLogger.cs,
	Repository/Hierarchy/DOMHierarchyConfigurator.cs,
	Repository/Hierarchy/DefaultLoggerFactory.cs,
	Repository/Hierarchy/Hierarchy.cs,
	Repository/Hierarchy/ILoggerFactory.cs,
	Repository/Hierarchy/Logger.cs, Repository/Hierarchy/LoggerKey.cs,
	Repository/Hierarchy/ProvisionNode.cs,
	Repository/Hierarchy/RootLogger.cs,
	spi/DefaultRepositorySelector.cs:

	Moved Hierarchy and all related classes into a separate
	namespace log4net.Repository.Hierarchy.
	
	Created LoggerRepositorySkeleton with basic implementation
	of a ILoggerRepository, Hierarchy now extends this.
	
	Moved implementation of the DOMConfigurator and BasicConfigurator
	into the log4net.Repository.Hierarchy namespace as these
	are Hierarchy specific classes. Left the static methods from
	the configurators in the log4net.Config namespace.
	
	* Appender/ADONetAppender.cs:

	Added debug messages
	
2002-08-31 18:38  ncadell

	* helpers/CountingQuietTextWriter.cs:

	Changed internal variable from m_count to m_countBytes to explicitly
	state that this variable is holding a byte count.
	
	* helpers/CountingQuietTextWriter.cs:

	Added use of an Encoding class to the CountingQuietTextWriter.
	The Encoding is used to count the number of bytes written, previously
	it was counting the number of characters written and assuming that
	this was the number of bytes written. This is correct only for an
	ASCII encoding or a UTF-8 using only ASCII characters. Now the encoding
	can be specified and the byte count will be correct.
	
	* Appender/RollingFileAppender.cs:

	Fixed bugs reported by Edward Smit.
	
2002-08-27 01:43  ncadell

	* log4net.sln:

	Added new examples
	
	* Config/DomainAttribute.cs, spi/DefaultRepositorySelector.cs:

	Made UseExecutableDomain obsolete.
	Added UseDefaultDomain.
	
	* Config/DOMConfigurator.cs:

	DOMConfigurator no longer extends the BasicConfigurator class.
	
	* Appender/TraceAppender.cs:

	Updated to use Layout property rather than m_layout member.
	
	* Appender/: SMTPAppender.cs, TextWriterAppender.cs:

	Updated appenders to use ErrorHandler for internal errors.
	Updated to use Layout property rather than m_layout member.
	
	* Appender/RollingFileAppender.cs:

	Updated appenders to use ErrorHandler for internal errors.

	* Appender/OutputDebugStringAppender.cs:

	Updated to use Layout property rather than m_layout member.
	
	* Appender/: EventLogAppender.cs, FileAppender.cs:

	Updated appenders to use ErrorHandler for internal errors.
	Updated to use Layout property rather than m_layout member.
	
	* Appender/ConsoleAppender.cs:

	Updated to use the Layout property rather than the m_layout member
	
	* Appender/BufferingAppenderSkeleton.cs:

	Updated appenders to use ErrorHandler for internal errors.
	
	* Appender/AppenderSkeleton.cs:

	Updated appenders to use ErrorHandler for internal errors.
	Changed creation of OnlyOnceErrorHandler to pass it the name
	of this class (i.e. the derived class) to use as a prefix
	on all error messages.
	
2002-08-27 00:52  ncadell

	* Appender/ADONetAppender.cs:

	Updated appenders to use ErrorHandler for internal errors.
	Updated loading of ODBC driver to use strong name to allow
	for loading from the GAC.
	
2002-08-27 00:45  ncadell

	* helpers/LogLog.cs:

	Updated comments
	
	* helpers/OnlyOnceErrorHandler.cs:

	Added void Error(string message, Exception e) method.
	Added prefix variable used with all output messages.
	
2002-08-27 00:43  ncadell

	* spi/IErrorHandler.cs:

	Added void Error(string message, Exception e) method.
	
2002-08-05 23:22  ncadell

	* helpers/: OptionConverter.cs, PatternParser.cs:

	Fixed usage of String.Substring(offset,length) where length should be
	the length of the substring returned not the index of the end of the
	substring. Was causing some out of bounds exceptions.
	
2002-08-03 23:43  ncadell

	* spi/LoggingEvent.cs:

	Added LoggingEventData as an externalizable data holder for the
	LoggingEvent object. Use the GetLoggingEventData() method to obtain
	the instance for the event. The LoggingEvent has a constructor
	that takes a LoggingEventData to use to initialize the event.
	
2002-08-03 22:49  ncadell

	* Appender/TextWriterAppender.cs:

	Added missing comment to WriteFooterAndCloseAppender()
	
	* helpers/QuietTextWriter.cs:

	Added Closed property for detecting when the writer has been closed
	
2002-08-03 20:02  ncadell

	* Appender/: FileAppender.cs, TextWriterAppender.cs:

	Fixed appending of the layout Footer so that it occurs whenever the
	writer is reset, rather than when the appender is closed. This fixes
	the problem of not writing the footer onto files rolled by the
	RollingFileAppender.
	
2002-08-03 17:03  ncadell

	* Appender/RollingFileAppender.cs:

	Updated File property to allow base class to rewrite the
	file path.
	
	* Appender/FileAppender.cs:

	If the target file is in a directory path that does not exist the
	directories required are now created.
	
	If a relative path is specified it is now relative to the
	AppDomain.BaseDirectory rather than the current directory.
	
	* spi/: LocationInfo.cs, LoggingEvent.cs:

	Added constructor to allow object to be created from stored data
	
2002-07-31 00:58  ncadell

	* ChangeLog:

	ChangeLog for 1.2.0 beta2

	
=============================================================================
Version 1.2.0 BETA 2
=============================================================================

	
2002-07-31 00:26  ncadell

	* Config/DOMConfigurator.cs:

	Added additional internal logging.

2002-07-28 19:51  ncadell

	* helpers/LogLog.cs:

	Updated static constructor to call OptionConverter.ToBoolean()
	when parsing the config app settings
	
	* helpers/OptionConverter.cs:

	Changed ToBoolean() method to use bool.Parse(string)
	
2002-07-28 19:30  ncadell

	* log4net.csproj, spi/DefaultRepositorySelector.cs,
	spi/LogException.cs, Repository/Hierarchy.cs,
	Repository/RootLogger.cs, helpers/OptionConverter.cs:

	Added LogException type. Updated code to only throw this type of
	exception.
	
2002-07-28 19:15  ncadell

	* Config/DOMConfigurator.cs:

	Added Debug message when config file could not be found
	
2002-07-28 19:06  ncadell

	* Appender/ADONetAppender.cs, Appender/AppenderSkeleton.cs,
	Appender/BufferingAppenderSkeleton.cs, Appender/ConsoleAppender.cs,
	Appender/EventLogAppender.cs, Appender/FileAppender.cs,
	Appender/RollingFileAppender.cs, Appender/SMTPAppender.cs,
	Appender/TextWriterAppender.cs, Config/BasicConfigurator.cs,
	Config/DOMConfigurator.cs, Repository/Logger.cs,
	Repository/RootLogger.cs, helpers/FormattingInfo.cs,
	helpers/OptionConverter.cs, helpers/PatternParser.cs:

	Updated internal logging calls to include the name of the class
	that the call originated from.
	
	* spi/DefaultRepositorySelector.cs:

	Added check for log4net.EntryAssembly config app setting. This 
	allows the ExecutableDomain assembly to be specified even when 
	the AppDomain does not have an EntryAssembly specified.
	
	* helpers/LogLog.cs:

	Added check for log4net.Internal.Debug and log4net.Internal.Quiet
	config app settings. These provide a global way of effecting the
	internal logging of log4net.
	
2002-07-25 23:39  ncadell

	* Repository/Hierarchy.cs:

	Changed LoggerCreation event delegate type to use standard pattern.
	Added LoggerCreationEventArgs object to pass as second param to the
	event handler.
	
2002-07-25 23:20  ncadell

	* spi/LoggingEvent.cs:

	Added FixVolatileData() method. Updated comments. Removed 'message'
	from serialized data.
	
	* spi/LevelEvaluator.cs:

	Made class public. Updated comments.
	
	* Config/DOMConfigurator.cs:

	Cleaned up error handling code, especially when failing to 
	resolve a type.
	
	* Appender/SMTPAppender.cs:

	Removed overridden Append() as data fixing is now done in the base
	class.
	
	* Appender/BufferingAppenderSkeleton.cs:

	Added comments. Added call to loggingEvent.FixVolatileData() in 
	Append().
	
	* Appender/AppenderSkeleton.cs:

	Added m_layout not null assertion to RenderLoggingEvent() method.
	
	* log4net.csproj, Appender/ADONetAppender.cs:

	Added ADONetAppender
	
2002-07-24 00:08  ncadell

	* log4net.csproj:

	Added BufferingAppenderSkeleton class
	
	* Appender/: AppenderSkeleton.cs, BufferingAppenderSkeleton.cs,
	ConsoleAppender.cs, CountingAppender.cs, EventLogAppender.cs,
	FileAppender.cs, OutputDebugStringAppender.cs, RemotingAppender.cs,
	RollingFileAppender.cs, SMTPAppender.cs, TextWriterAppender.cs,
	TraceAppender.cs:

	Refactored all appenders, moving generic functionality to the
	AppenderSkeleton class.
	Added BufferingAppenderSkeleton to be the parent of appenders
	that need to buffer their events before sending.
	
	* helpers/CyclicBuffer.cs:

	Added PopAll() method to return the entire contents in an array
	
2002-07-22 09:05  ncadell

	* log4net.sln:

	Added TraceLogApp and TraceLogAssembly projects
	
2002-07-22 08:33  ncadell

	* spi/DefaultRepositorySelector.cs:

	Changed GetRepository(Assembly) to be implemented using
	CreateRepository(Assembly,Type). Changed GetInfoForAssembly() to
	take params by ref rather than as out params. This allows the 
	caller to specify the default values for the domain and repository
	type.
	
	* LogManager.cs:

	Added overloaded methods taking Assembly parameter instead of 
	inferring it from Assembly.GetCallingAssembly(). This allows 
	extensions to pass through the calling assembly, therefore 
	extensions can be implemented in shared assemblies.
	
2002-07-21 19:55  ncadell

	* LogManager.cs, spi/DefaultRepositorySelector.cs,
	spi/IRepositorySelector.cs:

	Added CreateDomain(Type repositoryType) to LogManager and
	CreateRepository(Assembly assembly, Type repositoryType) to the
	IRepositorySelector interface and the DefaultRepositorySelector
	implementation. This allows the configuration to be read from
	the assemblies attributes but the type is set programmatically.
	
2002-07-21 16:05  ncadell

	* LogManager.cs:

	Fixed comments.
	Renamed Shutdown() methods to ShutdownRepository().
	Added Shutdown() method to shutdown all repositories.
	Added hooks for the ProcessExit and DomainUnload events
	to automatically shutdown log4net.
	
2002-07-21 10:32  ncadell

	* Appender/TextWriterAppender.cs:

	Added check to SubAppend() to log the exception only if there 
	is one.
	
2002-07-21 00:56  ncadell

	* Appender/RollingFileAppender.cs,
	Config/DOMConfiguratorAttribute.cs,
	spi/DefaultRepositorySelector.cs:

	Fixed argument validation
	
	* Appender/EventLogAppender.cs:

	Added argument validity tests.
	Fixed unit test
	
2002-07-19 00:05  ncadell

	* log4net.csproj:

	Added helpers\EmptyCollection.cs
	
	* log4net.ndoc:

	Updated namespace docs. Changed to build docs from the Debug
	configuration.
	
	* LogManager.cs:

	Updated comments. Changed GetCurrentLoggers() to return an ILog 
	array.
	
	* Appender/: TextWriterAppender.cs, SMTPAppender.cs:

	Updated comments. LoggingEvent.GetExceptionStrRep() changed to 
	return a string.
	
	* Config/DOMConfigurator.cs:

	Updated because ILoggerRepository method GetInstance() has been 
	renamed to GetLogger().
	
	* Layout/XMLLayout.cs:

	Updated because LoggingEvent.GetExceptionStrRep() now returns a 
	string not a string array.
	
2002-07-18 19:58  ncadell

	* Repository/Logger.cs:

	Changed GetAllAppenders() to return an ICollection. Updated 
	comments.
	
	* Repository/ILoggerRepository.cs:

	Renamed GetInstance() to GetLogger(). Changed GetCurrentLoggers() 
	to return an ILog array. Updated comments.
	
	* Repository/Hierarchy.cs:

	Renamed GetInstance() to GetLogger(). Changed GetCurrentLoggers() 
	to return an ILog array. Updated comments. Changed some variable 
	names to be more informative.
	
	* spi/LoggingEvent.cs:

	Removed stackTraceInfo. Removed ThrowableInformation public 
	property. Changed GetExceptionStrRep() public method to return a 
	string rather than a string array.
	
	* spi/IAppenderAttachable.cs:

	Changed GetAllAppenders() method to return an ICollection.
	
	* helpers/NullEnumerator.cs:

	Updated comments. Changed GetInstance() method into a property 
	Instance.
	
	* helpers/AppenderAttachedImpl.cs:

	Changed GetAllAppenders() to return ICollection
	
2002-07-18 18:03  ncadell

	* helpers/EmptyCollection.cs:

	An implementation of ICollection that is always empty.
	
2002-07-16 02:11  ncadell

	* Layout/XMLLayout.cs:

	Added empty constructor
	
2002-06-30 23:09  ncadell

	* ChangeLog:

	Updated change log to version 1.2.0 BETA 1
	
	
=============================================================================
Version 1.2.0 BETA 1
=============================================================================
	

2002-06-30 22:03  ncadell

	* spi/LoggingEvent.cs:

	Specified SecurityPermission Demand SerializationFormatter on the
	ISerializable GetObjectData() method.
	
	* spi/Level.cs:

	Added Compare(Level,Level) static method and CompareTo(object) 
	method.	Fixed cryptic method param names. Specified culture 
	where possible.
	
	* helpers/QuietTextWriter.cs:

	Added getter for ErrorHandler property.
	
	* helpers/PatternParser.cs:

	Specify the culture where possible.
	
	* helpers/OptionConverter.cs:

	Fixed cryptic method param names.
	Specified the culture where possible.
	
	* Repository/RootLogger.cs:

	Added getter to Level property.
	
	* Repository/LoggerKey.cs, ObjectRenderer/DefaultRenderer.cs, 
	Config/DOMConfigurator.cs:

	Fixed cryptic method param name.
	
	* Layout/XMLLayout.cs:

	Fixed example in comment.
	Changed content type to text/xml
	
	* Layout/LayoutSkeleton.cs:

	Added support for storing and settings the Header and Footer
	properties in the skeleton class.
	
	* Config/: ConfiguratorAttribute.cs, DOMConfiguratorAttribute.cs,
	DomainAttribute.cs:

	Marked all attributes as sealed
	
	* Appender/TextWriterAppender.cs:

	Added getter for ErrorHandler property
	
	* Appender/RollingFileAppender.cs:

	Fixed cryptic method params.
	Fixed illegal CLS public member variable names.
	
	* Appender/RemotingAppender.cs:

	Fixed method comments
	
	* MDC.cs, Appender/ConsoleAppender.cs:

	Fixed cryptic method params.
	Specified culture where appropriate.
	
	* AssemblyInfo.cs:

	Added CLSCompliant(true) and ComVisible(false) attributes to the 
	assembly.
	
2002-06-24 11:01  ncadell

	* .cvsignore, log4net.csproj, log4net.ndoc:

	Changed doc.xml to log4net.xml
	
2002-06-24 00:58  ncadell

	* LogManager.cs, Repository/Hierarchy.cs,
	Repository/ILoggerRepository.cs, spi/DefaultRepositorySelector.cs,
	spi/IRepositorySelector.cs:

	Added GetAllRepositories() method to LogManager, IRepositorySelector 
	and DefaultRepositorySelector. This returns a list of all the 
	currently defined repositories.
	
	Added Name property to the ILoggerRepository and Hierarchy. This 
	is the name (or domain name) of the repository.
	
	* Appender/ConsoleAppender.cs:

	Changed constructor to call ActivateOptions(). This fixed error
	checking when not configuring via the DOMConfigurator.
	
2002-06-19 22:18  ncadell

	* spi/LoggingEvent.cs:

	Changed rendering of exceptions to use the ObjectRenderer map. 
	This allows	the rendering of exceptions to be intercepted in a 
	user defined way. The exception is not serialized with the 
	LoggingEvent only the string representation is serialized.
	
	* ObjectRenderer/DefaultRenderer.cs:

	Added support for rendering exceptions.
	Broke code out into more modular functions so that overriding 
	should be more flexible.
	
	* Appender/TextWriterAppender.cs, Layout/LayoutSkeleton.cs,
	helpers/PatternParser.cs:

	Removed LayoutSkeleton.LINE_SEP constant. Use Environment.NewLine 
	instead
	
2002-06-19 21:43  ncadell

	* Appender/RemotingAppender.cs, Appender/SMTPAppender.cs,
	Config/DOMConfigurator.cs:

	Updated DOMConfigurator to be able to set properties to new 
	instances of objects this is done with syntax like:
	
		<param name="Evaluator">
			<object type="log4net.spi.LevelEvaluator,log4net">
				<constructor>
					<param type="log4net.spi.Level,log4net" value="DEBUG"/>
				</constructor>
			</object>
		</param>
	
	Updated RemotingAppender and SMTPAppender to have an Evaluator 
	property that can be set to the instance of the evaluator to use.
	
	Added 'Lossy' property to SMTPAppender this allows the appender to 
	be configured not to discard logging events that have not been sent 
	due to the lack of a triggering event. When the buffer becomes full 
	the contents of the buffer is sent.
	
2002-06-18 13:47  ncadell

	* Config/DOMConfigurator.cs:

	When loading a config file that does not exist all the logging from 
	the Hierarchy is disabled by setting the Threshold to Level.OFF
	
2002-06-17 21:11  ncadell

	* Layout/XMLLayout.cs:

	Added escaping of closing CDATA tags within CDATA sections.
	
	* helpers/Transform.cs:

	Added AppendEscapingCDATA() method to escape the end CDATA tags 
	within a CDATA section.
	
2002-06-17 20:32  ncadell

	* AssemblyInfo.cs, Category.cs, ILog.cs, LogManager.cs, MDC.cs,
	NDC.cs, Priority.cs, Appender/AppenderSkeleton.cs,
	Appender/ConsoleAppender.cs, Appender/CountingAppender.cs,
	Appender/EventLogAppender.cs, Appender/FileAppender.cs,
	Appender/IAppender.cs, Appender/OutputDebugStringAppender.cs,
	Appender/RemotingAppender.cs, Appender/RollingFileAppender.cs,
	Appender/SMTPAppender.cs, Appender/TextWriterAppender.cs,
	Appender/TraceAppender.cs, Config/BasicConfigurator.cs,
	Config/ConfiguratorAttribute.cs, Config/DOMConfigurator.cs,
	Config/DOMConfiguratorAttribute.cs, Config/DomainAttribute.cs,
	Config/Log4NetConfigurationSectionHandler.cs,
	DateFormatter/AbsoluteTimeDateFormatter.cs,
	DateFormatter/DateTimeDateFormatter.cs,
	DateFormatter/IDateFormatter.cs,
	DateFormatter/ISO8601DateFormatter.cs,
	DateFormatter/SimpleDateFormatter.cs, Filter/DenyAllFilter.cs,
	Filter/FilterSkeleton.cs, Filter/IFilter.cs,
	Filter/LevelMatchFilter.cs, Filter/LevelRangeFilter.cs,
	Filter/MDCFilter.cs, Filter/NDCFilter.cs,
	Filter/StringMatchFilter.cs, Layout/ILayout.cs,
	Layout/LayoutSkeleton.cs, Layout/PatternLayout.cs,
	Layout/SimpleLayout.cs, Layout/XMLLayout.cs,
	ObjectRenderer/DefaultRenderer.cs,
	ObjectRenderer/IObjectRenderer.cs, ObjectRenderer/RendererMap.cs,
	Repository/DefaultLoggerFactory.cs, Repository/Hierarchy.cs,
	Repository/ILoggerFactory.cs, Repository/ILoggerRepository.cs,
	Repository/Logger.cs, Repository/LoggerKey.cs,
	Repository/ProvisionNode.cs, Repository/RootLogger.cs,
	helpers/AppenderAttachedImpl.cs,
	helpers/CountingQuietTextWriter.cs, helpers/CyclicBuffer.cs,
	helpers/FormattingInfo.cs, helpers/LogLog.cs,
	helpers/NullEnumerator.cs, helpers/OnlyOnceErrorHandler.cs,
	helpers/OptionConverter.cs, helpers/PatternConverter.cs,
	helpers/PatternParser.cs, helpers/QuietTextWriter.cs,
	helpers/Transform.cs, spi/DefaultRepositorySelector.cs,
	spi/IAppenderAttachable.cs, spi/IErrorHandler.cs,
	spi/IOptionHandler.cs, spi/IRepositorySelector.cs,
	spi/ITriggeringEventEvaluator.cs, spi/Level.cs,
	spi/LevelEvaluator.cs, spi/LocationInfo.cs, spi/LoggingEvent.cs:

	Moved copyright into a region
	
2002-06-17 20:07  ncadell

	* Category.cs, LogManager.cs, Priority.cs, log4net.csproj,
	log4net.sln, Appender/RollingFileAppender.cs,
	Config/BasicConfigurator.cs, Config/ConfiguratorAttribute.cs,
	Config/DOMConfigurator.cs, Config/DomainAttribute.cs,
	Repository/Logger.cs, spi/DefaultRepositorySelector.cs,
	spi/IRepositorySelector.cs, Config/DOMConfiguratorAttribute.cs:

	Added support for logging domains. This allows separate assemblies 
	to have	control over their logging. Added DomainAttribute for 
	configuring the	domain for an assembly.
	Added DOMConfiguratorAttribute to allow the DOMConfigurator settings
	to be specified as an attribute on the assembly rather than being
	specified in code.
	
2002-06-14 18:19  ncadell

	* Category.cs, LogManager.cs, Appender/RollingFileAppender.cs,
	Config/DOMConfigurator.cs, Repository/Hierarchy.cs,
	Repository/ILoggerRepository.cs, Repository/Logger.cs:

	Changed some docs
	
2002-06-14 17:37  ncadell

	Renamed the Priority class to Level in line with log4j 1.2
	
	* spi/PriorityEvaluator.cs:
	
	Renamed to LevelEvaluator
	
	* spi/LoggingEvent.cs:

	Added UserName property
	
	* spi/LevelEvaluator.cs:

	Renamed from PriorityEvaluator
	
	* spi/Level.cs:

	Renamed from Priority
	
	* helpers/PatternParser.cs:

	Added 'u' pattern to include the current user info. This
	pattern replaces the 'W' pattern (which is still available).
	
	* Repository/Logger.cs:

	Changed GetChainedLevel() to GetEffectiveLevel()
	
	* Repository/Hierarchy.cs:

	Changed from using Disable...() methods to using a Threshold property.
	
	* Layout/XMLLayout.cs:

	Changed the 'priority' attribute to 'level'
	
	* Layout/PatternLayout.cs:

	Added 'u' pattern to include the current user info. This
	pattern replaces the 'W' pattern (which is still available).
	
	* Filter/PriorityRangeFilter.cs:

	Renamed to PriorityRangeFilter
	
	* Filter/PriorityMatchFilter.cs:

	Renamed to PriorityMatchFilter
	
	* Filter/LevelRangeFilter.cs:

	Renamed from PriorityRangeFilter
	
	* Filter/LevelMatchFilter.cs:

	Renamed from PriorityMatchFilter
	
	* Config/DOMConfigurator.cs:

	Added support for <level> element in place of <priority> element as
	a child of the <logger> element.
	Added support for settings the Threshold on the hierarchy.
	
	* Priority.cs:

	Priority class is retained for backward compatibility only. Methods 
	are marked as obsolete.
	
2002-05-29 01:38  ncadell

	* spi/PriorityEvaluator.cs:
	
	Moved from DefaultEvaluator
	
	* spi/LoggingEvent.cs:

	Changed to use StringBuilder.AppendFormat() On deserialize it 
	loads the Priority from the intern pool.
	
	* helpers/Transform.cs:

	New class to perform data transformations. Currently supports 
	escaping of XML strings.
	
	* helpers/OptionConverter.cs:

	Added ConvertStringTo() method that takes a string and a Type to 
	convert it to. Returns an instance of Type initialized from the
	string. Uses various methods to do the conversion.
	
	* Repository/LoggerKey.cs:

	Changed String to string. updated use of ReferenceEquals()
	
	* Repository/: DefaultLoggerFactory.cs, ILoggerFactory.cs:

	Removed ParsePriority() method.
	
	* Layout/XMLLayout.cs:

	New layout to layout event as an XML fragment.
	
	* Layout/SimpleLayout.cs:

	Changed to use StringBuilder.AppendFormat()
	
	* Filter/StringMatchFilter.cs:

	Updated to use FilterDecision enumeration. Added support for 
	regex matching.
	
	* Filter/NDCFilter.cs:

	New filter to substring or regex match on the NDC value.
	
	* Filter/MDCFilter.cs:

	New filter to substring or regex match on one of the MDC values.
	
	* Filter/FilterSkeleton.cs:

	Updated to use FilterDecision enumeration. Made ActivateOptions() 
	virtual.
	
	* Filter/: DenyAllFilter.cs, IFilter.cs, PriorityMatchFilter.cs,
	PriorityRangeFilter.cs:

	Updated to use FilterDecision enumeration.
	
	* Config/DOMConfigurator.cs:

	Removed GetFirstFilter() use Filter { get; } instead. Removed 
	AddFilter() use Filter { set; } instead. Removed ClearFilters() 
	use Filter = null instead. Changed to use 
	OptionConverter.ConvertStringTo() where possible.
	
	* Appender/TextWriterAppender.cs:

	Made CheckEntryConditions() virtual. Make WriteHeader() 
	virtual. Make WriteFooter() virtual.
	
	* Appender/SMTPAppender.cs:

	Changed to use PriorityEvaluator. Moved DefaultEvaluator to 
	PriorityEvaluator
	
	* Appender/RemotingAppender.cs:

	Added constructor taking ITriggeringEventEvaluator argument
	
	* Appender/IAppender.cs:

	Removed GetFirstFilter() use Filter { get; } instead. 
	Removed AddFilter() use Filter { set; } instead. Removed 
	ClearFilters() use Filter = null instead.
	
	* Appender/ConsoleAppender.cs, Appender/EventLogAppender.cs,
	Appender/RollingFileAppender.cs, Layout/PatternLayout.cs,
	ObjectRenderer/IObjectRenderer.cs, Repository/Hierarchy.cs,
	Repository/Logger.cs, helpers/PatternConverter.cs,
	spi/LocationInfo.cs:

	Changed String to string.
	
	* Appender/AppenderSkeleton.cs:

	Changed String to string. Removed GetFirstFilter() use Filter { get; } 
	instead. Removed AddFilter() use Filter { set; } instead. Removed 
	ClearFilters() use Filter = null instead. Added FilterDecision 
	enumeration.
	
	* Priority.cs:
	
	Changed Priority to be a mapping between integer level and a display
	String for the level. Class is now sealed and has a private 
	constructor. Static methods are used to create instances of the class 
	and these are internally pooled (like String.Intern()). This allows 
	extenders to add new Priorities without extending the class and also 
	ensures that serialized events will be able to reconstruct their 
	Priority objects even when the sub classing code is not available. 
	This allows us to develop stand alone remoting sinks that do not need 
	to be modified to support customized logging frameworks.
	
2002-05-20 11:41  ncadell

	* log4net.csproj, log4net.sln:

	Adding project files for the 1.2 checkin
	
2002-05-19 18:58  ncadell

	* ChangeLog:

	Updated changed log for initial 1.2 code checkin
	
2002-05-19 18:42  ncadell

	* spi/: ProvisionNode.cs, RootCategory.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	Moved to Repository
	
	* spi/LoggingEvent.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	Made [Serializable] and implemented ISerializable interface. 
	Changed to use Logger rather than Category.
	
	* spi/LocationInfo.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	Made [Serializable] and changed caching scheme.
	
	* spi/ICategoryFactory.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	Moved to Repository.ILoggerFactory
	
	* spi/DefaultCategoryFactory.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	Moved to Repository.DefaultLoggerKey
	
	* spi/CategoryKey.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	Moved to Repository.LoggerKey
	
	* helpers/PatternParser.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	Updated to use Logger rather than Category
	
	* helpers/CyclicBuffer.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	Changed Append() to return true while the buffer is not full. 
	Once the buffer is full and subsequent Appends will overwrite 
	data in the buffer then the method will return false.
	
	* Repository/: ProvisionNode.cs, RootLogger.cs, LoggerKey.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	Moved
	
	* Repository/Logger.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	Takes over the role of the Category class. This class is used 
	in the implementation of the Hierarchy class.
	
	* Repository/ILoggerRepository.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	Interface that must be implemented by Repositories. Currently 
	only implemented by Hierarchy.
	
	* Repository/ILoggerFactory.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	Takes over the role of the ICategoryFactory
	
	* Repository/Hierarchy.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	The new home for the Hierarchy class. Now implements the 
	ILoggerRepository interface. Internally uses the Logger 
	class to implement its internal hierarchy of logging categories.
	
	* Repository/DefaultLoggerFactory.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	Implementation of ILoggerFactory for the Logger class. Takes 
	over the role of the DefaultCategoryFactory.
	
	* ObjectRenderer/RendererMap.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	Updated FindAndRender() to pass the RendererMap to the renderer
	
	* ObjectRenderer/IObjectRenderer.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	Changed DoRender() to take the RendererMap. This allows a 
	renderer to render composite objects correctly, i.e. 
	delegating to the correct renderers where possible.
	
	* ObjectRenderer/DefaultRenderer.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	Added support for rendering arrays
	
	* Layout/SimpleLayout.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	Added new and very simple layout. This consists of a format 
	which is "PRIORITY - MESSAGE"
	
	* Filter/FilterSkeleton.cs, Filter/IFilter.cs,
	Layout/PatternLayout.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	updated docs
	
	* Config/DOMConfigurator.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	Updated to configure new Hierarchy and Logger
	
	* Config/BasicConfigurator.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	Updated to Configure the LogManager.LoggerRepository
	
	* Appender/SMTPAppender.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	Changed the point at which the cyclic buffer is created so that 
	we don't waste any effort if the buffer size is set in the 
	configuration.
	
	* Appender/RollingFileAppender.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	Added Doug de la Torre's modifications: The RollingFileAppender 
	includes some bug fixes and LOTS of  refactoring for the Unit tests.  
	They use a more table-driven approach, which is much more thorough 
	and easier to understand. The tests for all the counted cases are 
	complete and fairly exhaustive. Tests for the Date and Date/Count 
	based rolling are still to be completed.
	
	* Appender/RemotingAppender.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	New appender that serializes logging events over .NET remoting 
	to a server running in a separate process. This can be used 
	to combine logging events in a distributed system.
	
	* Appender/EventLogAppender.cs:

	Moved Hierarchy and Category to the Repository namespace.
	Added Doug de la Torre's modifications: I've cleaned up 
	the EventLogAppender, and included simple NUnit  tests.  
	I changed the Hash-table based lookups to a much simpler  
	comparison to determine the info/warn/error messages for 
	logging, which I believe will be faster and simpler.  
	Finally, I changed the logging mechanism to trap exceptions, 
	which prevents an uncaught exception from being thrown if 
	the event log fills up.
	
	* Appender/AppenderSkeleton.cs:

	Moved Hierarchy and Category to the Repository namespace.
	Added missing return to DoAppend() if the appender is closed.
	
	* Priority.cs:

	Moved Hierarchy and Category to the Repository namespace.
	Made [Serializable] and made the level constants protected 
	rather than private.
	
	* MDC.cs:

	Moved Hierarchy and Category to the Repository namespace.
	Changed GetMap() from private to internal. This needs to be 
	called by LoggingEvent when it is serialized so that it 
	can deserialize correctly.
	
	* LogManager.cs:

	Moved Hierarchy and Category to the Repository namespace.
	Updated to use ILoggerRepository interface Added NUnit test 
	suite. You can now run all the tests by executing 
	NUnitConsole.exe log4net.LogManager+AllTests,log4net.dll
	
	* ILog.cs:

	Moved Hierarchy and Category to the Repository namespace.
	Updated docs
	
	* Hierarchy.cs:

	Moved Hierarchy and Category to the Repository namespace.
	
	* Category.cs:

	Moved Hierarchy and Category to the Repository namespace.   
	Changed Category to be a wrapper class around the new LogManager 
	and ILog interfaces. Category implements the same static methods 
	as it used to, but these are implemented over the LogManager methods. 
	The code from Category have been moved to the Repository.Logger class.
	
	* AssemblyInfo.cs:

	Moved Hierarchy and Category to the Repository namespace.
	Updated version number to 1.2.0.*

	
=============================================================================
Version 1.1.1
=============================================================================
	
	
2002-04-14 19:50  ncadell

	* AssemblyInfo.cs:

	Updated assembly version to 1.1.1.*
	
2002-03-28 00:23  ncadell

	* Appender/EventLogAppender.cs:

	Added ConvertPriority2EventLogEntryType() static method.
	
2002-03-26 09:56  ncadell

	* Appender/EventLogAppender.cs:

	Tweaked the event log so that the LogName event log does actually get 
	created.
	Also managed to get the events to appear with appropriate event type 
	indications (as near as possible given only 3 choices).
	
	* Priority.cs:

	Removed syslog constants from Priority. I don't think it is a good idea
	to stuff all possible variants of priority representation into the 
	implementation of this class, it only knows about log4net priorities, 
	it is up to others (usually appenders) to map to other priority (or 
	level) schemes.
	
2002-03-25 02:14  ncadell

	* Config/DOMConfigurator.cs:

	Added Configure(FileInfo) and ConfigureAndWatch(FileInfo) methods.
	These allow the config file to be loaded from any arbitrary XML file
	that contains an <log4net> element that holds the configuration info.
	The ConfigureAndWatch() method registers for change events on the
	config file and reloads the config if the config file is modified.
	
	
=============================================================================
Version 1.1.0
=============================================================================
	
	
2002-03-24 20:13  ncadell

	* log4net.ndoc:

	Changed copyright link url
	
2002-03-24 19:57  ncadell

	* AssemblyInfo.cs:

	Updated version number to 1.1.0
	
	* log4net.csproj:

	Removed reference to NUnit, just for now.
	
	* Category.cs, Hierarchy.cs, ILog.cs, LogManager.cs, MDC.cs,
	NDC.cs, Priority.cs, log4net.ndoc, Appender/RollingFileAppender.cs,
	Appender/TextWriterAppender.cs, DateFormatter/IDateFormatter.cs,
	DateFormatter/SimpleDateFormatter.cs, Filter/FilterSkeleton.cs,
	Filter/IFilter.cs, helpers/CyclicBuffer.cs, spi/LoggingEvent.cs:

	Updated documentation comments
	
2002-03-24 17:38  ncadell

	* Category.cs, Hierarchy.cs, ILog.cs, LogManager.cs, MDC.cs,
	NDC.cs, Appender/AppenderSkeleton.cs, Appender/EventLogAppender.cs,
	Appender/IAppender.cs, Appender/OutputDebugStringAppender.cs,
	Appender/RollingFileAppender.cs, Appender/SMTPAppender.cs,
	Appender/TextWriterAppender.cs, Appender/TraceAppender.cs,
	DateFormatter/AbsoluteTimeDateFormatter.cs,
	Filter/FilterSkeleton.cs, Filter/IFilter.cs,
	Filter/PriorityMatchFilter.cs, Filter/PriorityRangeFilter.cs,
	Layout/PatternLayout.cs, helpers/LogLog.cs,
	helpers/OnlyOnceErrorHandler.cs, helpers/OptionConverter.cs:

	Updated documentation comments
	
2002-03-16 20:22  ncadell

	* .cvsignore, Category.cs, Hierarchy.cs, ILog.cs, LogManager.cs,
	log4net.csproj, log4net.sln, Appender/RollingFileAppender.cs,
	Appender/SMTPAppender.cs, Appender/TextWriterAppender.cs,
	Config/BasicConfigurator.cs,
	DateFormatter/AbsoluteTimeDateFormatter.cs,
	DateFormatter/DateTimeDateFormatter.cs,
	DateFormatter/IDateFormatter.cs,
	DateFormatter/ISO8601DateFormatter.cs,
	DateFormatter/SimpleDateFormatter.cs, Layout/PatternLayout.cs,
	ObjectRenderer/DefaultRenderer.cs,
	ObjectRenderer/IObjectRenderer.cs, ObjectRenderer/RendererMap.cs,
	helpers/AbsoluteTimeDateFormatter.cs,
	helpers/DateTimeDateFormatter.cs, helpers/IDateFormatter.cs,
	helpers/ISO8601DateFormatter.cs, helpers/PatternParser.cs,
	helpers/SimpleDateFormatter.cs:

	Moved DateFormatters to new log4net.DateFormatter namespace.
	Moved ObjectRenderers to new log4net.ObjectRenderer namespace.
	Updated references to new namespaces.
	
	Added LogManager class to separate static methods away from
	the Category class. Static methods in the Category class
	are now deprecated.
	
2002-03-11 09:44  ncadell

	* Category.cs, Hierarchy.cs, ILog.cs, MDC.cs, NDC.cs, Priority.cs,
	Appender/AppenderSkeleton.cs, Appender/ConsoleAppender.cs,
	Appender/EventLogAppender.cs, Appender/IAppender.cs,
	Appender/OutputDebugStringAppender.cs,
	Appender/RollingFileAppender.cs, Appender/SMTPAppender.cs,
	Appender/TextWriterAppender.cs, Appender/TraceAppender.cs,
	Config/DOMConfigurator.cs, Filter/FilterSkeleton.cs,
	Filter/IFilter.cs, Filter/PriorityMatchFilter.cs,
	Filter/PriorityRangeFilter.cs, Layout/ILayout.cs,
	Layout/LayoutSkeleton.cs, Layout/PatternLayout.cs,
	helpers/AbsoluteTimeDateFormatter.cs,
	helpers/AppenderAttachedImpl.cs, helpers/CyclicBuffer.cs,
	helpers/LogLog.cs, helpers/OnlyOnceErrorHandler.cs,
	helpers/OptionConverter.cs, spi/LocationInfo.cs,
	spi/LoggingEvent.cs, spi/RootCategory.cs:

	Fixing code comments
	
2002-03-11 09:39  ncadell

	* log4net.ndoc:

	Added NDOC project file
	
2002-03-03 19:36  ncadell

	* Category.cs, ILog.cs:

	Added IsWarnEnabled, IsErrorEnabled, and IsFatalEnabled properties to 
	the ILog interface and Category implementation.
	
2002-03-03 18:53  ncadell

	* Category.cs:

	Removed unused System.Diagnostics.Conditional attributes
	
2002-02-24 20:35  ncadell

	* MDC.cs, log4net.csproj, Layout/PatternLayout.cs,
	helpers/PatternParser.cs, spi/LoggingEvent.cs:

	Added support for MDC (Mapped Diagnostic Context)
	
	The MDC is similar to the NDC (Nested Diagnostic Context) in that it
	allows additional logging information to be attached to the current 
	thread and then accessed in log calls made (on the same thread) at 
	some time later. Unlike the NDC where single messages are stacked and 
	are either displayed or not displayed the MDC can be used more 
	selectively. It is made up of a map of values, the values that need to
	be seen in the log can be selected from the values that are set.
	
	Added %X{key} pattern to the PatternLayout and PatternParser classes.
	Added method to lookup MDC value on the LoggingEvent.
	
2002-02-24 19:29  ncadell

	* helpers/: AbsoluteTimeDateFormatter.cs, DateTimeDateFormatter.cs,
	ISO8601DateFormatter.cs:

	Improved performance of date formatters. In the 
	AbsoluteTimeDateFormatter the FormatDate() splits responsibility for 
	rendering the date with precision to the nearest second into a separate
	function FormatDataWithoutMillis(). This method is called at most once
	per second, the results being cached for used in other calls during the
	same second. Sub classes can override the FormatDataWithoutMillis() 
	method to supply their own pattern while also benefiting from the 
	performance improvements.
	
2002-02-24 18:08  ncadell

	* NDC.cs:

	Enhanced the NDC class to enable use of the using keyword.
	The Push() method now returns an IDisposable object that
	allows the context stack to be cleaned up automatically
	at the end of the using block.
	
	  using(NDC.Push("my context message"))
	  {
	    ... all log calls will have my message included ...
	  } 
	  // at the end of the using block the message is automatically removed
	
2002-02-18 01:55  ncadell

	* AssemblyInfo.cs, Category.cs, Hierarchy.cs, ILog.cs, NDC.cs,
	Priority.cs, log4net.csproj, Appender/AppenderSkeleton.cs,
	Appender/ConsoleAppender.cs, Appender/CountingAppender.cs,
	Appender/EventLogAppender.cs, Appender/FileAppender.cs,
	Appender/IAppender.cs, Appender/OutputDebugStringAppender.cs,
	Appender/RollingFileAppender.cs, Appender/SMTPAppender.cs,
	Appender/TextWriterAppender.cs, Appender/TraceAppender.cs,
	Config/BasicConfigurator.cs, Config/DOMConfigurator.cs,
	Config/Log4NetConfigurationSectionHandler.cs,
	Filter/DenyAllFilter.cs, Filter/FilterSkeleton.cs,
	Filter/IFilter.cs, Filter/PriorityMatchFilter.cs,
	Filter/PriorityRangeFilter.cs, Filter/StringMatchFilter.cs,
	Layout/ILayout.cs, Layout/LayoutSkeleton.cs,
	Layout/PatternLayout.cs, helpers/AbsoluteTimeDateFormatter.cs,
	helpers/AppenderAttachedImpl.cs,
	helpers/CountingQuietTextWriter.cs, helpers/CyclicBuffer.cs,
	helpers/DateTimeDateFormatter.cs, helpers/FormattingInfo.cs,
	helpers/IDateFormatter.cs, helpers/ISO8601DateFormatter.cs,
	helpers/LogLog.cs, helpers/NullEnumerator.cs,
	helpers/OnlyOnceErrorHandler.cs, helpers/OptionConverter.cs,
	helpers/PatternConverter.cs, helpers/PatternParser.cs,
	helpers/QuietTextWriter.cs, helpers/SimpleDateFormatter.cs,
	spi/CategoryKey.cs, spi/DefaultCategoryFactory.cs,
	spi/IAppenderAttachable.cs, spi/ICategoryFactory.cs,
	spi/IErrorHandler.cs, spi/IOptionHandler.cs,
	spi/ITriggeringEventEvaluator.cs, spi/LocationInfo.cs,
	spi/LoggingEvent.cs, spi/ProvisionNode.cs, spi/RootCategory.cs:

	Fixes
	
	- RollingFileAppender can take a full path (like "C:\\myfile.log") as 
	  the name.
	- DomConfigurator missing return that caused properties to be reported
	  as if they couldn't be set.
	- DomConfigurator using wrong reflected method name to create Category
	  subclasses.
	- Cleaned up all end of line terminators. Now using DOS end of lines 
	  throughout.
	- General clean up of code.
	- Internal logging (LogLog) used System.Diagnostics.Trace as well as 
	  Console.Out.
	
	Additions
	
	- NUnit test cases for Category & RollingFileAppender.
	- CountingAppender for use in NUnit tests.
	- EventLogAppender for logging to the Windows event log.
	- OutputDebugStringAppender for logging to the default debugger.
	- TraceAppender for logging to the System.Diagnostics.Trace.
	
	Many thanks to Douglas de la Torre for all his hard work.
	
2002-02-17 03:00  ncadell

	* ILog.cs:

	Added standard file header
	
2002-02-17 02:55  ncadell

	* Category.cs, Hierarchy.cs, ILog.cs, NDC.cs, Priority.cs,
	Appender/AppenderSkeleton.cs, Appender/ConsoleAppender.cs,
	Appender/FileAppender.cs, Appender/IAppender.cs,
	Appender/RollingFileAppender.cs, Appender/SMTPAppender.cs,
	Appender/TextWriterAppender.cs, Config/BasicConfigurator.cs,
	Config/DOMConfigurator.cs, Filter/DenyAllFilter.cs,
	Filter/FilterSkeleton.cs, Filter/IFilter.cs,
	Filter/PriorityMatchFilter.cs, Filter/PriorityRangeFilter.cs,
	Filter/StringMatchFilter.cs, Layout/ILayout.cs,
	Layout/LayoutSkeleton.cs, Layout/PatternLayout.cs,
	helpers/AbsoluteTimeDateFormatter.cs,
	helpers/AppenderAttachedImpl.cs,
	helpers/CountingQuietTextWriter.cs, helpers/CyclicBuffer.cs,
	helpers/DateTimeDateFormatter.cs, helpers/FormattingInfo.cs,
	helpers/ISO8601DateFormatter.cs, helpers/LogLog.cs,
	helpers/NullEnumerator.cs, helpers/OnlyOnceErrorHandler.cs,
	helpers/OptionConverter.cs, helpers/PatternConverter.cs,
	helpers/PatternParser.cs, helpers/QuietTextWriter.cs,
	spi/CategoryKey.cs, spi/DefaultCategoryFactory.cs,
	spi/IAppenderAttachable.cs, spi/IErrorHandler.cs,
	spi/IOptionHandler.cs, spi/ITriggeringEventEvaluator.cs,
	spi/LocationInfo.cs, spi/LoggingEvent.cs, spi/RootCategory.cs:

	Fixed end of line terminators
	
2002-02-17 02:48  ncadell

	* Config/DOMConfigurator.cs:

	Fixed misspelling of reflected method name when using a specified
	category class name. was looking for getCategory but it should be 
	GetCategory.
	
	Fixed missing return when parsing a property of type enum.
	
2001-11-29 15:43  ncadell

	* Category.cs, spi/DefaultCategoryFactory.cs:

	Fixed class privacy to allow external assemblies to create their own 
	category types
	
2001-10-31 21:11  ncadell

	* log4net.csproj, Appender/FileAppender.cs,
	Appender/RollingFileAppender.cs, Appender/TextWriterAppender.cs,
	Config/DOMConfigurator.cs, helpers/CountingQuietTextWriter.cs,
	helpers/LogLog.cs, helpers/QuietTextWriter.cs, spi/LoggingEvent.cs:

	Added RollingFileAppender. Fixed exception reporting and printing in 
	the text writer
	
	
=============================================================================
Version 1.0.1
=============================================================================
	
	
2001-09-26 20:34  ncadell

	* log4net.csproj, Appender/SMTPAppender.cs,
	Appender/TextWriterAppender.cs, helpers/CyclicBuffer.cs:

	Added support for sending logs via SMTP mail using the SMTPAppender.
	Added better example that actually compiles etc...
	
2001-08-24 15:22  ncadell

	* NDC.cs, log4net.csproj:

	Added Depth property to NDC
	
2001-07-31 13:13  ncadell

	* Category.cs, ILog.cs, Config/DOMConfigurator.cs:

	Minor bug fix for when the config section is not found.
	
2001-07-27 14:39  ncadell

	* AssemblyInfo.cs, Category.cs, Hierarchy.cs, log4net.csproj,
	log4net.sln, NDC.cs, Priority.cs, Appender/AppenderSkeleton.cs,
	Appender/ConsoleAppender.cs, Appender/FileAppender.cs,
	Appender/IAppender.cs, Appender/TextWriterAppender.cs,
	Config/BasicConfigurator.cs, Config/DOMConfigurator.cs,
	Config/Log4NetConfigurationSectionHandler.cs,
	Filter/DenyAllFilter.cs, Filter/FilterSkeleton.cs,
	Filter/IFilter.cs, Filter/PriorityMatchFilter.cs,
	Filter/PriorityRangeFilter.cs, Filter/StringMatchFilter.cs,
	helpers/AbsoluteTimeDateFormatter.cs,
	helpers/AppenderAttachedImpl.cs, helpers/DateTimeDateFormatter.cs,
	helpers/FormattingInfo.cs, helpers/IDateFormatter.cs,
	helpers/ISO8601DateFormatter.cs, helpers/LogLog.cs,
	helpers/NullEnumerator.cs, helpers/OnlyOnceErrorHandler.cs,
	helpers/OptionConverter.cs, helpers/PatternConverter.cs,
	Layout/ILayout.cs, helpers/PatternParser.cs,
	helpers/QuietTextWriter.cs, helpers/SimpleDateFormatter.cs,
	Layout/LayoutSkeleton.cs, Layout/PatternLayout.cs,
	spi/CategoryKey.cs, spi/DefaultCategoryFactory.cs,
	spi/IAppenderAttachable.cs, spi/ICategoryFactory.cs,
	spi/IErrorHandler.cs, spi/IOptionHandler.cs,
	spi/ITriggeringEventEvaluator.cs, spi/LocationInfo.cs,
	spi/LoggingEvent.cs, spi/ProvisionNode.cs, spi/RootCategory.cs:

	Initial revision
	
2001-07-27 14:39  ncadell

	* AssemblyInfo.cs, Category.cs, Hierarchy.cs, log4net.csproj,
	log4net.sln, NDC.cs, Priority.cs, Appender/AppenderSkeleton.cs,
	Appender/ConsoleAppender.cs, Appender/FileAppender.cs,
	Appender/IAppender.cs, Appender/TextWriterAppender.cs,
	Config/BasicConfigurator.cs, Config/DOMConfigurator.cs,
	Config/Log4NetConfigurationSectionHandler.cs,
	Filter/DenyAllFilter.cs, Filter/FilterSkeleton.cs,
	Filter/IFilter.cs, Filter/PriorityMatchFilter.cs,
	Filter/PriorityRangeFilter.cs, Filter/StringMatchFilter.cs,
	helpers/AbsoluteTimeDateFormatter.cs,
	helpers/AppenderAttachedImpl.cs, helpers/DateTimeDateFormatter.cs,
	helpers/FormattingInfo.cs, helpers/IDateFormatter.cs,
	helpers/ISO8601DateFormatter.cs, helpers/LogLog.cs,
	helpers/NullEnumerator.cs, helpers/OnlyOnceErrorHandler.cs,
	helpers/OptionConverter.cs, helpers/PatternConverter.cs,
	Layout/ILayout.cs, helpers/PatternParser.cs,
	helpers/QuietTextWriter.cs, helpers/SimpleDateFormatter.cs,
	Layout/LayoutSkeleton.cs, Layout/PatternLayout.cs,
	spi/CategoryKey.cs, spi/DefaultCategoryFactory.cs,
	spi/IAppenderAttachable.cs, spi/ICategoryFactory.cs,
	spi/IErrorHandler.cs, spi/IOptionHandler.cs,
	spi/ITriggeringEventEvaluator.cs, spi/LocationInfo.cs,
	spi/LoggingEvent.cs, spi/ProvisionNode.cs, spi/RootCategory.cs:

	Initial checkin
	
